<?php
trait WS_Conditional
{
	public function Slot_IsEditMode($SlotIDs, $Html)
	{
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo $Html;
		}
	}

	public function Slot_IsViewMode($SlotIDs, $Html)
	{
		if (!$_SESSION["SLOTS_EDIT_MODE"])
		{
			echo $Html;
		}
	}

	public function Slot_IsSet($SlotIDs, $Html, $ShowInEditMode = true)
	{
		if ($_SESSION["SLOTS_EDIT_MODE"] && (!$ShowInEditMode))
		{
			return;
		}

		$SlotIDArr = explode(",", $SlotIDs);
		foreach ($SlotIDArr as $SlotID)
		{
			$SlotKey = $this->GetSlotKey($SlotID);
			if (array_key_exists($SlotKey, $this->WS_Page->Slots))
			{
				echo $Html;
				break;
			}
		}
	}

	public function Slot_IsNotSet($SlotIDs, $Html, $ShowInEditMode = true)
	{
		if ($_SESSION["SLOTS_EDIT_MODE"] && (!$ShowInEditMode))
		{
			return;
		}

		$SlotIDArr = explode(",", $SlotIDs);
		foreach ($SlotIDArr as $SlotID)
		{
			$SlotKey = $this->GetSlotKey($SlotID);
			if (array_key_exists($SlotKey, $this->WS_Page->Slots))
			{
				echo $SlotKey;
				return;
			}
		}
		echo $Html;
	}
	
}