<?php
trait WS_FreeTemplate
{
	public function Slot_FreeTemplate($SlotID,$Sql="", $TemplateHeader="",$TemplateBody="",$TemplateFooter="", $ConnectionProprety="")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}
		
		$SlotKey = $this->GetSlotKey($SlotID);

		$this->ReadInputSlots($this->WS_Page->PageID, $SlotID,  "TDB");
		
		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Params = array();
			array_push($Params, new WS_ParamDef("Param0", "Header template:", 80, 10, "TXT", null));
			array_push($Params, new WS_ParamDef("Text", "Template body:", 80, 10, "TXT", null));
			array_push($Params, new WS_ParamDef("Param1", "Footer template:", 80, 10, "TXT", null));
			array_push($Params, new WS_ParamDef("Param2", "Sql:", 80, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param3", "CSS Class:", 80, 1, "CLS", null));
			array_push($Params, new WS_ParamDef("Param4", "Rows for page:", 3, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param5", "Connection property:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Link", "Link:", 80, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Update", "Update", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null));
			$this->DrawConfigSlots($this->WS_Page->PageID, $SlotID,  $Params);
		}
		
		$CSS = "";
		$Link = "";
		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $this->WS_Page->Slots[$SlotKey];
			$TemplateBody = $Slot->Text;
			$TemplateHeader = $Slot->Param[0];
			$TemplateFooter = $Slot->Param[1];
			$Sql = $Slot->Param[2];
			$CSS = $Slot->Param[3];
			$RowsForPage = intval($Slot->Param[4]);
			$ConnectionProprety = $Slot->Param[5];
			$Link = $Slot->Link;
		}
		
		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver\">";
			echo $this->DrawEditButton($SlotKey, "Text", "Edit Template", "ws_btnedit-t ws_absolute",  $TemplateBody);
		}
	
		$DB=null;
		$Tab=null;
		$KeysH = array();
		$Keys = array();
		$KeysF = array();
		if ($Sql!="")
		{
			// CONNECT THE DB
			$DB = $WS->GetDbConnectFromProperties($ConnectionProprety);
			
			// GET TEMPLATE KEYS
			$KeysH =  WS::GetElementFromString($TemplateHeader,"<@","@>");
			$Keys =  WS::GetElementFromString($TemplateBody,"<@","@>");
			$KeysF =  WS::GetElementFromString($TemplateFooter,"<@","@>");
			
			$this->FreeTemplate_InitVar($KeysH);
			$this->FreeTemplate_InitVar($Keys);
			$this->FreeTemplate_InitVar($KeysF)
					;
			// UPDATER
			$RC = filter_input(INPUT_POST, $SlotKey."_RowCount");
			if (isset($RC))
			{
				$RC=intval($RC);
				$this->FreeTemplate_UpdateRow($SlotKey."_H",$DB,"",0,$KeysH);

				for ($RowCount=0;$RowCount<$RC;$RowCount++)
				{
					$this->FreeTemplate_UpdateRow($SlotKey,$DB,"",$RowCount,$Keys);
				}

				$this->FreeTemplate_UpdateRow($SlotKey."_F",$DB,"",0,$KeysF);
			}
		

				
			foreach (array_keys($this->FreeTemplate_ReadVars()) as $Var)
			{
				$Sql = str_replace("@".$Var, $this->FreeTemplate_ReadVar($Var), $Sql);
			}
			
			// PAGER MANAGER
			if (($RowsForPage>0))
			{
				$result = $DB->query($Sql);
				if ((isset($result->num_rows))&&($result->num_rows>0))
				{
					$RowCountTotal = $result->num_rows;
					$TotalPages = ceil($RowCountTotal / $RowsForPage);

					// GET AND SET CURRENT PAGE
					$CurrentPage = filter_input(INPUT_POST, $SlotKey."_CurrentPage");
					if (!isset($CurrentPage)){$CurrentPage=1;}
					$Start = filter_input(INPUT_POST, $SlotKey."_Start");
					$End = filter_input(INPUT_POST, $SlotKey."_End");
					$Next = filter_input(INPUT_POST, $SlotKey."_Next");
					$Prev =	filter_input(INPUT_POST, $SlotKey."_Prev");
					if (isset($Start)){$CurrentPage=1;}
					if (isset($End)){$CurrentPage=$TotalPages;}
					if (isset($Prev)){$CurrentPage--;}
					if (isset($Next)){$CurrentPage++;}
					if($CurrentPage<1){$CurrentPage=1;}
					if($CurrentPage>$TotalPages){$CurrentPage=$TotalPages;}

					if ($RowsForPage>0) {$Sql .= " limit ".$RowsForPage * ($CurrentPage-1).",".$RowsForPage;}
					if(isset($Tab)){echo "<input name=\"".$SlotKey."_CurrentPage\" type=\"hidden\" value=\"".$CurrentPage."\" >";}
				}
			}
			
			$Tab= new DbEntity_Table($DB);
			$Tab->Query($Sql);
			$RowCount = $Tab->GetRowCount();
		}
		
		// SLOT DRAWER
		$this->FreeTemplate_DrawRow($SlotKey."_H",$DB,$Tab,0,$TemplateHeader,$KeysH);

		if(isset($Tab)){echo "<input name=\"".$SlotKey."_RowCount\" type=\"hidden\" value=\"".$Tab->GetRowCount()."\" >";}
		$RC=1;
		if(isset($Tab)){$RC=$Tab->GetRowCount();}
		for ($RowCount=0;$RowCount<$RC;$RowCount++)
		{
			$this->FreeTemplate_DrawRow($SlotKey,$DB,$Tab,$RowCount,$TemplateBody,$Keys);
		}

		$this->FreeTemplate_DrawRow($SlotKey."_F",$DB,$Tab,0,$TemplateFooter,$KeysF);
			
		if (($Sql!="")&&(intval($RowsForPage)>0)&&(isset($result->num_rows))&&($result->num_rows>0))
		{
			echo "<input name=\"".$SlotKey."_CurrentPage\" type=\"hidden\" value=\"".$CurrentPage."\" >";
			echo "<div class=\"ws_central ws_table\" style=\"width:200px\"><div class=\"ws_center ws_row\">";
			echo "<div class=\"ws_cell\"><input class=\"ws_button\" name=\"".$SlotKey."_Start\" type=\"submit\" value=\"|<\"/>&nbsp;</div>";
			echo "<div class=\"ws_cell\"><input class=\"ws_button\" name=\"".$SlotKey."_Prev\" type=\"submit\" value=\"<\"/></div>";
			echo "&nbsp;&nbsp;".$CurrentPage."/".$TotalPages."&nbsp;&nbsp;";
			echo "<div class=\"ws_cell\"><input class=\"ws_button\" name=\"".$SlotKey."_Next\" type=\"submit\" value=\">\"/>&nbsp;</div>";
			echo "<div class=\"ws_cell\"><input class=\"ws_button\" name=\"".$SlotKey."_End\" type=\"submit\" value=\">|\"/></div>";
			echo "</div></div>";
		}
		
		// EDIT MODE CLOSE
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
		
	}
	
	private function FreeTemplate_InitVar($Keys)
	{
		if (!isset($_SESSION["WS_USER_VARIABLES"])) {$_SESSION["WS_USER_VARIABLES"]=array();}
		foreach ($Keys as $Key)
		{
			$Key = $this->FreeTemplate_ClearKey($Key);
			$Props=$this->FreeTemplate_GetProperties($Key);
				if (array_key_exists("var",$Props) )
				{
					if (!array_key_exists($Props["var"],$_SESSION["WS_USER_VARIABLES"])) 
					{
						$_SESSION["WS_USER_VARIABLES"][$Props["var"]] ="";
					}
				}
			
		}
	}
	
	private function FreeTemplate_UpdateRow($SlotKey,$DB,$Tab,$RowCount,$Keys)
	{
		foreach ($Keys as $Key)
		{
			$Key = $this->FreeTemplate_ClearKey($Key);
			$Tag= $this->FreeTemplate_GetTag($Key);
			$Prop= $this->FreeTemplate_GetProperties($Key);
			
			switch($Tag)
			{
				case "input-number":
				case "input-date":
				case "input":

					// DB BINDING
					if (array_key_exists("bind", $Prop)) 
					{
						$PostName = $SlotKey."_".$RowCount."_".$Prop["bind"];
						$BindName = $SlotKey."_".$RowCount."_".$Prop["bind"]."_bind";
						$Value = filter_input(INPUT_POST, $PostName);
						$BindData = filter_input(INPUT_POST, $BindName);
						if (isset($Value)&&isset($BindData))
						{
							$BindData = base64_decode($BindData);
							$BindData = explode(";",$BindData);
							if (($BindData[0]!="")&&($BindData[1]!=""))
							{
								$Sql = "select * from ".$BindData[0]." where ".$BindData[1];
								$DE = new DbEntity_Table($DB);
								$DE->Query($Sql);
								$R = $DE->GetRow(0);
								if($Tag=="input-date")
								{
									$D = DateTime::createFromFormat('d/m/Y',$Value);
									$Value = $D->format('Y-m-d H:i:s');
								}
								if ($R->GetValue($Prop["bind"]) != $Value)
								{
									$R->SetValue($Prop["bind"],$Value);
									$R->Update();
								}
							}
						}
					}

					// VARIABLE
					if (array_key_exists("var", $Prop)) 
					{
						$PostName = $SlotKey."_".$RowCount."_".$Prop["var"];
						$Value = filter_input(INPUT_POST, $PostName);
						if (isset($Value))
						{
							$this->FreeTemplate_WriteVar($Prop["var"],$Value);
						}
					}
					
					break;

				
				default:
					break ;
			}
		}
	}
	
	private function FreeTemplate_DrawRow($SlotKey,$DB,$Tab,$RowCount,$Template,$Keys)
	{
		global $WS;
		$Row=null;
		if(isset($Tab)) {$Row = $Tab->GetRow($RowCount);}
		
		foreach ($Keys as $Key)
		{
			$Key = $this->FreeTemplate_ClearKey($Key);
			$Tag= $this->FreeTemplate_GetTag($Key);
			$Prop= $this->FreeTemplate_GetProperties($Key);
			$Val="";
			$Name = " name=\"".$SlotKey."_".$RowCount."\" ";
			$DataName = " name=\"".$SlotKey."_".$RowCount."_bind\" ";
			$Table = "";
			$Where = "";
			switch($Tag)
			{
				case "setvar":
					if (!array_key_exists("name", $Prop)) return;
					$Name = $Row->GetValue($Prop["name"]);
				
					if (array_key_exists("bing", $Prop)){$Value = FreeTemplate_GetBind($Prop,$Row);}
					if (array_key_exists("var", $Prop)){$Value = FreeTemplate_ReadVar($Prop["var"]);}
					if (array_key_exists("value", $Prop)){$Value = $Prop["Value"];}

					FreeTemplate_WriteVar($Name,$Value);
					break;
					
				case "label":
					if (array_key_exists("bind", $Prop)&&isset($Row)) {$Val = $Row->GetValue($Prop["bind"]);}
					if (array_key_exists("var", $Prop)) {$Val =  $Prop["var"];}
					if (array_key_exists("value", $Prop)) {$Val = $Prop["value"];}
					
					$Val = str_replace("\n", "<br/>", $Val);
					$Val = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;", $Val);
					$Template = str_replace("<@".$Key."@>", $Val, $Template);
					break;
					
				case "input":
					if (array_key_exists("bind", $Prop)&&isset($Row)) 
					{
						$Table = $Row->GetTableName($Prop["bind"]);
						$Where = $Row->BuildKeyWherePart($Table);
						$Val = $Row->GetValue($Prop["bind"]);
						$Name = " name=\"".$SlotKey."_".$RowCount."_".$Prop["bind"]."\" ";
						$DataName = " name=\"".$SlotKey."_".$RowCount."_".$Prop["bind"]."_bind\" ";
					}
					else
					{
						if (array_key_exists("var", $Prop)) 
						{
							$Val = $this->FreeTemplate_ReadVar($Prop["var"]);
							$Name = " name=\"".$SlotKey."_".$RowCount."_".$Prop["var"]."\" ";
						}
					}
					if (array_key_exists("value", $Prop)) {$Val = $Prop["value"];}
					
					$Par="";
					if (array_key_exists("size", $Prop)) {$Par .= " size=\"".$Prop["size"]."\" maxlength=\"".$Prop["size"]."\" ";}
					
					if (array_key_exists("rows", $Prop) && array_key_exists("size", $Prop)) 
					{
						$Value =  "<textarea ".$Par.$Name." value=\"\" rows=\"".$Prop["rows"]."\" cols=\"".$Prop["size"]."\"/>".$Val."</textarea>";
					}
					else
					{
						$Value =  "<input ".$Par.$Name." type=\"text\" value=\"".$Val."\" />";
					}
					if (array_key_exists("bind", $Prop)){$Value .= "<input ".$DataName." type=\"hidden\" value=\"".base64_encode($Table.";".$Where)."\" >";}
					$Template = str_replace("<@".$Key."@>", $Value, $Template);
					break;
					
				case "input-date":
					if (array_key_exists("bind", $Prop)&&isset($Row)) 
					{
						$Table = $Row->GetTableName($Prop["bind"]);
						$Where = $Row->BuildKeyWherePart($Table);
						$Val = $Row->GetValue($Prop["bind"]);
						$Name = " name=\"".$SlotKey."_".$RowCount."_".$Prop["bind"]."\" ";
						$DataName = " name=\"".$SlotKey."_".$RowCount."_".$Prop["bind"]."_bind\" "; 
					}
					else
					{
						if (array_key_exists("var", $Prop)) 
						{
							$Val =  $Prop["var"];
							$Name = " name=\"".$SlotKey."_".$RowCount."_".$Prop["var"]."\" ";
						}
					}
					if (array_key_exists("value", $Prop)) {$Val = $Prop["value"];}
					
					$D = strtotime($Val);
					
					$Value = "<input type=\"text\" ".$Name." id=\"".$SlotKey."_".$RowCount."_".$Prop["bind"]."\" size=\"10\" value=\"".date('d/m/Y',$D)."\" >";
					$Value .= "<script>$( \"#".$SlotKey."_".$RowCount."_".$Prop["bind"]."\").datepicker({changeMonth: true,changeYear: true, showButtonPanel: true,dateFormat:'dd/mm/yy'});</script>"; 
					if (array_key_exists("bind", $Prop)){$Value .= "<input ".$DataName." type=\"hidden\" value=\"".base64_encode($Table.";".$Where)."\" >";}
					$Template = str_replace("<@".$Key."@>", $Value, $Template);
					break;
				
				case "input-number":
					if (array_key_exists("bind", $Prop)&&isset($Row)) 
					{
						$Table = $Row->GetTableName($Prop["bind"]);
						$Where = $Row->BuildKeyWherePart($Table);
						$Val = $Row->GetValue($Prop["bind"]);
						$Name = " name=\"".$SlotKey."_".$RowCount."_".$Prop["bind"]."\" ";
						$DataName = " name=\"".$SlotKey."_".$RowCount."_".$Prop["bind"]."_bind\" ";
					}
					else
					{
						if (array_key_exists("var", $Prop)) 
						{
							$Val =  $Prop["var"];
							$Name = " name=\"".$SlotKey."_".$RowCount."_".$Prop["var"]."\" ";
						}
					}
					if (array_key_exists("value", $Prop)) {$Val = $Prop["value"];}
					
					$Par="";
					if (array_key_exists("size", $Prop)) {$Par .= " size=\"".$Prop["size"]."\" maxlength=\"".$Prop["size"]."\" ";}
					$Value =  "<input ".$Par.$Name." type=\"number\" value=\"".$Val."\" />";
					if (array_key_exists("bind", $Prop)){$Value .= "<input ".$DataName." type=\"hidden\" value=\"".base64_encode($Table.";".$Where)."\" >";}
					$Template = str_replace("<@".$Key."@>", $Value, $Template);
					break;

				case "translate":
					$Value="";
					if (array_key_exists("text", $Prop)){$Value = $WS->GetTranslation($Prop["text"]);}
					$Template = str_replace("<@".$Key."@>", $Value, $Template);
					break;
				default:
					break ;
			}
			
		}
		echo $Template;
	}
	
	private function FreeTemplate_ClearKey($Key)
	{
		return substr(substr($Key,0,strlen($Key)-2),2);
	}
	
	private function FreeTemplate_GetTag($Key)
	{
		$Param = explode(" ",$Key);
		return $Param[0];
	}
	
	private function FreeTemplate_GetProperties($Key)
	{
		$Tag = $this->EmailTemplate_GetTag($Key);
		$Key = trim(substr($Key,strlen($Tag)));
		
		$Properties = array();
		while (strpos($Key,'=') !== false)
		{
			$Name = trim(substr($Key,0, strpos($Key,"=")));
			$Key = substr($Key,strpos($Key,"\"")+1);
			$Value =  substr($Key,0,strpos($Key,"\""));
			$Key = trim(substr($Key,strpos($Key,"\"")+1));
			$Properties[strtolower($Name)] = $Value;
		}
		
		return $Properties;
	}
	
	private function FreeTemplate_GetVar($Prop)
	{
		if (!array_key_exists("var", $Prop)) {$Val =  $Prop["var"];}
	}
	
	private function FreeTemplate_WriteVar($Name,$Value)
	{
		if(!isset($_SESSION["WS_USER_VARIABLES"])) {$_SESSION["WS_USER_VARIABLES"] = array();}
		$_SESSION["WS_USER_VARIABLES"][$Name]=$Value;
	}
	
	private function FreeTemplate_ReadVar($Name)
	{
		if(!isset($_SESSION["WS_USER_VARIABLES"])) return "";
		if (!array_key_exists($Name, $_SESSION["WS_USER_VARIABLES"])) {return "";}
		return $_SESSION["WS_USER_VARIABLES"][$Name];
	}
	
	private function FreeTemplate_ReadVars()
	{
	if (!isset($_SESSION["WS_USER_VARIABLES"])) {$_SESSION["WS_USER_VARIABLES"]=array();}
		return $_SESSION["WS_USER_VARIABLES"];
	}
}

?>