<?php
trait WS_Image_Video
{
	public function Slot_ImageTitle($SlotID, $Width = "", $Height = "", $Text = "", $TextVAlign = "bottom", $OverEffect = "", $ImgResize = "Strech")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$RowOffset = 0;

		$Img = "";  // LOAD FROM DB 
		$Link = "";
		$UserWidth = "";
		$UserHeight = "";
		$SlotKey = $WS->GetHeaderSlotKey($SlotID);

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			if (filter_input(INPUT_POST, "Clr_" . $SlotKey))
			{
				$WS->SlotDelete(0, 0, $SlotID, 0);
				$WS->LoadSlots();
			}

			if (filter_input(INPUT_POST, "Set_" . $SlotKey))
			{
				$Params = $WS->InitParamsArray();
				$Params[0] = filter_input(INPUT_POST, "img_" . $SlotKey);
				$Link = filter_input(INPUT_POST, "WS_IN_txtLink_" . $SlotKey);
				$Params[1] = filter_input(INPUT_POST, "WS_IN_txtWidth_" . $SlotKey);
				$Params[2] = filter_input(INPUT_POST, "WS_IN_txtHeight_" . $SlotKey);
				$Params[3] = filter_input(INPUT_POST, "WS_IN_TextAlign_" . $SlotKey);
				$Params[4] = filter_input(INPUT_POST, "WS_IN_OverEffect_" . $SlotKey);
				$Params[5] = filter_input(INPUT_POST, "WS_IN_Hover_" . $SlotKey);
				$Params[6] = filter_input(INPUT_POST, "WS_IN_Resize_" . $SlotKey);
				$Params[7] = filter_input(INPUT_POST, "WS_IN_CssClass_" . $SlotKey);
				$Text = filter_input(INPUT_POST, "WS_IN_Text_" . $SlotKey);
				$WS->SlotUpdate(0, $SlotID, $Text, $Params, $Link, "IMG");
				$WS->LoadSlots();
			}
		}

		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Img = $WS->WS_Page->Slots[$SlotKey]->Param[0];
			$UserWidth = $WS->WS_Page->Slots[$SlotKey]->Param[1];
			$UserHeight = $WS->WS_Page->Slots[$SlotKey]->Param[2];
			$TextVAlign = $WS->WS_Page->Slots[$SlotKey]->Param[3];
			$OverEffect = $WS->WS_Page->Slots[$SlotKey]->Param[4];
			$ImgHover = $WS->WS_Page->Slots[$SlotKey]->Param[5];
			$ImgResize = $WS->WS_Page->Slots[$SlotKey]->Param[6];
			$CssClass = $WS->WS_Page->Slots[$SlotKey]->Param[7];
			$Link = $WS->WS_Page->Slots[$SlotKey]->Link;
			$Text = $WS->WS_Page->Slots[$SlotKey]->Text;
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey) || filter_input(INPUT_POST, "btnSearch_" . $SlotKey))
		{
			$Pop = "</br>&nbsp;&nbsp;<input name=\"txtSearch_" . $SlotKey . "\" type=\"text\" value=\"\" size=\"40\"/>";
			$Pop .= "<input class=\"ws_button\" name=\"btnSearch_" . $SlotKey . "\" type=\"submit\" value=\"Search\"/></br></br>";
			$Pop .= "<div style=\"overflow-x:scroll;width:95%;border:solid 1px #444444;margin:auto\">";
			$Pop .= "<table><tr>";

			$MediaDir = WS::GetMediaNames();
			if (count($MediaDir) == 0)
			{
				$Pop .= "<td>No Midia Loaded.</td>";
			}
			else
			{
				foreach ($MediaDir as $Entry)
				{
					if ((!isset($_POST["txtSearch_" . $SlotKey])) || ($_POST["txtSearch_" . $SlotKey] == "") || (strpos($Entry, $_POST["txtSearch_" . $SlotKey]) !== false))
					{
						$Pop .= "<td style=\"border: 1px solid #444444\">";

						$imageFileType = pathinfo($Entry, PATHINFO_EXTENSION);
						if (($imageFileType == "jpg") || ($imageFileType == "gif") || ($imageFileType == "png") || ($imageFileType == "bmp"))
						{
							$Pop .= "<div style=\"float:left;background-image:url(../Media/" . $Entry . ");background-repeat:no-repeat; background-size:contain;width:80px;height:50px\"></div>";
						}

						$Pop .= "<div style=\"float:right;vertical-align:top\"></div>";
						//$Pop .=  "<input type=\"hidden\" name=\"hide_".$SlotKey."_" . str_replace(".","_",$Entry) . "\" value=\"" . $Entry . "\">";
						$Pop .= "<br/><br/><br/><div style\";font-size:9px;color:#444444\">" . $Entry . "</br></br>";
						$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Image\" title=\"Set Image\" onclick=\"$('#img_" . $SlotKey . "').val('" . $Entry . "')\"></div>";
						$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Over\" title=\"Set Hover\" onclick=\"$('#hover_" . $SlotKey . "').val('" . $Entry . "')\"></div>";
						$Pop .= "</td><td>&nbsp;&nbsp;&nbsp;</td>";
					}
				}
			}

			$Pop .= "</tr></table>";
			$Pop .= "</div><br/>";
			$Pop .= "<table  style=\"margin-left:20px\">";
			$Pop .= "<tr><td>Image:</td><td><input type=\"text\" id=\"img_" . $SlotKey . "\" name=\"img_" . $SlotKey . "\" value=\"" . $Img . "\" size=\"25\"></td></tr>";
			$Pop .= "<tr><td>Over Image:</td><td><input type=\"text\" id=\"hover_" . $SlotKey . "\" name=\"WS_IN_Hover_" . $SlotKey . "\" value=\"" . $ImgHover . "\" size=\"25\"></td></tr>";
			$Pop .= "<tr><td>Override Text:</td><td><input name=\"WS_IN_Text_" . $SlotKey . "\" type=\"text\" value=\"" . $Text . "\" size=\"50\"/></td></tr>";
			$Pop .= "<tr><td>Text Align:</td><td><input name=\"WS_IN_TextAlign_" . $SlotKey . "\" type=\"text\" value=\"" . $TextVAlign . "\" size=\"10\"/></td></tr>";
			$Pop .= "<tr><td>Width:</td><td><input name=\"WS_IN_txtWidth_" . $SlotKey . "\" type=\"text\" value=\"" . $UserWidth . "\" size=\"10\"/></td></tr>";
			$Pop .= "<tr><td>Height:</td><td><input name=\"WS_IN_txtHeight_" . $SlotKey . "\" type=\"text\" value=\"" . $UserHeight . "\" size=\"10\"/></td></tr>";

			$Pop .= "<tr><td>Over Effect:</td><td><select id=\"WS_IN_OverEffect_" . $SlotKey . "\" name=\"WS_IN_OverEffect_" . $SlotKey . "\">";
			$Pop .= "<option value=\"\">None</option>";
			$Pop .= "<option value=\"ws_jamp_up\">Jamp Up</option>";
			$Pop .= "<option value=\"ws_tilt\">Tilt</option>";
			$Pop .= "<option value=\"ws_red_shadow\">Red Shadow</option>";
			$Pop .= "<option value=\"ws_green_shadow\">Green Shadow</option>";
			$Pop .= "<option value=\"ws_blue_shadow\">Blue Shadow</option>";
			$Pop .= "<option value=\"ws_orange_shadow\">Orange Shadow</option>";
			$Pop .= "<option value=\"ws_gray_shadow\">Gray_Shadow</option>";
			$Pop .= "<option value=\"ws_highlight\">Highlight</option>";
			$Pop .= "<option value=\"ws_rotate_Y\">Rotate Y</option>";
			$Pop .= "<option value=\"ws_rotate_Z\">Rotate Z</option>";
			$Pop .= "<option value=\"ws_gray_scale\">Gray Scale</option>";
			$Pop .= "</select>";
			$Pop .= "<script>document.getElementById('WS_IN_OverEffect_" . $SlotKey . "').value='" . $OverEffect . "';</script>";
			$Pop .= "</td></tr>";

			$Pop .= "<tr><td>Resize:</td><td><select id=\"WS_IN_Resize_" . $SlotKey . "\" name=\"WS_IN_Resize_" . $SlotKey . "\" >";
			$Pop .= "<option value=\"\"></option>";
			$Pop .= "<option value=\"Strech\">Strech</option>";
			$Pop .= "<option value=\"Cover\">Cover</option>";
			$Pop .= "<option value=\"Contain\">Contain</option>";
			$Pop .= "<option value=\"100% auto\">Resize to width</option>";
			$Pop .= "<option value=\"auto 100%\">Resize to height</option>";
			$Pop .= "<option value=\"auto auto\">No resize</option>";
			$Pop .= "</select>";
			$Pop .= "<script>document.getElementById('WS_IN_Resize_" . $SlotKey . "').value='" . $ImgResize . "';</script>";
			$Pop .= "</td></tr>";

			$Pop .= "<tr><td>Link:</td><td><input name=\"WS_IN_txtLink_" . $SlotKey . "\" type=\"text\" value=\"" . $Link . "\" size=\"50\"/></td></tr>";
			$Pop .= "<tr><td>Css class:</td><td><input id=\"WS_IN_CssClass_" . $SlotKey . "\" name=\"WS_IN_CssClass_" . $SlotKey . "\" type=\"text\" value=\"" . $CssClass . "\" size=\"50\"/>";
			$Pop .= $this->DrawClassesComboBox("WS_IN_Param_" . $SlotKey );
			$Pop .= "</td></tr>";
			$Pop .= "</table><br/>";
			
			$Pop .= "<div style=\"position:relative;margin:auto;width:250px;display:block\">";
			$Pop .= "<input class=\"ws_button\" name=\"Set_" . $SlotKey . "\" type=\"submit\" value=\"&nbsp;&nbsp;Set&nbsp;&nbsp;\" style=\"padding:3px\" />&nbsp;";
			$Pop .= "<input class=\"ws_button\" name=\"Clr_" . $SlotKey . "\" type=\"submit\" value=\"Clear\" style=\"padding:3px\" />&nbsp;";
			$Pop .= "<input class=\"ws_button\" name=\"Can_" . $SlotKey . "\" type=\"submit\" value=\"Cancel\" style=\"padding:3px\" /><br/><br/>";
			$Pop .= "</div>";
			$WS->SetPopup($Pop, "95%", "600px");
		}

		$SWidth = "width:30px";
		$SHeight = "height:30px";
		$MWidth = "";
		$MHeight = "";
		$SImgResize = "";
		if ($Img != "")
		{
			if (file_exists(WS::$WSBase->Root . "/Media/" . $Img))
			{
				$Size = getimagesize(WS::$WSBase->Root . "/Media/" . $Img);
				$SWidth = "width:" . $Size[0] . "px;";
				$SHeight = "height:" . $Size[1] . "px;";

				if (($Width != "") && ($Height == ""))
				{
					$MHeight = intval($Width) * $Size[0] / $Size[1] . "px";
				}

				if (($Height != "") && ($Width == ""))
				{
					$MWidth = intval($Height) * $Size[0] / $Size[1] . "px";
				}
			}
		}
		if ($MWidth != "")
		{
			$SWidth = "width:" . $MWidth . ";";
		}
		if ($MHeight != "")
		{
			$SHeight = "height:" . $MHeight . ";";
		}
		if ($Width != "")
		{
			$SWidth = "width:" . $Width . ";";
		}
		if ($Height != "")
		{
			$SHeight = "height:" . $Height . ";";
		}
		if ($UserWidth != "")
		{
			$SWidth = "width:" . $UserWidth . ";";
		}
		if ($UserHeight != "")
		{
			$SHeight = "height:" . $UserHeight . ";";
		}
		if ($ImgResize != "")
		{
			if ($ImgResize=="Strech"){$ImgResize="100% 100%";}
			$SImgResize = "background-size:" . strtolower ($ImgResize) . ";";
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver;" . $SWidth . $SHeight . "\">";
			echo $WS->DrawEditButton($SlotKey, "Img", "Set Image", "ws_btnedit-im ws_absolute",  $Img);
		}

		if ($Img != "")
		{
			$CEffect = "";
			$Target = "";
			if ((strpos($Link, "http://") !== false) || (strpos($Link, "https://") !== false))
			{
				$Target = " target=\"_blank\"";
			}
			if ($Link != "")
				echo "<a " . $Target . " href=\"" . $Link . "\">";
			echo "<style>";
			echo " .cls_" . $SlotKey . "{" . $SWidth . $SHeight . $SImgResize . ";background-image:url(../Media/" . $Img . ")}";
			if ($ImgHover != "")
			{
				echo ".cls_" . $SlotKey . ":hover{background-image:url(../Media/" . $ImgHover . ");}";
			}
			echo "</style>";
			echo "<div class=\"ws_imgToDiv " . $CssClass ." ". $OverEffect . " cls_" . $SlotKey . "\">";
			if ($Text != "")
			{
				$VAlign = "bottom";
				if ($TextVAlign != "")
				{
					$VAlign = $TextVAlign;
				}
				echo "<div style=\"position:relative;vertical-align:" . $VAlign . ";background-color:rgba(0,0,0,.7);color:white\"></div>";
			}
			echo "</div>";
			if ($Link != "")
				echo "</a>";
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
	
	public function Slot_Image($SlotID, $Width = "", $Height = "", $Text = "", $TextVAlign = "bottom", $OverEffect = "", $ImgResize = "Strech")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $WS->GetSlotKey($SlotID);
		$Img = "";  // LOAD FROM DB 
		$ImgHover = "";
		$Link = "";
		$UserWidth = "";
		$UserHeight = "";
		$CssClass  ="";
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			if (filter_input(INPUT_POST, "Clr_" . $SlotKey))
			{
				$Slot=$WS->WS_Page->Slots[$SlotKey];
				$WS->SlotDelete($Slot->PageID, $Slot->BodyID, $Slot->SlotID);
				$WS->LoadSlots();
			}

			if (filter_input(INPUT_POST, "Set_" . $SlotKey))
			{
				$Params = $WS->InitParamsArray();
				$Params[0] = filter_input(INPUT_POST, "img_" . $SlotKey);
				$Link = filter_input(INPUT_POST, "WS_IN_txtLink_" . $SlotKey);
				$Params[1] = filter_input(INPUT_POST, "WS_IN_txtWidth_" . $SlotKey);
				$Params[2] = filter_input(INPUT_POST, "WS_IN_txtHeight_" . $SlotKey);
				$Params[3] = filter_input(INPUT_POST, "WS_IN_TextAlign_" . $SlotKey);
				$Params[4] = filter_input(INPUT_POST, "WS_IN_OverEffect_" . $SlotKey);
				$Params[5] = filter_input(INPUT_POST, "WS_Img_Hover_" . $SlotKey);
				$Params[6] = filter_input(INPUT_POST, "WS_IN_Resize_" . $SlotKey);
				$Params[7] = filter_input(INPUT_POST, "WS_IN_CssClass_" . $SlotKey);
				$Text = filter_input(INPUT_POST, "WS_IN_Text_" . $SlotKey);
				$WS->SlotUpdate($WS->WS_Page->PageID, $SlotID, $Text, $Params, $Link, "IMG");
				$WS->LoadSlots();
			}

			$MediaDir = WS::GetMediaNames();
			$MediaDirPage = WS::GetMediaNames($WS->WS_Page);
		}

		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Img = $WS->WS_Page->Slots[$SlotKey]->Param[0];
			$UserWidth = $WS->WS_Page->Slots[$SlotKey]->Param[1];
			$UserHeight = $WS->WS_Page->Slots[$SlotKey]->Param[2];
			$TextVAlign = $WS->WS_Page->Slots[$SlotKey]->Param[3];
			$OverEffect = $WS->WS_Page->Slots[$SlotKey]->Param[4];
			$ImgHover = $WS->WS_Page->Slots[$SlotKey]->Param[5];
			if ($WS->WS_Page->Slots[$SlotKey]->Param[6] != "")$ImgResize = $WS->WS_Page->Slots[$SlotKey]->Param[6];
			$CssClass = $WS->WS_Page->Slots[$SlotKey]->Param[7];
			$Link = $WS->WS_Page->Slots[$SlotKey]->Link;
			$Text = $WS->WS_Page->Slots[$SlotKey]->Text;
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey) || filter_input(INPUT_POST, "btnSearch_" . $SlotKey))
		{
			$Pop = "</br>&nbsp;&nbsp;<input name=\"txtSearch_" . $SlotKey . "\" type=\"text\" value=\"\" size=\"40\"/>";
			$Pop .= "<input class=\"ws_button\" name=\"btnSearch_" . $SlotKey . "\" type=\"submit\" value=\"Search\"/></br></br>";
			$Pop .= "<div style=\"overflow-x:scroll;width:95%;border:solid 1px #444444;margin:auto\">";
			$Pop .= "<table><tr>";

			if (count($MediaDir) == 0)
			{
				$Pop .= "<td>No Midia Loaded.</td>";
			}
			else
			{
				foreach ($MediaDir as $Entry)
				{
					if ((!isset($_POST["txtSearch_" . $SlotKey])) || ($_POST["txtSearch_" . $SlotKey] == "") || (strpos($Entry, $_POST["txtSearch_" . $SlotKey]) !== false))
					{
						$Pop .= "<td style=\"border: 1px solid #444444\">";

						$imageFileType = pathinfo($Entry, PATHINFO_EXTENSION);
						if (($imageFileType == "jpg") || ($imageFileType == "gif") || ($imageFileType == "png") || ($imageFileType == "bmp"))
						{
							$Pop .= "<div style=\"float:left;background-image:url(../Media/" . $Entry . ");background-repeat:no-repeat; background-size:contain;width:80px;height:50px\"></div>";
						}

						$Pop .= "<div style=\"float:right;vertical-align:top\"></div>";
						//$Pop .=  "<input type=\"hidden\" name=\"hide_".$SlotKey."_" . str_replace(".","_",$Entry) . "\" value=\"" . $Entry . "\">";
						$Pop .= "<br/><br/><br/><div style\";font-size:9px;color:#444444\">" . $Entry . "</br></br>";
						$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Image\" title=\"Set Image\" onclick=\"$('#img_" . $SlotKey . "').val('" . $Entry . "')\"></div>";
						$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Over\" title=\"Set Hover\" onclick=\"$('#hover_" . $SlotKey . "').val('" . $Entry . "')\"></div>";
						$Pop .= "</td><td>&nbsp;&nbsp;&nbsp;</td>";
					}
				}

				foreach ($MediaDirPage as $Entry)
				{
					if ((!isset($_POST["txtSearch_" . $SlotKey])) || ($_POST["txtSearch_" . $SlotKey] == "") || (strpos($Entry, $_POST["txtSearch_" . $SlotKey]) !== false))
					{
						$Pop .= "<td style=\"border: 1px solid #444444\">";

						$imageFileType = pathinfo($Entry, PATHINFO_EXTENSION);
						if (($imageFileType == "jpg") || ($imageFileType == "gif") || ($imageFileType == "png") || ($imageFileType == "bmp"))
						{
							$Pop .= "<div style=\"float:left;background-image:url(../Media/" . $WS->WS_Page->Name . "/" . $Entry . ");background-repeat:no-repeat; background-size:contain;width:80px;height:50px\"></div>";
						}

						$Pop .= "<div style=\"float:right;vertical-align:top\"></div>";
						//$Pop .=  "<input type=\"hidden\" name=\"hide_".$SlotKey."_".$WS->WS_Page->Name."_". str_replace(".","_",$Entry) . "\" value=\"" .$WS->WS_Page->Name."/".$Entry . "\">";
						$Pop .= "<br/><br/><br/><div style\";font-size:9px;color:#444444\">" . $WS->WS_Page->Name . "/" . $Entry . "</br></br>";
						$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Image\" title=\"Set Image\" onclick=\"$('#img_" . $SlotKey . "').val('" . $WS->WS_Page->Name . "/" . $Entry . "')\"></div>";
						$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Over\" title=\"Set Hover\" onclick=\"$('#hover_" . $SlotKey . "').val('" . $WS->WS_Page->Name . "/" . $Entry . "')\"></div>";
						$Pop .= "</td><td>&nbsp;&nbsp;&nbsp;</td>";
					}
				}
			}

			$Pop .= "</tr></table>";
			$Pop .= "</div><br/>";
			$Pop .= "<table  style=\"margin-left:20px\">";
			$Pop .= "<tr><td>Image:</td><td><input type=\"text\" id=\"img_" . $SlotKey . "\" name=\"img_" . $SlotKey . "\" value=\"" . $Img . "\" size=\"25\"></td></tr>";
			$Pop .= "<tr><td>Over Image:</td><td><input type=\"text\" id=\"hover_" . $SlotKey . "\" name=\"WS_Img_Hover_" . $SlotKey . "\" value=\"" . $ImgHover . "\" size=\"25\"></td></tr>";
			$Pop .= "<tr><td>Override Text:</td><td><input name=\"WS_IN_Text_" . $SlotKey . "\" type=\"text\" value=\"" . $Text . "\" size=\"50\"/></td></tr>";
			$Pop .= "<tr><td>Text Align:</td><td><input name=\"WS_IN_TextAlign_" . $SlotKey . "\" type=\"text\" value=\"" . $TextVAlign . "\" size=\"10\"/></td></tr>";
			$Pop .= "<tr><td>Width:</td><td><input name=\"WS_IN_txtWidth_" . $SlotKey . "\" type=\"text\" value=\"" . $UserWidth . "\" size=\"10\"/></td></tr>";
			$Pop .= "<tr><td>Height:</td><td><input name=\"WS_IN_txtHeight_" . $SlotKey . "\" type=\"text\" value=\"" . $UserHeight . "\" size=\"10\"/></td></tr>";
			$Pop .= "<tr><td>Over Effect:</td><td><select id=\"WS_IN_OverEffect_" . $SlotKey . "\" name=\"WS_IN_OverEffect_" . $SlotKey . "\" >";
			$Pop .= "<option value=\"\">None</option>";
			$Pop .= "<option value=\"ws_jamp_up\">Jamp Up</option>";
			$Pop .= "<option value=\"ws_tilt\">Tilt</option>";
			$Pop .= "<option value=\"ws_red_shadow\">Red Shadow</option>";
			$Pop .= "<option value=\"ws_green_shadow\">Green Shadow</option>";
			$Pop .= "<option value=\"ws_blue_shadow\">Blue Shadow</option>";
			$Pop .= "<option value=\"ws_orange_shadow\">Orange Shadow</option>";
			$Pop .= "<option value=\"ws_gray_shadow\">Gray_Shadow</option>";
			$Pop .= "<option value=\"ws_highlight\">Highlight</option>";
			$Pop .= "<option value=\"ws_rotate_Y\">Rotate Y</option>";
			$Pop .= "<option value=\"ws_rotate_Z\">Rotate Z</option>";
			$Pop .= "<option value=\"ws_gray_scale\">Gray Scale</option>";
			$Pop .= "</select>";
			$Pop .= "<script>document.getElementById('WS_IN_OverEffect_" . $SlotKey . "').value='" . $OverEffect . "';</script>";
			$Pop .= "</td></tr>";

			$Pop .= "<tr><td>Resize:</td><td><select id=\"WS_IN_Resize_" . $SlotKey . "\" name=\"WS_IN_Resize_" . $SlotKey . "\" >";
			$Pop .= "<option value=\"\"></option>";
			$Pop .= "<option value=\"Strech\">Strech</option>";
			$Pop .= "<option value=\"Cover\">Cover</option>";
			$Pop .= "<option value=\"Contain\">Contain</option>";
			$Pop .= "<option value=\"100% auto\">Resize to width</option>";
			$Pop .= "<option value=\"auto 100%\">Resize to height</option>";
			$Pop .= "<option value=\"auto auto\">No resize</option>";
			$Pop .= "</select>";
			$Pop .= "<script>document.getElementById('WS_IN_Resize_" . $SlotKey . "').value='" . $ImgResize . "';</script>";
			$Pop .= "</td></tr>";

			$Pop .= "<tr><td>Link:</td><td><input name=\"WS_IN_txtLink_" . $SlotKey . "\" type=\"text\" value=\"" . $Link . "\" size=\"50\"/></td></tr>";
			$Pop .= "<tr><td>Css class:</td><td><input id=\"WS_IN_CssClass_" . $SlotKey . "\" name=\"WS_IN_CssClass_" . $SlotKey . "\" type=\"text\" value=\"" . $CssClass . "\" size=\"50\"/>";
			$Pop .= $this->DrawClassesComboBox("WS_IN_Param_" . $SlotKey );
			$Pop .= "</td></tr>";
			$Pop .= "</table><br/>";
			$Pop .= "<div style=\"position:relative;margin:auto;width:250px;display:block\">";
			$Pop .= "<input class=\"ws_button\" name=\"Set_" . $SlotKey . "\" type=\"submit\" value=\"&nbsp;&nbsp;Set&nbsp;&nbsp;\" style=\"padding:3px\" />&nbsp;&nbsp;&nbsp;";
			$Pop .= "<input class=\"ws_button\" name=\"Clr_" . $SlotKey . "\" type=\"submit\" value=\"Clear\" style=\"padding:3px\" />&nbsp;&nbsp;&nbsp;";
			$Pop .= "<input class=\"ws_button\" name=\"Can_" . $SlotKey . "\" type=\"submit\" value=\"Cancel\" style=\"padding:3px\" />";
			$Pop .= "</div><br/>";
			$WS->SetPopup($Pop, "95%", "700px");
		}

		$SWidth = "width:30px";
		$SHeight = "height:30px";
		$MWidth = "";
		$MHeight = "";

		if ($Img != "")
		{
			if (file_exists(WS::$WSBase->Root . "/Media/" . $Img))
			{
				$Size = getimagesize(WS::$WSBase->Root . "/Media/" . $Img);
				$SWidth = "width:" . $Size[0] . "px;";
				$SHeight = "height:" . $Size[1] . "px;";
				//if ((strpos($Width,"px") === true) && ($Height == "")){$MHeight = intval(intval($Width) * $Size[0] / $Size[1]) . "px";}
				//if ((strpos($Height,"px") === true) && ($Width == "")){$MWidth = intval(intval($Height) * $Size[1] / $Size[0]) . "px";}
			}
		}
		if ($MWidth != "") {$SWidth = "width:" . $MWidth . ";";}
		if ($MHeight != "") {$SHeight = "height:" . $MHeight . ";";}
		if ($Width != "") {$SWidth = "width:" . $Width . ";";}
		if ($Height != "") {$SHeight = "height:" . $Height . ";";}
		if ($UserWidth != ""){$SWidth = "width:" . $UserWidth . ";";}
		if ($UserHeight != "") {$SHeight = "height:" . $UserHeight . ";";}
		if ($ImgResize != "")
		{
			if ($ImgResize=="Strech"){$ImgResize="100% 100%";}
			$SImgResize = "background-size:" . strtolower ( $ImgResize) . ";";
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver;" . $SWidth . $SHeight . "\">";
			echo $WS->DrawEditButton($SlotKey, "Img", "Set Image", "ws_btnedit-im ws_absolute",  $Img);
		}

		if ($Img != "")
		{
			$CEffect = "";
			$Target = "";
			if ((strpos($Link, "http://") !== false) || (strpos($Link, "https://") !== false))
			{
				$Target = " target=\"_blank\"";
			}
			if ($Link != "")
				echo "<a " . $Target . " href=\"" . $Link . "\">";
			echo "<style>";
			echo ".cls_" . $SlotKey . "{" . $SWidth . $SHeight . $SImgResize . "background-image:url(../Media/" . $Img . ");}";
			if ($ImgHover != "")
			{
				echo ".cls_" . $SlotKey . ":hover{background-image:url(../Media/" . $ImgHover . ");}";
			}
			echo "</style>";
			echo "<div class=\"ws_imgToDiv " . $CssClass . " " . $OverEffect . " cls_" . $SlotKey . "\">";
			if ($Text != "")
			{
				$VAlign = "bottom";
				if ($TextVAlign != "")
				{
					$VAlign = $TextVAlign;
				}
				echo "<div style=\"position:relative;vertical-align:" . $VAlign . ";background-color:rgba(0,0,0,.7);color:white\"></div>";
			}
			echo "</div>";
			if ($Link != "")
				echo "</a>";
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
	
	public function Slot_Video($SlotID, $Width = "", $Height = "")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $this->GetSlotKey($SlotID);
		$Vid = "";  // LOAD FROM DB $Vid
		$UserWidth = "";
		$UserHeight = "";
		$AutoPlay = "false";
		$Controls = "true";
		$CssClass = "";
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			if (filter_input(INPUT_POST, "Clr_" . $SlotKey))
			{
				$this->SlotDelete($this->WS_Page->PageID, $this->CurrentBodyID, $SlotID);
				$this->LoadSlots();
			}

			if (filter_input(INPUT_POST, "Set_" . $SlotKey))
			{
				$Params = $this->InitParamsArray();
				$Params[0] = filter_input(INPUT_POST, "vid_" . $SlotKey);
				$Params[1] = filter_input(INPUT_POST, "WS_IN_txtWidth_" . $SlotKey);
				$Params[2] = filter_input(INPUT_POST, "WS_IN_txtHeight_" . $SlotKey);
				$Params[3] = filter_input(INPUT_POST, "WS_IN_chkAutoPlay_" . $SlotKey);
				$Params[4] = filter_input(INPUT_POST, "WS_IN_chkControls_" . $SlotKey);
				$Params[5] = filter_input(INPUT_POST, "WS_IN_CssClass_" . $SlotKey);	
				$Text = filter_input(INPUT_POST, "WS_IN_Text_" . $SlotKey);
				$this->SlotUpdate($this->WS_Page->PageID, $SlotID, $Text, $Params, "", "VID");
				$this->LoadSlots();
			}

			$MediaDir = WS::GetMediaNames();
			$MediaDirPage = WS::GetMediaNames($this->WS_Page);
		}

		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$Vid = $this->WS_Page->Slots[$SlotKey]->Param[0];
			$UserWidth = $this->WS_Page->Slots[$SlotKey]->Param[1];
			$UserHeight = $this->WS_Page->Slots[$SlotKey]->Param[2];
			$AutoPlay = $this->WS_Page->Slots[$SlotKey]->Param[3];
			$Controls = $this->WS_Page->Slots[$SlotKey]->Param[4];
			$CssClass = $this->WS_Page->Slots[$SlotKey]->Param[5];
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey) || filter_input(INPUT_POST, "btnSearch_" . $SlotKey))
		{
			$Pop = "</br>&nbsp;&nbsp;<input name=\"txtSearch_" . $SlotKey . "\" type=\"text\" value=\"\" size=\"40\"/>";
			$Pop .= "<input class=\"ws_button\" name=\"btnSearch_" . $SlotKey . "\" type=\"submit\" value=\"Search\"/></br></br>";
			$Pop .= "<div style=\"overflow-x:scroll;width:95%;border:solid 1px #444444;margin:auto\">";
			$Pop .= "<table><tr>";

			if (count($MediaDir) == 0)
			{
				$Pop .= "<td>No Midia Loaded.</td>";
			}
			else
			{
				foreach ($MediaDir as $Entry)
				{
					if ((!isset($_POST["txtSearch_" . $SlotKey])) || ($_POST["txtSearch_" . $SlotKey] == "") || (strpos($Entry, $_POST["txtSearch_" . $SlotKey]) !== false))
					{

						$imageFileType = pathinfo($Entry, PATHINFO_EXTENSION);
						if (($imageFileType == "avi") || ($imageFileType == "mp4"))
						{
							$Pop .= "<td style=\"border: 1px solid #444444\">";
							$Pop .= "<div style=\"float:left;background-image:url(../Lib/Images/EditVid.png);background-repeat:no-repeat; background-size:contain;width:80px;height:50px\"></div>";
							$Pop .= "<div style=\"float:right;vertical-align:top\"></div>";
							//$Pop .=  "<input type=\"hidden\" name=\"hide_".$SlotKey."_" . str_replace(".","_",$Entry) . "\" value=\"" . $Entry . "\">";
							$Pop .= "<br/><br/><br/><div style\";font-size:9px;color:#444444\">" . $Entry . "</br></br>";
							$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Video\" title=\"Set Video\" onclick=\"$('#vid_" . $SlotKey . "').val('" . $Entry . "')\"></div>";
							$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Over\" title=\"Set Hover\" onclick=\"$('#hover_" . $SlotKey . "').val('" . $Entry . "')\"></div>";
							$Pop .= "</td><td>&nbsp;&nbsp;&nbsp;</td>";
						}
					}
				}

				foreach ($MediaDirPage as $Entry)
				{
					if ((!isset($_POST["txtSearch_" . $SlotKey])) || ($_POST["txtSearch_" . $SlotKey] == "") || (strpos($Entry, $_POST["txtSearch_" . $SlotKey]) !== false))
					{
						

						$imageFileType = pathinfo($Entry, PATHINFO_EXTENSION);
						if (($imageFileType == "avi") || ($imageFileType == "mp4"))
						{
							$Pop .= "<td style=\"border: 1px solid #444444\">";
							$Pop .= "<div style=\"float:left;background-image:url(../Lib/Images/EditVid.png);background-repeat:no-repeat; background-size:contain;width:80px;height:50px\"></div>";
							$Pop .= "<div style=\"float:right;vertical-align:top\"></div>";
							//$Pop .=  "<input type=\"hidden\" name=\"hide_".$SlotKey."_".$this->WS_Page->Name."_". str_replace(".","_",$Entry) . "\" value=\"" .$this->WS_Page->Name."/".$Entry . "\">";
							$Pop .= "<br/><br/><br/><div style\";font-size:9px;color:#444444\">" . $this->WS_Page->Name . "/" . $Entry . "</br></br>";
							$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Video\" title=\"Set Video\" onclick=\"$('#vid_" . $SlotKey . "').val('" . $this->WS_Page->Name . "/" . $Entry . "')\"></div>";
							$Pop .= "<input class=\"ws_button\" type=\"button\" value=\"Set Over\" title=\"Set Hover\" onclick=\"$('#hover_" . $SlotKey . "').val('" . $this->WS_Page->Name . "/" . $Entry . "')\"></div>";
							$Pop .= "</td><td>&nbsp;&nbsp;&nbsp;</td>";
						}
					}
				}
			}

			$Pop .= "</tr></table>";
			$Pop .= "</div><br/>";
			$Pop .= "<table  style=\"margin-left:20px\">";
			$Pop .= "<tr><td>Video:</td><td><input type=\"text\" id=\"vid_" . $SlotKey . "\" name=\"vid_" . $SlotKey . "\" value=\"" . $Vid . "\" size=\"25\"></td></tr>";
			$Pop .= "<tr><td>Width:</td><td><input name=\"WS_IN_txtWidth_" . $SlotKey . "\" type=\"text\" value=\"" . $UserWidth . "\" size=\"10\"/></td></tr>";
			$Pop .= "<tr><td>Height:</td><td><input name=\"WS_IN_txtHeight_" . $SlotKey . "\" type=\"text\" value=\"" . $UserHeight . "\" size=\"10\"/></td></tr>";
			$Pop .= "<tr><td>Auto start:</td><td><input name=\"WS_IN_chkAutoPlay_" . $SlotKey . "\" type=\"checkbox\" value=\"true\" /></td></tr>";
			if ($AutoPlay == "true") {$Checked = "checked";} else {$Checked="";}
			$Pop .= "<tr><td>Controls:</td><td><input ".$Checked." name=\"WS_IN_chkControls_" . $SlotKey . "\" type=\"checkbox\" value=\"true\" /></td></tr>";
			if ($Controls == "true") {$Checked = "checked";} else {$Checked="";}
			$Pop .= "<tr><td>Css class:</td><td><input id=\"WS_IN_CssClass_" . $SlotKey . "\" name=\"WS_IN_CssClass_" . $SlotKey . "\" type=\"text\" value=\"" . $CssClass . "\" size=\"50\"/>";
			$Pop .= $this->DrawClassesComboBox("WS_IN_Param_" . $SlotKey );
			$Pop .= "</td></tr>";
			$Pop .= "</table><br/>";
			$Pop .= "<div style=\"position:relative;margin:auto;width:250px;display:block\">";
			$Pop .= "<input class=\"ws_button\" name=\"Set_" . $SlotKey . "\" type=\"submit\" value=\"&nbsp;&nbsp;Set&nbsp;&nbsp;\" style=\"padding:3px\" />&nbsp;&nbsp;&nbsp;";
			$Pop .= "<input class=\"ws_button\" name=\"Clr_" . $SlotKey . "\" type=\"submit\" value=\"Clear\" style=\"padding:3px\" />&nbsp;&nbsp;&nbsp;";
			$Pop .= "<input class=\"ws_button\" name=\"Can_" . $SlotKey . "\" type=\"submit\" value=\"Cancel\" style=\"padding:3px\" />";
			$Pop .= "</div><br/>";
			$this->SetPopup($Pop, "95%", "700px");
		}

		$SWidth = "width:100%";
		$SHeight = "";
		$MWidth = "";
		$MHeight = "";
		$Attributes = "";
		if ($MWidth != "") {$SWidth = "width:" . $MWidth . ";";}
		if ($MHeight != "") {$SHeight = "height:" . $MHeight . ";";}
		if ($Width != "") {$SWidth = "width:" . $Width . ";";}
		if ($Height != "") {$SHeight = "height:" . $Height . ";";}
		if ($UserWidth != ""){$SWidth = "width:" . $UserWidth . ";";}
		if ($UserHeight != "") {$SHeight = "height:" . $UserHeight . ";";}
		if ($AutoPlay == "true") {$Attributes .= " autoplay ";}
		if ($Controls == "true") {$Attributes .= " controls ";}
		if ($CssClass != "") {$Attributes .= " class=\"".$CssClass."\" ";}
		
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver;" . $SWidth . $SHeight . "\">";
			echo $this->DrawEditButton($SlotKey, "Vid", "Set Video", "ws_btnedit-vid ws_absolute",  $Vid);
		}

		if ($Vid != "")
		{
			echo "<video style=\"" . $SWidth . $SHeight . "\" src=\"../Media/" . $Vid . "\" ".$Attributes." />";
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
	
	public function Slot_YouTube($SlotID, $Width, $Height)
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $this->GetSlotKey($SlotID);
		$SlotKey = $this->GetSlotKey($SlotID);

		$this->ReadInputSlots($this->WS_Page->PageID, $SlotID,  "TXT");

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Params = array();
			array_push($Params, new WS_ParamDef("Link", "Link:", 80, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param0", "Width:", 6, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param1", "Height:", 6, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param2", "CSS styles:", 80, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param3", "Auto Start:", 3, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Update", "Update", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null));
			$this->DrawConfigSlots($this->WS_Page->PageID, $SlotID,  $Params);
		}

		$Link = "";
		$Text = "";
		$Width = "";
		$Height = "";
		$AutoStart = 0;
		$CSS = "";
		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $this->WS_Page->Slots[$SlotKey];
			$Width = $Slot->Param[0];
			$Height = $Slot->Param[1];
			$CSS = $Slot->Param[2];
			$AutoStart = $Slot->Param[3];
			$Link = $Slot->Link;
		}

		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver\">";
			echo $this->DrawEditButton($SlotKey, "Text", "Edit Text", "ws_btnedit-im ws_absolute",  $Text);
		}

		$SWidth = "";
		$SHeight = "";
		$AutoStart = "0";
		if ($Link != "")
		{
			if (strtolower($AutoStart == "true"))
			{
				$AutoStart = "1";
			}
			if (strtolower($AutoStart == "false"))
			{
				$AutoStart = "0";
			}
			if ($Link != "")
				echo "<a href=\"" . $Link . "\">";
			if ($Width != "")
			{
				$SWidth = "width:" . $Width . ";";
			}
			if ($Height != "")
			{
				$SHeight = "height:" . $Height . ";";
			}
			if ($UserWidth != "")
			{
				$SWidth = "width:" . $UserWidth . ";";
			}
			if ($UserHeight = "")
			{
				$SHeight = "height:" . $UserHeight . ";";
			}
			echo "<iframe style=\"" . $SWidth . $SHeight . $CSS . "\" src=\"" . $Link . "\"?version=3&loop=1&autoplay=" . $AutoStart . "&showsearch=0&showinfo=0&fs=1\" frameborder=\"0\" allowfullscreen></iframe>";
		}
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
}
?>