<?php

trait WS_MenuBar
{

	public function Slot_MenuBar($SlotID, $Vertical = false)
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"]))
		{
			return;
		}
		if (!isset($WS->WS_Page->PageID))
		{
			return;
		}
		if ($WS->WSDB == null)
		{
			return;
		}

		$RowOffset = 0;
		$SlotKey = $WS->GetSlotKey($SlotID);

		//$Menus = $WS->GetMenus($SlotID);
		//$SubMenus = $WS->GetMenus($SlotID,"",true);
		$Menus = WS_Menu::GetMultiLangMenus($SlotID);
		$SubMenus = WS_Menu::GetMultiLangMenus($SlotID, "", true);

		// MENU EDIT POPUP
		$AllMenu = array_merge($Menus, $SubMenus);
		$WS->ManageMenu($SlotID, $Menus, $SubMenus, $AllMenu);

		$VertBuff = "";
		$OrizBuff = "";
		$Menus = WS_Menu::GetMultiLangMenus($SlotID);
		if ($Vertical)
		{
			// ---------------------
			// VERTICAL MENU
			// ---------------------
			$VertBuff .= "<div style=\"margin-top:14px\" class=\"ws_menu_open_button_act\"><table class=\" ws_menu_mobile_tab ws_menu_dropdown_bar\">\n";
			if ($_SESSION["SLOTS_EDIT_MODE"])
			{
				$VertBuff .= "<tr><td style=\"height:1px;overflow:visible\">";
				echo $WS->DrawEditButton($SlotKey, " ", "Edit Menu Bar", "ws_btnedit-mn", 0, $Value = "");
				$VertBuff .= "</td></tr>";
			}

			foreach ($Menus as $Menu)
			{
				// CHECK PERMISION
				$Perm = "none";
				if (isset($_SESSION["PERMISIONS"]) && ($_SESSION["PERMISIONS"] != ""))
				{
					$Perm = $_SESSION["PERMISIONS"];
				}
				if (
						(strpos($Menu->Permisions, "all") !== false) ||
						(strpos($Menu->Permisions, $Perm) !== false)
				)
				{
					// PREPARE SUB MENU
					$SubMenu = "";
					$SubMenuV = "";
					$Class = "";
					$href = " href=\"" . $Menu->Link . "\"";
					if ($Menu->DropDown)
					{
						$href = "";
						$SubMenus = WS_Menu::GetMultiLangMenus($SlotID, $Menu->Pos, true);
						$Class .= " ws_menu_dropdown";
						$SubMenu .= "<div class=\"ws_menu_dropdown_act ws_menu_dropdown_bar\">";
						$SubMenuV .= "<div class=\"ws_menu_dropdown_act ws_menu_mobile_dropdown_bar\">";
						foreach ($SubMenus as $Mn)
						{
							$Target = "";
							if ($Mn->Link == "")
							{
								$Mn->Link = basename($_SERVER["SCRIPT_FILENAME"]);
							}
							if ((strpos($Mn->Link, "http://") !== false) || (strpos($Mn->Link, "https://") !== false))
							{
								$Target = " target=\"_blank\"";
							}
							$SubMenuV .= "<div class=\"ws_menu_dropdown_box\"><a " . $Target . " title=\"" . $Mn->Tooltip . "\"  href=\"" . $Mn->Link . "\">" . $Mn->Text . "</a></div>";
						}
						$SubMenuV .= "</div>";
						$SubMenu .= "</div>";
					}

					// DRAW MENU
					$Target = "";
					$Class .= " ws_menu_td ";
					if ($Menu->Link == basename($_SERVER["SCRIPT_FILENAME"]))
					{
						$Class .= " ws_menu_selected";
					}
					if ($Menu->Link == "")
					{
						$Menu->Link = basename($_SERVER["SCRIPT_FILENAME"]);
					}
					if ((strpos($Menu->Link, "http://") !== false) || (strpos($Menu->Link, "https://") !== false))
					{
						$Target = " target=\"_blank\"";
					}
					$VertBuff .= "<tr><a " . $href . " " . $Target . "><td class=\"ws_menu_mobile_box ws_menu_dropdown_box " . $Class . "\" title=\"" . $Menu->Tooltip . "\">" . $SubMenuV . $Menu->Text . "</td></a></tr>\n";
				}
			}

			if ($_SESSION["SLOTS_EDIT_MODE"])
			{
				$VertBuff .= "<td><tr>";
				echo $WS->DrawEditButton($SlotKey, " ", "Edit Menu Bar", "ws_btnedit-mn", 0, $Value = "");
				$VertBuff .= "</td></tr>";
			}
			$VertBuff .= "</table></div>";
			echo $VertBuff;
		}
		else
		{
			// -----------------------
			// ORIZZONTAL MENU
			// -----------------------
			$VertBuff .= "<div  class=\"ws_menu_open_button_act\" style=\"margin-top:14px\"><table class=\" ws_menu_tab ws_menu_mobile_dropdown_bar\">\n";
			$OrizBuff .= "<table class=\"ws_menu_tab ws_menu_bar\" style=\"z-index:1000;\" cellpadding=\"0px\" cellspacing=\"0px\"><tr>\n";
			if ($_SESSION["SLOTS_EDIT_MODE"])
			{
				$OrizBuff .= "<td style=\"height:10px;overflow:visible\">";
				$OrizBuff .= $WS->DrawEditButton($SlotKey, " ", "Edit Menu Bar", "ws_btnedit-mn", 0, $Value = "");
				$OrizBuff .= "</td>";
			}

			$Target = "";
			$MenuCount = 0;
			foreach ($Menus as $Menu)
			{
				// CHECK PERMISION
				$Perm = "none";
				if (isset($_SESSION["PERMISIONS"]) && ($_SESSION["PERMISIONS"] != ""))
				{
					$Perm = $_SESSION["PERMISIONS"];
				}
				if (
						(strpos($Menu->Permisions, "all") !== false) ||
						(strpos($Menu->Permisions, $Perm) !== false)
				)
				{
					// PREPARE SUB MENU
					$SubMenu = "";
					$SubMenuV = "";
					$Class = "";
					$href = " href=\"" . $Menu->Link . "\"";
					if ($Menu->DropDown)
					{
						$href = "";
						$SubMenus = WS_Menu::GetMultiLangMenus($SlotID, $Menu->Pos, true);
						$Class .= " ws_menu_dropdown";
						$SubMenu .= "<div class=\"ws_menu_dropdown_act ws_menu_dropdown_bar\">";
						$SubMenuV .= "<div class=\"ws_menu_dropdown_act ws_menu_mobile_dropdown_bar\" style=\"position:static\">";
						foreach ($SubMenus as $Mn)
						{
							$Target = "";
							if ($Mn->Link == "")
							{
								$Mn->Link = basename($_SERVER["SCRIPT_FILENAME"]);
							}
							if ((strpos($Mn->Link, "http://") !== false) || (strpos($Mn->Link, "https://") !== false))
							{
								$Target = " target=\"_blank\"";
							}

							$SubMenu .= "<a " . $Target . " title=\"" . $Mn->Tooltip . "\"  href=\"" . $Mn->Link . "\"><div class=\"ws_menu_dropdown_box\">" . $Mn->Text . "</div></a>";

							$SubMenuV .= "<a " . $Target . " title=\"" . $Mn->Tooltip . "\"  href=\"" . $Mn->Link . "\"><div class=\"ws_menu_mobile_dropdown_box ws_sub_menu_mobile\"><span class=\"ws_sub_menu_mobile\">" . $Mn->Text . "</span></div></a>";
						}
						$SubMenuV .= "</div>";
						$SubMenu .= "</div>";
					}

					// DRAW MENU
					$Target = "";
					$Arrow = "";
					$Class .= "";
					if ($Menu->DropDown)
					{
						$Arrow = "<div class=\"ws_menu_mobile_arrow\">&gt;</div>";
					}
					if ($Menu->Link == basename($_SERVER["SCRIPT_FILENAME"]))
					{
						$Class .= " ws_menu_selected";
					}
					if ($Menu->Link == "")
					{
						$Menu->Link = basename($_SERVER["SCRIPT_FILENAME"]);
					}
					if ((strpos($Menu->Link, "http://") !== false) || (strpos($Menu->Link, "https://") !== false))
					{
						$Target = " target=\"_blank\"";
					}

					// MENU MOBILE
					$VertBuff .= "<tr><td class=\"" . $Class . "\" title=\"" . $Menu->Tooltip . "\">";
					$VertBuff .= "<a " . $href . " " . $Target . ">";
					$VertBuff .= "<div class=\"ws_menu_mobile_dropdown_box\" >" . $Menu->Text;

					// Arrow
					$VertBuff .= $Arrow . "</div></a>";

					// SUM MENU MOBILE
					$VertBuff .= $SubMenuV;
					$VertBuff .= "</td></tr>\n";

					// MENU DESKTOP 
					$OrizBuff .= "<td class=\"ws_menu_desktop_conteiner " . $Class . "\" title=\"" . $Menu->Tooltip . "\" >";
					$OrizBuff .= "<a " . $href . " " . $Target . "><div class=\"ws_menu_box\" >" . $Menu->Text . "</div>" . $SubMenu;
					$OrizBuff .= "</td>\n";

					$MenuCount++;
				}
			}
			$VertBuff .= "</table></div>";

			$OrizBuff .= "<td class=\"ws_menu_open_button_dropdown ws_menu_open_button\" title=\"Open\">";
			if ($MenuCount > 0)
			{
				$OrizBuff .= "<hr class=\"ws_menu_mobile_button_rows\" />";
				$OrizBuff .= "<hr class=\"ws_menu_mobile_button_rows\" />";
				$OrizBuff .= "<hr class=\"ws_menu_mobile_button_rows\" />";
				$OrizBuff . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			$OrizBuff .= "<div style=\"\">" . $VertBuff . "</div>";
			$OrizBuff .= "</td>";
			$OrizBuff .= "<td style=\"width:99%\"></td>";

			if ($_SESSION["SLOTS_EDIT_MODE"])
			{
				$OrizBuff .= "<td>";
				$OrizBuff .= $WS->DrawEditButton($SlotKey, " ", "Edit Menu Bar", "ws_btnedit-mn", 0, $Value = "");
				$OrizBuff .= "</td>";
			}
			$OrizBuff .= "</tr>";
			$OrizBuff .= "</table>";

			echo $OrizBuff;
		}

		// GENERATE SCRIPT
		if (!$WS->MenuScript)
		{
			$WS->MenuScript = true;
			echo "<script type=\"text/javascript\" src=\"../Lib/js/Menu.js\"></script>";
		}
		//echo $VertBuff;
	}
}

?>