<?php
trait WS_Slider
{
	public function Slot_ImageSliderCarousel($SlotID, $Width = "", $Height = "", $Mode = "SHADE")
	{
		global $WS;
		$MAX_IMAGES = 5;
		
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $WS->GetSlotKey($SlotID);
		//$Link = filter_input(INPUT_POST, "WS_IN_txtLink_" . $SlotKey);

		if (filter_input(INPUT_POST, "WS_IN_BtnClear_" . $SlotKey))
		{
			if (isset($WS->WS_Page->Slots[$SlotKey]))
			{
				$Slot=$WS->WS_Page->Slots[$SlotKey];
				$WS->SlotDelete($Slot->PageID, $Slot->BodyID, $Slot->SlotID);
				$WS->LoadSlots();
			}
		}

		if (filter_input(INPUT_POST, "WS_IN_BtnUpdate_" . $SlotKey))
		{
			// UPDATE DB
			$Link = filter_input(INPUT_POST, "WS_IN_txtLink_" . $SlotKey);
			$Params = $WS->InitParamsArray();
			for ($N = 0; $N < $MAX_IMAGES; $N++)
			{
				$Params[$N] = filter_input(INPUT_POST, "WS_IN_img_" . strval($N) . "_" . $SlotKey);
				$Params[$N+10] = filter_input(INPUT_POST, "WS_IN_txt_" . strval($N) . "_" . $SlotKey);
				$Params[$N+15] = filter_input(INPUT_POST, "WS_IN_link_" . strval($N) . "_" . $SlotKey);
			}
			$Params[7] = filter_input(INPUT_POST, "WS_IN_txtDelay_" . $SlotKey);
			$Params[8] = filter_input(INPUT_POST, "WS_IN_txtWidth_" . $SlotKey);
			$Params[9] = filter_input(INPUT_POST, "WS_IN_txtHeight_" . $SlotKey);

			$WS->SlotUpdate($WS->WS_Page->PageID, $SlotID, "X", $Params, $Link, "SLI");
			$WS->LoadSlots();
		}

		$Link = "";
		$UserWidth = "100%";
		$UserHeight = "100%";
		$Delay = "3";
		if ($Width != "")
		{
			$UserWidth = $Width;
		}
		if ($Height != "")
		{
			$UserHeight = $Height;
		}
		if ($Mode != "")
		{
			$UserMode = $Mode;
		}
		$Img = array("", "", "", "", "");
		$TextVal = array("", "", "", "", "");
		$LinkVal = array("", "", "", "", "");
		$Slot =null;
		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $WS->WS_Page->Slots[$SlotKey];
			//$Link = $Slot->Link;
			if ($Slot->Param[7] != ""){$Delay = $Slot->Param[7];}
			if ($Slot->Param[8] != ""){$UserWidth =$Slot->Param[8];}
			if ($Slot->Param[9] != ""){$UserHeight = $Slot->Param[9];}
			
			for ($N = 0; $N < $MAX_IMAGES; $N++)
			{
				$Img[$N] = $Slot->Param[$N];
				$TextVal[$N] = $Slot->Param[$N+10];
				$LinkVal[$N] = $Slot->Param[$N+15];
			}
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Pop="<div style=\"height:80%;width:100%;\" class=\"ws_scroll\">";
			$Media = $WS->GetMediaNames();
			$MediaP = $WS->GetMediaNames($WS->WS_Page);
			foreach ($MediaP as $F)
			{
				array_push($Media, $WS->WS_Page->Name . "/" . $F);
			}

			$Pages = WS_Page::GetPagesNames();
			$Pop.="<div class=\"ws_tab\">";
			for ($N = 0; $N < $MAX_IMAGES; $N++)
			{
				$SN = strval($N);
				$SNC = strval($N+1);
				$Pop.="<div class=\"ws_row\">";
				$Pop .= "<div class=\"ws_cell\">Image ".$SNC.":</div>";
				$Pop .= "<div class=\"ws_cell\">" . $WS->BuildNullableSelectList($Media, "WS_IN_img_".$SN."_" . $SlotKey, $Img[$N]) . "</div> ";
				$Pop.="</div><div class=\"ws_row\">";
				$Pop .= "<div class=\"ws_cell\">Text</div>";
				$Pop .= "<div class=\"ws_cell\"><input name=\"WS_IN_txt_".$SN."_". $SlotKey . "\" type=\"text\" size=\"50\" value=\"" . $TextVal[$N] . "\"/></div>";
				$Pop.="</div><div class=\"ws_row\">";
				$Pop .= "<div class=\"ws_cell\">Link:</div>";
				$id = "WS_IN_link_".$SN."_".$SlotKey;
				$lst= "ws_lst_".$SN."_".$SlotKey;
				$Pop .= "<div class=\"ws_cell\"><input id=\"".$id."\" name=\"".$id."\" type=\"text\" size=\"50\" value=\"" . $LinkVal[$N] . "\" />";
				$Pop .= "<select style=\"width:50%\" id=\".$lst.\" onchange=\"$('#".$id."').val($(this).find('option:selected').text()+'.php');\">";
				$Pop .= "<option value=\"\"></option>";
				foreach ($Pages as $P)
				{
					$Pop .= "<option value=\"" . $P . ".php\">" . $P . "</option>";
				}
				$Pop .= "</select>";
				$Pop.="</div>";
				$Pop.="</div>&nbsp;<div class=\"ws_row\">";
				$Pop.="</div>";
			}

				$Pop.="<div class=\"ws_row\">";
					$Pop .= "<div class=\"ws_cell\">Delay:</div><div class=\"ws_cell\"><input name=\"WS_IN_txtDelay_" . $SlotKey . "\" type=\"text\" size=\"10\" value=\"" . $Delay . "\" /></div>";
				$Pop.="</div><div class=\"ws_row\">";
					$Pop .= "<div class=\"ws_cell\">Width:</div><div class=\"ws_cell\"><input name=\"WS_IN_txtWidth_" . $SlotKey . "\" type=\"text\" size=\"10\" value=\"" . $UserWidth . "\" /></div>";
				$Pop.="</div><div class=\"ws_row\">";
					$Pop .= "<div class=\"ws_cell\">Height:</div><div class=\"ws_cell\"><input name=\"WS_IN_txtHeight_" . $SlotKey . "\" type=\"text\" size=\"10\" value=\"" . $UserHeight . "\" /></div>";
				$Pop.="</div>";
				
			$Pop .= "</div>";
			$Pop .= "</div>";
			
			$Pop .= "</br></br>";
			$Pop .= "<input class=\"ws_button\" name=\"WS_IN_BtnUpdate_" . $SlotKey . "\" type=\"submit\" value=\"Update\" />";
			$Pop .= "<input class=\"ws_button\" name=\"WS_IN_BtnClear_" . $SlotKey . "\" type=\"submit\" value=\"Clear\" />";
			$Pop .= "<input class=\"ws_button\" name=\"WS_IN_BtnCancel_" . $SlotKey . "\" type=\"submit\" value=\"Cancel\" />";

			$WS->SetPopup($Pop, "665px", "450px");
			
		}

		$SWidth = "";
		$SHeight = "";
		if ($Width != 0){$SWidth = "width:" . $Width . ";";}
		if ($Height != 0){$SHeight = "height:" . $Height . ";";}
		if ($UserWidth != ""){$SWidth = "width:" . $UserWidth . ";";}
		if ($UserHeight != ""){$SHeight = "height:" . $UserHeight . ";";}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver;" . $SWidth . $SHeight . "\">";
			echo $WS->DrawEditButton($SlotKey, "Slid", "Set Image Slider", "ws_btnedit-im ws_absolute",  $Img[0]);
			echo "&nbsp;";
		}

		if ($Img[0] != "")
		{
			$WS->IncludeCss("../Lib/Styles/SliderCarousel.css");
			$WS->IncludeScript("../Lib/js/SliderCarousel.js");
			
			$Delta = "";
			if (!$_SESSION["SLOTS_EDIT_MODE"])
			{
				if ($Mode === false){$Mode = "EXCHANGE";}
				if ($Mode === true){$Mode = "SHADE";}
				if ($UserMode != ""){$Mode = $UserMode;}
				if ($Mode == "SHADE"){$Delta = str_replace("height:", "", $SHeight);}
			}

	
//			if ($Link != "")
//				{echo "<a " . $Target . " href=\"" . $Link . "\">";}
			
			// CONTAINER
			echo "<input type=\"hidden\" id=\"ws_sldInd_".$SlotKey."\" value=\"1\">";
			echo "<div class=\"ws_slider_container\">";

			// IMAGES
			$NC = 1;
			for ($NN = 0; $NN < $MAX_IMAGES; $NN++) 
			{
				if ($Img[$NN] != "")
				{
					$Target = "";
					if ((strpos($LinkVal[$NN], "http://") !== false) || (strpos($LinkVal[$NN], "https://") !== false))
					{
						$Target = " target=\"_blank\"";
					}
					
					echo "<div class=\"ws_slider_Slides ws_slider_fade ws_slider_".$SlotKey."\" >";
					if ($LinkVal[$NN] != "") {echo "<a " . $Target . " href=\"".$LinkVal[$NN]."\">";}
					echo "<img src=\"../Media/".$Img[$NN]."\" style=\"width:100%;height:100%\">";
					if ($TextVal[$NN] != "") {echo "<div class=\"ws_slider_text\" >" . $TextVal[$NN] . "</div>";}
					if ($LinkVal[$NN] != "") {echo "</a>";}

					echo "</div>";
					
					$NC++;
				}
			}
			
			// Next and previous buttons
			echo "<a class=\"ws_slider_prev\" onclick=\"ws_slider_plusSlides('".$SlotKey."',-1);\">&#10094;</a>";
			echo "<a class=\"ws_slider_next\" onclick=\"ws_slider_plusSlides('".$SlotKey."',1);\">&#10095;</a>";
			echo "</div>";

			// The dots/circles
			echo "<div style=\"text-align:center\">";
			$NC = 1;
			for ($NN = 0; $NN < $MAX_IMAGES; $NN++)
			{
				if ($Img[$NN] != "")
				{
					echo "<span class=\"ws_slider_dot ws_slider_dot_".$SlotKey."\" onclick=\"ws_slider_currentSlide('".$SlotKey."',".$NC.");\"></span>";
					$NC++;
				}
			}
			echo "</div>";

			//if ($Link != "") {echo "</a>";}
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
		echo "<script >ws_slider_showSlides('".$SlotKey."');</script>";
		if (($Delay != "")&&(intval($Delay) > 0))
		{
			echo "<script >ws_slider_setDelay('".$SlotKey."',".(intval($Delay)*1000).");</script>";
		}
	}
	
	public function Slot_ImageSlider($SlotID, $Width = "100%", $Height = "500px", $Mode = "SHADE")
	{
		global $WS;
		$MAX_IMAGES = 7;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $WS->GetSlotKey($SlotID);
		$Link = filter_input(INPUT_POST, "WS_IN_txtLink_" . $SlotKey);

		if (filter_input(INPUT_POST, "WS_IN_BtnClear_" . $SlotKey))
		{
			$Slot=$WS->WS_Page->Slots[$SlotKey];
			$WS->SlotDelete($Slot->PageID, $Slot->BodyID, $Slot->SlotID);
			$WS->LoadSlots();
		}

		if (filter_input(INPUT_POST, "WS_IN_BtnUpdate_" . $SlotKey))
		{
			// UPDATE DB
			$Link = filter_input(INPUT_POST, "WS_IN_txtLink_" . $SlotKey);
			$Params = $WS->InitParamsArray();
			for ($N = 0; $N < $MAX_IMAGES; $N++)
			{
				$Params[$N] = filter_input(INPUT_POST, "WS_IN_txtImg" . $N . "_" . $SlotKey);
			}
			$Params[7] = filter_input(INPUT_POST, "WS_IN_txtMode_" . $SlotKey);
			$Params[8] = filter_input(INPUT_POST, "WS_IN_txtWidth_" . $SlotKey);
			$Params[9] = filter_input(INPUT_POST, "WS_IN_txtHeight_" . $SlotKey);
			$WS->SlotUpdate($WS->WS_Page->PageID, $SlotID, "", $Params, $Link, "SLI");
			$WS->LoadSlots();
		}

		$Link = "";
		$UserWidth = "100%";
		$UserHeight = "500px";
		$UserMode = "SHADE";
		if ($Width != "")
			{$UserWidth = $Width;}
		
		if ($Height != "")
			{$UserHeight = $Height;}
			
		if ($Mode != "")
			{$UserMode = $Mode;}
		
		$Img = array("", "", "", "", "", "", "");
		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Link = $WS->WS_Page->Slots[$SlotKey]->Link;
			if ($WS->WS_Page->Slots[$SlotKey]->Param[7] != "")
				{$UserMode = $WS->WS_Page->Slots[$SlotKey]->Param[7];}
			if ($WS->WS_Page->Slots[$SlotKey]->Param[8] != "")
				{$UserWidth = $WS->WS_Page->Slots[$SlotKey]->Param[8];}
			if ($WS->WS_Page->Slots[$SlotKey]->Param[9] != "")
				{$UserHeight = $WS->WS_Page->Slots[$SlotKey]->Param[9];}
			for ($N = 0; $N < $MAX_IMAGES; $N++)
				{$Img[$N] = $WS->WS_Page->Slots[$SlotKey]->Param[$N];}
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Media = $WS->GetMediaNames();
			$MediaP = $WS->GetMediaNames($WS->WS_Page);
			foreach ($MediaP as $F)
				{array_push($Media, $WS->WS_Page->Name . "/" . $F);}

			$Pop = "Image 1:" . $WS->BuildNullableSelectList($Media, "WS_IN_txtImg0_" . $SlotKey, $Img[0]) . "<br/>";
			$Pop .= "Image 2:" . $WS->BuildNullableSelectList($Media, "WS_IN_txtImg1_" . $SlotKey, $Img[1]) . "<br/>";
			$Pop .= "Image 3:" . $WS->BuildNullableSelectList($Media, "WS_IN_txtImg2_" . $SlotKey, $Img[2]) . "<br/>";
			$Pop .= "Image 4:" . $WS->BuildNullableSelectList($Media, "WS_IN_txtImg3_" . $SlotKey, $Img[3]) . "<br/>";
			$Pop .= "Image 5:" . $WS->BuildNullableSelectList($Media, "WS_IN_txtImg4_" . $SlotKey, $Img[4]) . "<br/>";
			$Pop .= "Image 6:" . $WS->BuildNullableSelectList($Media, "WS_IN_txtImg5_" . $SlotKey, $Img[5]) . "<br/>";
			$Pop .= "Image 7:" . $WS->BuildNullableSelectList($Media, "WS_IN_txtImg6_" . $SlotKey, $Img[6]) . "<br/>";

			$Modes = array("CHANGE", "SHADE", "SCROLL_LEFT", "SCROLL_RIGHT", "SCROLL_DOWN", "SCROLL_UP", "RING");
			$Pop .= "&nbsp;Mode:" . $WS->BuildNullableSelectList($Modes, "WS_IN_txtMode_" . $SlotKey, $UserMode) . "<br/>";

			$Pop .= "&nbsp;Width:<input name=\"WS_IN_txtWidth_" . $SlotKey . "\" type=\"text\" size=\"10\" value=\"" . $UserWidth . "\" /></br>";
			$Pop .= "&nbsp;Height:<input name=\"WS_IN_txtHeight_" . $SlotKey . "\" type=\"text\" size=\"10\" value=\"" . $UserHeight . "\" /></br>";

			$Pop .= "&nbsp;Link:<input name=\"WS_IN_txtLink" . $SlotKey . "\" type=\"text\" size=\"80\"  value=\"" . $Link . "\"/></br></br>";
			$Pop .= "<input class=\"ws_button\" name=\"WS_IN_BtnUpdate_" . $SlotKey . "\" type=\"submit\" value=\"Update\" />";
			$Pop .= "<input class=\"ws_button\" name=\"WS_IN_BtnClear_" . $SlotKey . "\" type=\"submit\" value=\"Clear\" />";
			$Pop .= "<input class=\"ws_button\" name=\"WS_IN_BtnCancel_" . $SlotKey . "\" type=\"submit\" value=\"Cancel\" />";
			$WS->SetPopup($Pop, "665px", "350px");
		}

		$SWidth = "";
		$SHeight = "";
		if ($Width != 0)
		{
			$SWidth = "width:" . $Width . ";";
		}
		if ($Height != 0)
		{
			$SHeight = "height:" . $Height . ";";
		}
		if ($UserWidth != "")
		{
			$SWidth = "width:" . $UserWidth . ";";
		}
		if ($UserHeight != "")
		{
			$SHeight = "height:" . $UserHeight . ";";
		}


		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver;" . $SWidth . $SHeight . "\">";
			echo $WS->DrawEditButton($SlotKey, "Slid", "Set Image Slider", "ws_btnedit-im ws_absolute",  $Img[0]);
		}

		if ($Img[0] != "")
		{
			$Delta = "";
			if (!$_SESSION["SLOTS_EDIT_MODE"])
			{
				if ($Mode === false){$Mode = "EXCHANGE";}
					
				if ($Mode === true){$Mode = "SHADE";}
				
				if ($UserMode != ""){$Mode = $UserMode;}

				if ($Mode == "SHADE")
				{
					$Delta = str_replace("height:", "", $SHeight);
				}
			}


			$Target = "";
			if ((strpos($Link, "http://") !== false) || (strpos($Link, "https://") !== false))
			{
				$Target = " target=\"_blank\"";
			}
			if ($Link != ""){echo "<a " . $Target . " href=\"" . $Link . "\">";}
			echo "<div style=\"overflow:hidden;" . $SWidth . $SHeight . "\">";
			echo "<div id=\"WS_ImgBack_" . $SlotKey . "\" class=\"ws_imgToDiv\" style=\" background-image:url(../Media/" . $Img[0] . ");background-size: 100% 100%;" . $SWidth . $SHeight . "\"></div>";
			echo "<div id=\"WS_Img_" . $SlotKey . "\" class=\"ws_imgToDiv\" style=\"background-image:url(../Media/" . $Img[0] . ");background-size: 100% 100%;" . $SWidth . $SHeight . "\"></div>";
			echo "<input  id=\"WS_ImgNum_" . $SlotKey . "\" type=\"hidden\" value=\"0\">";
			echo "</div>";

			if ($Link != ""){echo "</a>";}

			echo "<script type=\"text/javascript\">\n";
			echo "var WS_Img_" . $SlotKey . " = Array();\n";
			$NC = 0;
			for ($NN = 0; $NN < $MAX_IMAGES; $NN++)
			{
				if ($Img[$NN] != "")
				{
					echo "WS_Img_" . $SlotKey . "[" . $NC . "] = \"../Media/" . $Img[$NN] . "\";\n";
					$NC++;
				}
			}
			if (!$_SESSION["SLOTS_EDIT_MODE"])
			{
				if ($Img[1] != "")
				{
					echo "setTimeout(function () { TranslateImage(\"IMG\",\"WS_ImgNum_" . $SlotKey . "\", WS_Img_" . $SlotKey . ", \"WS_Img_" . $SlotKey . "\",\"WS_ImgBack_" . $SlotKey . "\",\"" . $Mode . "\") }, " . $WS->Timer . ");\n";
					$WS->Timer += 13;
				}
			}
			echo "</script>\n";
		}

		$WS->IncludeScript("../Lib/js/Slide.js");

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
	
	public function Slot_TextSlider($SlotID, $Width = "100%", $Height = "500px", $Mode = "SHADE")
	{
		global $WS;
		$MAX_TEXTS = 7;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $WS->GetSlotKey($SlotID);

		$WS->ReadInputSlots($WS->WS_Page->PageID, $SlotID,  "SLD");

		$Link = "";
		$UserWidth = "";
		$UserHeight = "";
		$UserMode = "";
		$Txt = array("", "", "", "", "", "", "");

		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $WS->WS_Page->Slots[$SlotKey];
			$Link = $Slot->Link;
			$UserMode = $Slot->Param[7];
			$UserWidth = $Slot->Param[8];
			$UserHeight = $Slot->Param[9];
			for ($N = 0; $N < $MAX_TEXTS; $N++)
			{
				$Txt[$N] = $Slot->Param[$N];
			}
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Modes = array("CHANGE", "SHADE", "SCROLL_LEFT", "SCROLL_RIGHT", "SCROLL_DOWN", "SCROLL_UP", "RING");
			$Params = array();

			$Params[1] = new WS_ParamDef("Param0", "Text 1:", 80, 2, "TXT", null);
			$Params[2] = new WS_ParamDef("Param1", "Text 2:", 80, 2, "TXT", null);
			$Params[3] = new WS_ParamDef("Param2", "Text 3:", 80, 2, "TXT", null);
			$Params[4] = new WS_ParamDef("Param3", "Text 4:", 80, 2, "TXT", null);
			$Params[5] = new WS_ParamDef("Param4", "Text 5:", 80, 2, "TXT", null);
			$Params[6] = new WS_ParamDef("Param5", "Text 6:", 80, 2, "TXT", null);
			$Params[7] = new WS_ParamDef("Param6", "Text 7:", 80, 2, "TXT", null);

			$Params[8] = new WS_ParamDef("Param7", "Mode:", 20, 1, "DDL", $Modes);
			$Params[9] = new WS_ParamDef("Param8", "Width:", 6, 1, "TXT", null);
			$Params[10] = new WS_ParamDef("Param9", "Height:", 6, 1, "TXT", null);
			$Params[11] = new WS_ParamDef("Link", "Link:", 80, 1, "TXT", null);

			$Params[12] = new WS_ParamDef("Update", "Update", 0, 0, "BTN", null);
			$Params[13] = new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null);
			$Params[14] = new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null);
			$WS->DrawConfigSlots($WS->WS_Page->PageID, $SlotID,  $Params);
		}

		$SWidth = "";
		$SHeight = "";
		if ($Width != 0)
		{
			$SWidth = "width:" . $Width . ";";
		}
		if ($Height != 0)
		{
			$SHeight = "height:" . $Height . ";";
		}
		if ($UserWidth != "")
		{
			$SWidth = "width:" . $UserWidth . ";";
		}
		if ($UserHeight != "")
		{
			$SHeight = "height:" . $UserHeight . ";";
		}


		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver;" . $SWidth . $SHeight . "\">";
			echo $WS->DrawEditButton($SlotKey, "Slid", "Set Text Slider", "ws_btnedit-t ws_absolute",  $Txt[0]);
		}

		if ($Txt[0] != "")
		{
			if ($Link != ""){echo "<a href=\"" . $Link . "\">";}
			echo "<div style=\"overflow:hidden;" . $SWidth . $SHeight . "\">";
			echo "<div id=\"WS_ImgBack_" . $SlotKey . "\" style=\"" . $SWidth . $SHeight . "\">" . $Txt[0] . "</div>";
			echo "<div id=\"WS_Img_" . $SlotKey . "\" style=\"" . $SWidth . $SHeight . "\">" . $Txt[0] . "</div>";
			echo "<input id=\"WS_ImgNum_" . $SlotKey . "\" type=\"hidden\" value=\"0\">";
			echo "</div>";

			if ($Link != ""){echo "</a>";}

			echo "<script type=\"text/javascript\">\n";
			echo "var WS_Img_" . $SlotKey . " = Array();\n";
			$NC = 0;
			for ($NN = 0; $NN < $MAX_TEXTS; $NN++)
			{

				if ($Txt[$NN] != "")
				{
					$T = str_replace("\r", "", str_replace("\n", "<br/>", $Txt[$NN]));
					echo "WS_Img_" . $SlotKey . "[" . $NC . "] = \"" . $T . "\";\n";
					$NC++;
				}
			}

			if (!$_SESSION["SLOTS_EDIT_MODE"])
			{
				if ($Mode === false){$Mode = "EXCHANGE";}
				
					if ($Mode === true){$Mode = "SHADE";}
				
				if ($UserMode != ""){$Mode = $UserMode;}
				
				if ($Txt[1] != "")
				{
					echo "setTimeout(function () { TranslateImage(\"TXT\",\"WS_ImgNum_" . $SlotKey . "\", WS_Img_" . $SlotKey . ", \"WS_Img_" . $SlotKey . "\",\"WS_ImgBack_" . $SlotKey . "\",\"" . $Mode . "\") }, " . $WS->Timer . ");\n";
					$WS->Timer += 13;
				}
			}
			echo "</script>\n";
		}

		if (!$WS->SlideScript)
		{
			$WS->SlideScript = true;
			echo "<script type=\"text/javascript\" src=\"../Lib/js/Slide.js\"></script>";
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
}
?>
