<?php
trait WS_Tabs
{
	public function Slot_Tabs($SlotID, $Width = "", $Height = "")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $WS->GetSlotKey($SlotID);

		if (filter_input(INPUT_POST, "WS_IN_BtnClear_" . $SlotKey))
		{
			$Slot=$WS->WS_Page->Slots[$SlotKey];
			$WS->SlotDelete($Slot->PageID, $Slot->BodyID, $Slot->SlotID);
			$WS->LoadSlots();
		}

		$WS->ReadInputSlots($WS->WS_Page->PageID, $SlotID,  "TAB");
		
		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Params = array();
			array_push($Params, new WS_ParamDef("Text", "Title:", 80, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param0", "Tab 1:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param1", "Tab 2:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param2", "Tab 3:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param3", "Tab 4:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param4", "Tab 5:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param5", "Tab 6:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param6", "Tab 7:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param7", "Tab 8:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param8", "CSS class:", 80, 1, "CLS",null));  
			array_push($Params, new WS_ParamDef("Update", "Update", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null));
			$this->DrawConfigSlots($this->WS_Page->PageID, $SlotID,  $Params);
		}

		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$Tabs = array();
			$Title = $this->WS_Page->Slots[$SlotKey]->Text;
			for ($N = 0; $N < 8; $N++){$Tabs[$N] = $this->WS_Page->Slots[$SlotKey]->Param[$N];}
			$CssClass = $this->WS_Page->Slots[$SlotKey]->Param[8];
		}
		
		$UserWidth = "100%";
		$UserHeight = "100%";
		$Delay = "0";
		if ($Width != "")
		{
			$UserWidth = $Width;
		}
		if ($Height != "")
		{
			$UserHeight = $Height;
		}

		$SWidth = "";
		$SHeight = "";
		if ($Width != 0)
		{
			$SWidth = "width:" . $Width . ";";
		}
		if ($Height != 0)
		{
			$SHeight = "height:" . $Height . ";";
		}
		if ($UserWidth != "")
		{
			$SWidth = "width:" . $UserWidth . ";";
		}
		if ($UserHeight != "")
		{
			$SHeight = "height:" . $UserHeight . ";";
		}


		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver;" . $SWidth . $SHeight . "\">";
			echo $WS->DrawEditButton($SlotKey, "Slid", "Set Tabs", "ws_btnedit-tab ws_absolute",  "");
		}

		if ((isset($Tabs)) && ($Tabs[0] != ""))
		{
			$Delta = "";

			$WS->IncludeCss("../Lib/Styles/Tabs.css");
			$WS->IncludeScript("../Lib/js/Tabs.js");
			
			// CONTAINER(
			$Index = 0;
			if (isset($_POST[$SlotKey."_index"])) {$Index = $_POST[$SlotKey."_index"];}
			echo "<input type=\"hidden\" name=\"".$SlotKey."_index\" id=\"".$SlotKey."_index\" value=\"".$Index."\">";
			echo "<div class=\"ws_tabs ".$CssClass."\">";

			// IMAGES

			for ($N = 0; $N < 8; $N++) 
			{
				if ($Tabs[$N] != "")
				{
					$Class="ws_tabs_label ";
					if ($N==$Index){$Class.=" ws_tabs_label_active ";}
					
					echo "<div id=\"".$SlotKey."_label_".$N."\" class=\"".$Class."\"  onclick=\"WS_TabsSwitch('".$SlotKey."',".$N.");\" >".$Tabs[$N]."</div>";
				}
			}

			for ($N = 0; $N < 8; $N++) 
			{
				if ($Tabs[$N] != "")
				{
					$Class="ws_tabs_body ";
					if ($N==$Index){$Class.=" ws_tabs_body_active ";}
					
					echo "<div id=\"".$SlotKey."_body_".$N."\" class=\"".$Class."\">";
					$WS->Slot_SubTemplate($SlotKey."_".$N);
					echo "</div>";
				}
			}

			
			// Next and previous buttons
			echo "</div>";
			echo "<div style=\"text-align:center\">";

		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
		echo "<script >ws_slider_showSlides('".$SlotKey."');</script>";
		if (($Delay != "")&&(intval($Delay) > 0))
		{
			echo "<script >ws_slider_setDelay('".$SlotKey."',".(intval($Delay)*1000).");</script>";
		}
	}

}
?>
