<?php

trait WS_Text
{

	public function Slot_TextTitle($SlotID)
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"]))
		{
			return;
		}
		if (!isset($WS->WS_Page->PageID))
		{
			return;
		}
		if ($WS->WSDB == null)
		{
			return;
		}

		$SlotKey = $WS->GetHeaderSlotKey($SlotID);

		$WS->ReadInputSlots(0, $SlotID, "TXT");

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP

		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Params = array();
			$Params[0] = new WS_ParamDef("Text", "Text:", 80, 25, "TXT", null);
			$Params[1] = new WS_ParamDef("Link", "Link:", 80, 1, "TXT", null);
			$Params[2] = new WS_ParamDef("Param0", "CSS Class:", 80, 1, "CLS", null);
			$Params[3] = new WS_ParamDef("Update", "Update", 0, 0, "BTN", null);
			$Params[4] = new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null);
			$Params[5] = new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null);
			$WS->DrawConfigSlots(0, $SlotID, $Params);
		}

		$Link = "";
		$Text = "";
		$CSS = "";
		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Text = $WS->WS_Page->Slots[$SlotKey]->Text;
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver\">";
			echo $WS->DrawEditButton($SlotKey, "Text", "Edit Text", "ws_btnedit-t ws_absolute", $Text);
		}

		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Target = "";
			if ((strpos($Link, "http://") !== false) || (strpos($Link, "https://") !== false))
			{
				$Target = " target=\"_blank\"";
			}
			if ($Link != "")
			{
				echo "<a " . $Target . " href=\"" . $Link . "\">";
			}
			if ($CSS != "")
			{
				echo "<div style=\"display:block\" class=\"" . $CSS . "\">";
			}
			if (strpos($Text, "<br>") === false)
			{
				$Text = str_replace("\r\n", "\n", $Text);
				$Text = str_replace("\n", "<br/>", $Text);
				$Text = str_replace("\r", "<br/>", $Text);
			}
			//$Text = str_replace(" ", "&nbsp;", $Text);
			$Text = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", $Text);
			echo $Text;
			if ($CSS != "")
			{
				echo "</div>";
			}
			if ($Link != "")
			{
				echo "</a>";
			}
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}

	public function Slot_Text($SlotID)
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"]))
		{
			return;
		}
		if (!isset($WS->WS_Page->PageID))
		{
			return;
		}
		if ($WS->WSDB == null)
		{
			return;
		}
		$SlotKey = $WS->GetSlotKey($SlotID);

		$WS->ReadInputSlots($WS->WS_Page->PageID, $SlotID, "TXT");

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Params = array();
			$Params[0] = new WS_ParamDef("Text", "Text:", 80, 25, "TXT", null);
			$Params[1] = new WS_ParamDef("Link", "Link:", 80, 1, "TXT", null);
			$Params[2] = new WS_ParamDef("Param0", "CSS Class:", 80, 1, "CLS", null);
			$Params[3] = new WS_ParamDef("Update", "Update", 0, 0, "BTN", null);
			$Params[4] = new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null);
			$Params[5] = new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null);
			$WS->DrawConfigSlots($WS->WS_Page->PageID, $SlotID, $Params);
		}

		$Link = "";
		$Text = "";
		$CSS = "";
		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $WS->WS_Page->Slots[$SlotKey];
			$CSS = $Slot->Param[0];
			$Text = $Slot->Text;
			$Link = $Slot->Link;
		}

		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver\">";
			echo $WS->DrawEditButton($SlotKey, "Text", "Edit Text", "ws_btnedit-t ws_absolute", $Text);
		}

		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Target = "";
			if ((strpos($Link, "http://") !== false) || (strpos($Link, "https://") !== false))
			{
				$Target = " target=\"_blank\"";
			}
			if ($Link != "")
			{
				echo "<a " . $Target . " href=\"" . $Link . "\">";
			}
			if ($CSS != "")
			{
				echo "<div style=\"display:block\" class=\"" . $CSS . "\">";
			}
			if (strpos($Text, "<br>") === false)
			{
				$Text = str_replace("\r\n", "\n", $Text);
				$Text = str_replace("\n", "<br/>", $Text);
				$Text = str_replace("\r", "<br/>", $Text);
			}
			//$Text = str_replace(" ", "&nbsp;", $Text);
			$Text = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", $Text);
			echo $Text;
			if ($CSS != "")
			{
				echo "</div>";
			}
			if ($Link != "")
			{
				echo "</a>";
			}
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
}

?>