CREATE TABLE `ws_pay` (
  `SiteID` int(11) NOT NULL DEFAULT '1',
  `DT` datetime NOT NULL,
  `TransactionID` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `PayAccount` varchar(100) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `UserID` int(11) NOT NULL DEFAULT '0',
  `Tag` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `Quantity` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Import` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Shipping` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Currency` varchar(3) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `ItemName` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Description` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Success` int(11) NOT NULL DEFAULT '0',
  `Ret_verify_sign` varchar(100) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_txn_type` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_txn_id` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_shipping` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Ret_residence_country` varchar(100) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_quantity` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Ret_protection_eligibility` varchar(50) CHARACTER SET utf8 NOT NULL,
  `Ret_pending_reason` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payment_type` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payment_status` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payment_gross` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Ret_payment_date` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payer_status` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payer_id` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_payer_email` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_notify_version` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_mc_gross` decimal(10,3) NOT NULL DEFAULT '0.000',
  `Ret_mc_currency` varchar(3) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_last_name` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_first_name` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_custom` varchar(20) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_business` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_zip` varchar(20) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_street` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_state` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_name` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_country_code` varchar(3) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Ret_address_city` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`SiteID`,`DT`,`TransactionID`),
  KEY `DT` (`DT`),
  KEY `UserID` (`UserID`),
  KEY `Tag` (`Tag`),
  KEY `PayerEmail` (`Ret_payer_email`),
  KEY `PayerName` (`Ret_last_name`,`Ret_first_name`),
  KEY `PayAccount` (`PayAccount`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
