<?php
$Message = "";

$WS->IncludeScript("../Lib/js/md5.js");
$WS->IncludeScript("../Lib/js/ws_login.js");

// Cancel button
if (isset($_POST['CancelNoScript']))
{
	$_SESSION["LastAccessMM"] = null;
	$_SESSION["LastAccessCount"] = null;
	header("Location: ../Pages/" . $_SESSION["WS_RET_PAG"]);
	exit();
}

// Cancel button
if (isset($_POST['Cancel']))
{
	$_SESSION["LastAccessMM"] = null;
	$_SESSION["LastAccessCount"] = null;
	header("Location: ../Pages/" . $_SESSION["WS_RET_PAG"]);
	exit();
}

// Login Button
if (isset($_POST['UserName']) && isset($_POST['Password']))
{
	$MM = date('m', time());
	if (!isset($_SESSION["LastAccessCount"]))
	{
		$_SESSION["LastAccessCount"] = 0;
	}
	if (!isset($_SESSION["LastAccessMM"]))
	{
		$_SESSION["LastAccessMM"] = $MM;
	}
	if ($_SESSION["LastAccessMM"] == $MM)
	{
		$_SESSION["LastAccessCount"] ++;
		if ($_SESSION["LastAccessCount"] == 5)
		{
			WS_Log::Log("UsrLogin", 0, "Login loop " . $_SERVER["REMOTE_ADDR"]);
			$Message = $WS->Translator->Translate('Wait one minute to retry');
		}
	}

	if ($Message == "")
	{
		$AuthCode = $_POST['AuthCode'];
		if (!WS::CheckAuthCode($AuthCode))
		{
			WS_Log::Log("UsrLogin", 0, "Login fault " . $_SERVER["REMOTE_ADDR"]);
			$Message = $WS->Translator->Translate('Invadid username/password combination');
		}
	}

	if ($Message == "")
	{
		$username = $_POST['UserName'];
		$password = $_POST['Password'];
		if (!empty($username) && !empty($password))
		{
			$User = WS_User::GetUserByName($username);
			if($User==null)
			{
				{$Message = $WS->Translator->Translate('Invadid username/password');}
			}
			if (isset($User->LastAccess) )
			{
				$diff=abs(strtotime(date("Y-m-d h:i:s" )) - strtotime($User->LastAccess));
				if ($diff < 5) 
					{$Message = $WS->Translator->Translate("Too many access at this time, retry later");}
			}
			if($Message=="")
			{
				
				$User->LastAccess = date("Y-m-d h:i:s");
				$User->Update();
			}
			if($Message=="")
			{
				if (!isset($User))
				{
					WS_Log::Log("UsrLogin", 0, "Login wrong usr " . $_SERVER["REMOTE_ADDR"]);
					$Message = $WS->Translator->Translate('Invadid username/password');
				}
				else
				{
					if ($User->Password != $password)
					{
						WS_Log::Log("UsrLogin", 0, "Login wrong pwd " . $_SERVER["REMOTE_ADDR"]);
						$Message = $WS->Translator->Translate('Invadid username/password');
					}
					else
					{
						if ($User->Disabled)
						{
							WS_Log::Log("UsrLogin", 0, "Login disab usr " . $_SERVER["REMOTE_ADDR"]);
							$Message = $WS->Translator->Translate('The user is disabled');
						}
						else
						{
							$_SESSION['USER_ID'] = $User->UserID;
							$_SESSION['USER_NAME'] = $User->UserName;
							$_SESSION['PERMISIONS'] = $User->Permisions;
							$_SESSION['LOGIN_SITE_ID'] = $_SESSION['SITE_ID'];
							$_SESSION["LastAccessMM"] = null;
							$_SESSION["LastAccessCount"] = null;
							WS_Log::Log("UsrLog", $User->UserID, "Success " . $_SERVER["REMOTE_ADDR"]);
							$WSDB->Disconnect();
							ob_start();
							WS_Cookie::Set("USR",$User->UserName);
							WS_Cookie::Set("PWD",$User->Password);
							ob_flush();
							header("Location: ../Pages/" . $_SESSION["WS_RET_PAG"]);
							exit();
						}
					}
				}
			}
		}
	}
}
?>
<link href="../Lib/Styles/ws_private.css" rel="stylesheet" type="text/css"/>
<br/><br/><br/><br/>
<div class="page_block">
	<br/><br/>
	<input type="hidden" name="AuthCode" value="<?php echo WS::GenerateAuthCode(); ?>">
	
	<div class="ws_central ws_text ws_text_big ws_bordered  ws_padd_5" style="width:700px;color:red" id="no_script" >
		Script is not allowed on your browser, can't login<br/><br/>
		<input class="ws_button ws_button_big ws_central" name="CancelNoScript" type="submit" value="<?php echo $WS->Translator->Translate("Cancel") ?>">
	</div>
	<div id="yes_script" class="ws_tab ws_txt-right ws_central ws_hidden">
		<div class="ws_row">
			<div class="ws_text ws_text_big ws_cell ws_padd_5">
				<?php echo $WS->Translator->Translate("User Name") ?>: 
			</div>
			<div class="ws_cell ws_padd_5">	
				<input class="ws_text ws_text_big ws_padd_5" type="text" id="UserName" name="UserName" style="width:250px"> 
			</div>
		</div>
		<div class="ws_row">
			<div class="ws_text ws_text_big ws_cell ws_padd_5">
				<?php echo $WS->Translator->Translate("Password") ?>: 
			</div>
			<div class="ws_cell ws_margin_0 ws_padd_5">
				<div style="position:relative;">
					<input type="text" id="Bullets" class="ws_text ws_text_big ws_padd_5" autocomplete="off" style="width:250px"
							onkeydown="ManageInput('Bullets','Password');" 
							onfocus="document.getElementById('Bullets').style.borderWidth='2.5px';" 
							onfocusout="document.getElementById('Bullets').style.borderWidth='1px';"/>
					<input  id="Password" name="Password" type="hidden"  />
				</div>
			</div>	  
		</div>
		<div class="ws_row">
			<div></div>
			<div class="ws_cell ws_margin_10">
				<br/><input class="ws_button ws_button_big" name="Login" type="submit" value="<?php echo $WS->Translator->Translate("Log in") ?>" onclick="CryptPwd('Password');">
				<input class="ws_button ws_button_big" name="Cancel" type="submit" value="<?php echo $WS->Translator->Translate("Cancel") ?>">
			</div>	  
		</div>

		<div class="ws_row">
			<div style="color:red" class="ws_text ws_text_big ws_cell" >
				<br/>
				<?php echo $Message ?>
				<br/>
			</div>
		</div>

		<div class="ws_row">
			<div  class="ws_cell"></div>
			<div class="ws_text ws_text_big ws_cell">
				<br/>
				<?php 
				$Reg = WS_Property::GetText('Registration', 'Enable');
				if ( ($Reg=="1") || ($Reg==strtolower("true")))
				{
					echo "<a href=\"../SysPages/SysBase.php?P=Register\">". $WS->GetTranslation("Register")."</a>";
				}
				?>
			</div>
		</div>

		<div class="ws_row">
			<div  class="ws_cell"></div>
			<div  class="ws_text ws_text_big ws_cell">
				<br/>
				<a href="../SysPages/SysBase.php?P=RecoverPwd"><?php echo $WS->Translator->Translate("Recover your pasword") ?></a>
			</div>
		</div>
	</div>
	<script>
		$("#no_script").css("display","none");
		$("#yes_script").css("display","table");
	</script>
	<div style="height:800px"/>
</div>
<script type="text/javascript" src="../Lib/js/md5.js"></script>
<script type="text/javascript"  src="../Lib/js/ws_login.js"></script>
<?php
$WSDB->Disconnect();
?>