<div class="page_block">
<br/>
<?php
include "../Lib/TableListView.php";

$Message = "";
$_SESSION["WS_RET_PAG"] = "../SysPages/SysBase.php?P=ManageUsers";

// Cancel button
if(isset($_POST['btnBack']))
{
	header("Location: ".WS_Page::GetStartPage()->GetPageLink());
	exit();
}

if (isset($_POST['btnClearCCEncode']))
{
	WS::$WSBase->ClearCCEncode();
}

if (isset($_POST['btnDelete']))
{
	$User = WS_User::GetUserByID($_POST["txtUserID"]);
	$User->Delete();
	$Message = 'User removed';
	ws_Log::Log("UsrDel",$_SESSION["USER_ID"],"");
}

if(isset($_POST['btnChangePermision']))
{
	$User = WS_User::GetUserByID($_POST["txtUserID"]);
	$User->Permisions = $_POST["txtPermision"];
	$User->Update();
	$Message = 'User permision updated';
	ws_Log::Log("UsrUpd",$_SESSION["USER_ID"],"");
}

if(isset($_POST['btnChangePwd']))
{
	$User = WS_User::GetUserByID($_POST["txtUserID"]);
	$User->Password = md5($_POST["txtPassword"]);
	$User->Update();
	$Message = 'User password updated';
	ws_Log::Log("UsrUpd",$_SESSION["USER_ID"],"Change Pwd");
}

// QUERY USERS
$Sql = "SELECT UserID,UserName,FirstName ,LastName,Email,Permisions,Disabled as Disab,RegistrationDT as '".$WS->GetTranslation("Registration Date")."' from ws_users";
$Search = "";
if (isset($_POST["txtSearch"]) && ($_POST["txtSearch"] != ""))
{
	$Search = $_POST["txtSearch"];
	$Sql .= " where UserName like '%".$Search."%' or FirstName like '%".$Search."%' or LastName like '%".$Search."%' or Email like '%".$Search."%' ";
}
$Sql .= " order by UserName";

// CREATE BUTTONS ARRAY FOR THE TABLE
$Buttons = array
(
	new TableListViewerButton("EditUser", $WS->GetTranslation("Edit")),
	new TableListViewerButton("ChangePwd", $WS->GetTranslation("Change password")),
	new TableListViewerButton("Login", $WS->GetTranslation("Impersonate")),
	new TableListViewerButton("Permision", $WS->GetTranslation("Permision")),
	new TableListViewerButton("Disab", "Disab/Enab"),
	new TableListViewerButton("Delete", $WS->GetTranslation("Del."))
);

// CREATE TABLE VIEWER
$TV = new TableListViewer($WS->WSDB,$Sql,$Buttons);
//$TV->CssClassTable = "Tab";

// MANAGE BUTTONS RESPONSE
if (isset($TV->SelectedButton))
{
	if ($TV->SelectedButton->Name=="Permision")
	{
		$InnerCode = "<input name=\"txtUserID\" type=\"hidden\" value=\"".$TV->SelectedArgs["UserID"]."\"><br/>";
		$InnerCode.= "&nbsp;User Name<br/><input disabled name=\"txtUserName\" size=\"25\" type=\"text\" value=\"".$TV->SelectedArgs["UserName"]."\"><br/>";
		$InnerCode.= "&nbsp;First Name<br/><input disabled name=\"txtFirstName\" size=\"50\" type=\"text\" value=\"".$TV->SelectedArgs["FirstName"]."\"><br/>";
		$InnerCode.= "&nbsp;Last Name<br/><input disabled name=\"txtLastName\" size=\"50\" type=\"text\" value=\"".$TV->SelectedArgs["LastName"]."\"><br/>";
		$InnerCode.= "&nbsp;Permision<br/><input name=\"txtPermision\" size=\"25\" maxlenth=\"25\" type=\"text\" value=\"".$TV->SelectedArgs["Permisions"]."\"><br/><br/>";
		$InnerCode.= "<input class=\"ws_button\" name=\"btnChangePermision\" type=\"submit\" value=\"Set permision\"> ";
		$InnerCode.= "<input class=\"ws_button\" name=\"btnCancel\" type=\"submit\" value=\"Cancel\">";
		$WS->SetPopup($InnerCode,"400px","250px");
	}
	
	if ($TV->SelectedButton->Name=="Delete")
	{
		$InnerCode = "<input name=\"txtUserID\" type=\"hidden\" value=\"".$TV->SelectedArgs["UserID"]."\"><br/>";
		$InnerCode.= "&nbsp;User Name<br/><input disabled name=\"txtUserName\" size=\"25\" type=\"text\" value=\"".$TV->SelectedArgs["UserName"]."\"><br/>";
		$InnerCode.= "&nbsp;First Name<br/><input disabled name=\"txtFirstName\" size=\"50\" type=\"text\" value=\"".$TV->SelectedArgs["FirstName"]."\"><br/>";
		$InnerCode.= "&nbsp;Last Name<br/><input disabled name=\"txtLastName\"  size=\"50\" type=\"text\" value=\"".$TV->SelectedArgs["LastName"]."\"><br/><br/>";
		$InnerCode.= "<input class=\"ws_button\" name=\"btnDelete\" type=\"submit\" value=\"Delete user\"> ";
		$InnerCode.= "<input class=\"ws_button\" name=\"btnCancel\" type=\"submit\" value=\"Cancel\">";
		$WS->SetPopup($InnerCode,"400px","250px");
	}
	
	if ($TV->SelectedButton->Name=="ChangePwd")
	{
		$InnerCode = "<input name=\"txtUserID\" type=\"hidden\" value=\"".$TV->SelectedArgs["UserID"]."\"><br/>";
		$InnerCode.= "&nbsp;User Name<br/><input disabled name=\"txtUserName\" size=\"25\" type=\"text\" value=\"".$TV->SelectedArgs["UserName"]."\"><br/>";
		$InnerCode.= "&nbsp;First Name<br/><input disabled name=\"txtFirstName\" size=\"50\" type=\"text\" value=\"".$TV->SelectedArgs["FirstName"]."\"><br/>";
		$InnerCode.= "&nbsp;Last Name<br/><input disabled name=\"txtLastName\" size=\"50\" type=\"text\" value=\"".$TV->SelectedArgs["LastName"]."\"><br/>";
		$InnerCode.= "&nbsp;New Password<br/><input name=\"txtPassword\" maxlenth=\"45\" size=\"45\" type=\"text\" value=\"\"><br/><br/>";
		$InnerCode.= "<input name=\"btnChangePwd\" type=\"submit\" value=\"Change password\"> ";
		$InnerCode.= "<input name=\"btnCancel\" type=\"submit\" value=\"Cancel\">";
		$WS->SetPopup($InnerCode,"400px","250px");
	}
	
	if ($TV->SelectedButton->Name=="Login")
	{
		$User = WS_User::GetUserByID($TV->SelectedArgs["UserID"]);
		if(isset($User))
		{
			$_SESSION['USER_ID'] = $User->UserID;
			$_SESSION['USER_NAME'] = $User->UserName." (imperson)";
			$_SESSION['PERMISIONS'] = $User->Permisions;
			$_SESSION['LOGIN_SITE_ID'] = $_SESSION['SITE_ID'];
			$_SESSION['IMPERSON']=true;
		}
		
		header("Location: ".WS_Page::GetStartPage()->GetPageLink());
		exit();
	}
	
	if ($TV->SelectedButton->Name=="Disab")
	{
		$User = WS_User::GetUserByID($TV->SelectedArgs["UserID"]);
		
		if ($User->Disabled)
			{$User->Disabled = false;}
		else
			{$User->Disabled = true;}
		$User->Update();
	}
	
	if ($TV->SelectedButton->Name=="EditUser")
	{
		$_SESSION["MOD_USER_ID"] = $TV->SelectedArgs["UserID"];
		ws_Log::Log("UsrUpd",$_SESSION["USER_ID"],"Edit User");
		header("Location: ../SysPages/SysBase.php?P=EditUser");
	}
	
	$TV->Requery();
}

//$TV->CssClassTable="Tab";
$TV->CssClassTable = "wd_grid_table";
$TV->CssClassHeader = "wd_grid_header";
$TV->CssClassRow = "ws_grid_row";
$TV->CssClassAlternateRow = "ws_grid_alternate_row";
$TV->CssClassPagerButtons = "ws_grid_pager_buttons";
$TV->CssClassButton="ws_grid_button";
$TV->ColsWidth=array("","","","","","","","","50px","50px","50px","50px");
$TV->ColsVisibility=array(false,true,true,true,true,true,true,true,true,true);

	
echo "<div style=\"margin:auto;width:700px\">";
echo "<input class=\"ws_text_big\" name=\"txtSearch\" size=\"40\" type=\"text\" value=\"\">";
echo "&nbsp;<input class=\"ws_button\" name=\"btnSearch\" type=\"submit\" value=\"".$WS->GetTranslation("Search")."\">";
echo "</div><br/>";
echo "<div style=\"margin:auto;display:table;min-height:60%;padding-top:0px;font-size:12px\">";
$TV->Draw();
echo "</div><br/><br/>";  
?>

	<br/>
	<div style="width:600px;margin:auto;color:red">
		
		<input class="ws_button" name="btnNewUser" type="button" value="<?php $WS->Translate("New user"); ?>" onclick="window.location.href='../SysPages/SysBase.php?P=Register';" >
		<input class="ws_button" name="btnClearCCEncode" type="submit" value="<?php $WS->Translate("Clear registration codes"); ?>" onclick="return confirm('<?php $WS->Translate("Are you sure to clear the registration codes");?>');">
		<input class="ws_button" name="btnBack" type="submit" value="<?php $WS->Translate("Back"); ?>">
		<br/>
	</div>
	<br/>
	<div style="width:400px;margin:auto;color:red;min-height:400px">
		<?php echo $Message?>
	</div>
	<br/><br/>
</div>
