<?php
class WS_Log
{
	public $UserID=0;
	public $DT;
	public $Group;
	public $NumKey;
	public $Note;

	public function __construct($Group,$NumKey=0,$Note="")
	{
		if ((isset($_SESSION["USER_ID"])) && ($_SESSION["USER_ID"]!="")) {$this->UserID = $_SESSION["USER_ID"];}
		$this->DT=new DateTime();
		$this->Group=$Group;
		$this->NumKey=$NumKey;
		$this->Note=$Note;
	}
	
	public function Update()
	{
            try
            {
		$Sql="insert into ws_logs (UserID,DT,Grp,NumKey,Note) values (".$this->UserID.",'".$this->DT->format('Y-m-d H:i:s.u')."','".$this->Group."',".$this->NumKey.",'".$this->Note."')"; 
		WS::$WSBase->WSDB->query($Sql);
            }
            catch (Exception $ex) 
            {}
	}
	
	public static function Clear($DaysDelay,$Group="")
	{
		$WSDB=WS::$WSBase->WSDB;
		$Sql="delete from ws_logs where DT < DATE_SUB(NOW(),INTERVAL (-".$DaysDelay.") DAY)"; 
		if ($Group!="") {$Sql.=" and Grp='".$Group."'";}
		$WSDB->query($Sql);
	}
	
	public static function Log($Group,$NumKey=0,$Note="")
	{
		$L = new WS_Log($Group,$NumKey,$Note,$WSDB=null);
		$L->Update();
	}

	public static function QueryCount($FromDT=null,$ToDT=null,$UserID=null,$Group=null,$NumKey=null,$Note=null)
	{
		$WSDB=WS::$WSBase->WSDB;
		$Sql="select Count(*) as C from ws_logs where 1=1"; 
		if (isset($FromDT)) {$Sql.=" and DT>='".$FromDT."'";}
		if (isset($ToDT)) {$Sql.=" and DT<='".$ToDT."'";}
		if (isset($User)) {$Sql.=" and UserID=".$UserID;}
		if (isset($Group)) {$Sql.=" and Grp='".$Group."'";}
		if (isset($NumKey)) {$Sql.=" and NumKey=".$NumKey;}
		if (isset($Note)) {$Sql.=" and Note like'%".$Note."%'";}
		$Sql.= " ".$GroupBy;
		$result = $WSDB->query($Sql);
		$row = $result->fetch_assoc();
		return $row["C"];
	}
}