var WS_Map_Base = null;

class WS_Map
{
	BingMap = null;
	Pointer = null;
	ContainerLatID = "";
	ContainerLngID = "";
	ContainerZoomID = "";
	Lat = 45.46;
	Lng = 9.18;
	Zoom = 12;
	
	constructor(ContainerID,ContainerLatID,ContainerLngID,ContainerZoomID,BingKey)
	{
		if (BingKey == "") BingKey = 'AlXzXsRRCFDn_dgcpH-sCUEDYaZ6WKGCxne5vsCfMADGhFba7uv86PfWQkhugsmj';
		this.ContainerLatID = ContainerLatID;
		this.ContainerLngID = ContainerLngID;
		this.ContainerZoomID = ContainerZoomID;

		this.BingMap = new Microsoft.Maps.Map('#'+ContainerID, {credentials: BingKey});

		if ((this.ContainerLatID!="") && (this.ContainerLngID!=""))
		{
			if (this.get_zoom() != "") this.Zoom = this.get_zoom();
			if (($("#"+this.ContainerLatID).val() != "") && ($("#"+this.ContainerLngID).val() != ""))
			{
				this.Lat = this.get_latitude();
				this.Lng = this.get_longitude();
				
				this.Pointer = this.add_pointer(this.Lat,this.Lng);
			}
		}
		this.move_map(this.Lat,this.Lng,this.Zoom);
		WS_Map_Base = this;
	}

	enable_edit()
	{
		Microsoft.Maps.Events.addHandler(this.BingMap, 'click', this.handler);
	}
	
	get_latitude()
	{
		return $("#"+this.ContainerLatID).val();
	}
	
	get_longitude()
	{
		return $("#"+this.ContainerLngID).val();
	}

	get_zoom()
	{
		return $("#"+this.ContainerZoomID).val();
	}

	set_fields_lat_lng(Lat,Lng,Zoom)
	{
		if (this.ContainerZoomID!="") this.ContainerZoomID = Zoom;
		if ((this.ContainerLatID!="") && (this.ContainerLngID!=""))
		{
			$("#"+this.ContainerLatID).val(Lat);
			$("#"+this.ContainerLngID).val(Lng);
			return true;
		}
		return false;
	}
	
	move_pointer(Pointer,Lat,Lng)
	{
		var loc = new Microsoft.Maps.Location(Lat,Lng);
		Pointer.setLocation(loc);
	}

	move_map(Lat,Lng,Zoom)
	{
		this.Lat = Lat;
		this.Lng = Lng;
		var Map = this.BingMap;
		Map.setView(
		{
			center: new Microsoft.Maps.Location(Lat, Lng),
			zoom: Zoom
		});
	}

	add_pointer(Lat,Lng)
	{
		var loc = new Microsoft.Maps.Location(Lat,Lng);
		var Pin = new Microsoft.Maps.Pushpin(loc);
		var Map = this.BingMap;
		Map.entities.push(Pin);
		return Pin;
	}
	
	map_remove_pointer(Pointer)
	{
		this.Map.entities.remove(Pointer);
	}

	goto_address(address,zoom) 
	{

	}
	
	handler(e)
	{
		if (e.targetType == "map")
		{
			var point = new Microsoft.Maps.Point(e.getX(), e.getY());
			var loc = e.target.tryPixelToLocation(point);
			WS_Map_Base.Lat = loc.latitude;
			WS_Map_Base.Lng = loc.longitude;
			WS_Map_Base.set_fields_lat_lng(WS_Map_Base.Lat,WS_Map_Base.Lng,WS_Map_Base.BingMap.getZoom());
			
			if (WS_Map_Base.Pointer === null)
				WS_Map_Base.Pointer = WS_Map_Base.add_pointer(WS_Map_Base.Lat,WS_Map_Base.Lng);
			else
				WS_Map_Base.move_pointer(WS_Map_Base.Pointer,WS_Map_Base.Lat,WS_Map_Base.Lng);
		}
	}
}