<?php

trait WS_Background
{

	public function Slot_BackgroundSetButton($SlotID)
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"]))
		{
			return;
		}
		if (!isset($WS->WS_Page->PageID))
		{
			return;
		}
		if ($WS->WSDB == null)
		{
			return;
		}

		$SlotKey = $WS->GetSlotKey($SlotID);
		$PageID = $WS->WS_Page->PageID;

		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo $WS->DrawEditButton($SlotKey, " ", "Edit Background Color", "ws_btnedit-co", "");
		}

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Params = array();
			$Params[0] = new WS_ParamDef("Param0", "Back Color:", 80, 1, "COL", "");
			$Params[1] = new WS_ParamDef("Param1", "Shades color:", 80, 1, "COL", "");

			$Values2 = array();
			$Values2[0] = "top";
			$Values2[1] = "left";
			$Values2[2] = "right";
			$Values2[3] = "bottom";
			$Values2[4] = "top Left";
			$Values2[5] = "top right";
			$Params[2] = new WS_ParamDef("Param2", "Shades Orientation:", 100, 1, "DDL", $Values2);

			$Values3 = array();
			$Values3[0] = "none";
			$Values3[1] = "20%";
			$Values3[2] = "45%";
			$Values3[3] = "50%";
			$Values3[4] = "75%";
			$Values3[5] = "100%";
			$Params[3] = new WS_ParamDef("Param3", "Shades Start %:", 100, 1, "DDL", $Values3);

			$Values4 = array();
			$Values4 = $WS->GetMediaNames();
			array_unshift($Values4, "no-image");
			$Params[4] = new WS_ParamDef("Param4", "Image:", 100, 1, "DDL", $Values4);

			$Values5 = array();
			$Values5[0] = "none";
			$Values5[1] = "no-repeat";
			$Values5[2] = "repeat-x";
			$Values5[3] = "repeat-y";
			$Values5[4] = "repeat";
			$Params[5] = new WS_ParamDef("Param5", "Image Repeat:", 100, 1, "DDL", $Values5);

			$Values6 = array();
			$Values6[0] = "none";
			$Values6[1] = "auto";
			$Values6[2] = "cover";
			$Values6[3] = "contain";
			$Values6[4] = "100% auto";
			$Values6[5] = "100% 150px";
			$Values6[6] = "100% 200px";
			$Values6[7] = "100% 250px";
			$Values6[8] = "100% 300px";
			$Values6[9] = "100% 350px";
			$Values6[10] = "100% 400px";
			$Values6[11] = "initial";
			$Params[6] = new WS_ParamDef("Param6", "Image Cover:", 100, 1, "DDL", $Values6);

			$Params[7] = new WS_ParamDef("Update", "Update", 0, 0, "BTN", null);
			$Params[8] = new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null);
			$Params[9] = new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null);

			$WS->DrawConfigSlots($PageID, $SlotID, $Params);
		}
	}

	public function Slot_BackgroundSet($SlotID)
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"]))
		{
			return;
		}
		if (!isset($WS->WS_Page->PageID))
		{
			return;
		}
		if ($WS->WSDB == null)
		{
			return;
		}

		$PageID = $WS->WS_Page->PageID;
		$SlotKey = $WS->GetSlotKey($SlotID);

		$WS->ReadInputSlots($PageID, $SlotID, "COL");

		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Style = " style=\"";
			if ($WS->WS_Page->Slots[$SlotKey]->Param[0] != "")
			{
				if ($WS->WS_Page->Slots[$SlotKey]->Param[0] == "transparent")
				{
					$Style .= "background-color:transparent;";
				}
				else
				{
					$Style .= "background-color:" . $WS->WS_Page->Slots[$SlotKey]->Param[0] . ";";
				}
			}
			if (($WS->WS_Page->Slots[$SlotKey]->Param[0] != "") && ($WS->WS_Page->Slots[$SlotKey]->Param[0] != $WS->WS_Page->Slots[$SlotKey]->Param[1]) && ($WS->WS_Page->Slots[$SlotKey]->Param[3] != "none"))
			{
				$Style .= "background: linear-gradient(to " . $WS->WS_Page->Slots[$SlotKey]->Param[2] . "," . $WS->WS_Page->Slots[$SlotKey]->Param[0] . " 0%," . $WS->WS_Page->Slots[$SlotKey]->Param[1] . "  " . $WS->WS_Page->Slots[$SlotKey]->Param[3] . ");";
			}

			if ($WS->WS_Page->Slots[$SlotKey]->Param[4] != "no-image")
			{
				$Style .= "background-image:url(../Media/" . $WS->WS_Page->Slots[$SlotKey]->Param[4] . ");";

				if ($WS->WS_Page->Slots[$SlotKey]->Param[5] != "none")
				{
					$Style .= "background-repeat:" . $WS->WS_Page->Slots[$SlotKey]->Param[5] . ";";
				}

				if ($WS->WS_Page->Slots[$SlotKey]->Param[6] != "none")
				{
					$Style .= "background-size:" . $WS->WS_Page->Slots[$SlotKey]->Param[6] . ";";
				}
			}
			$Style .= "\"";

			echo $Style;
		}
	}
}

?>