<?php
trait WS_Map
{
	public function Slot_Map($SlotID, $Width = "100px", $Height = "100px", $Latitude = "", $Longitude = "")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$PageID = $WS->WS_Page->PageID;
		$SlotKey = $WS->GetSlotKey($SlotID);

		$WS->ReadInputSlots($PageID, $SlotID,  "MAP");

		$Lat = "45.466";
		$Lon = "9.199";
		if ($Latitude != "")
		{
			$Lat = $Latitude;
		}
		if ($Longitude != "")
		{
			$Lon = $Longitude;
		}

		$Zoom = "14";

		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$P0 = $WS->WS_Page->Slots[$SlotKey]->Param[0];
			$P1 = $WS->WS_Page->Slots[$SlotKey]->Param[1];
			$Zoom = $WS->WS_Page->Slots[$SlotKey]->Param[2];
			if ($WS->WS_Page->Slots[$SlotKey]->Param[3] != ""){$Width=$WS->WS_Page->Slots[$SlotKey]->Param[3];}
			if ($WS->WS_Page->Slots[$SlotKey]->Param[4] != ""){$Height=$WS->WS_Page->Slots[$SlotKey]->Param[4];}
			if ($P0 != "")
			{
				$Lat = $P0;
			}
			if ($P1 != "")
			{
				$Lon = $P1;
			}
		}

		if (!in_array("..\Lib\js\Map.js",$WS->ScriptList))
		{
			echo "<script type='text/javascript' src='http://www.bing.com/api/maps/mapcontrol?callback=GetMap' async defer></script>";
			$WS->IncludeScript("..\Lib\js\Map.js");
		}
		
		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Pop = "";
			$Pop .= "<div style=\"background-color:silver;width:390px;height:280px\" id=\"maped_".$SlotKey."\"></div>";
			$Pop .= "<br/><table><tr><td>&nbsp;Latitude:</td><td><input id=\"txtLat\" name=\"WS_IN_Param0_" . $SlotKey . "\" type=\"text\" size=\"20\"  value=\"" . $Lat . "\"/></td></tr><tr>";
			$Pop .= "<td>&nbsp;Longitude:</td><td><input id=\"txtLng\" name=\"WS_IN_Param1_" . $SlotKey . "\" type=\"text\" size=\"20\"  value=\"" . $Lon . "\"/></td></tr><tr>";
			$Pop .= "<td>&nbsp;Zoom:</td><td><input id=\"txtZoom\" name=\"WS_IN_Param2_" . $SlotKey . "\" type=\"text\" size=\"5\"  value=\"" . $Zoom . "\"/></td></tr>";
			$Pop .= "<td>&nbsp;Width:</td><td><input name=\"WS_IN_Param3_" . $SlotKey . "\" type=\"text\" size=\"5\"  value=\"" . $Width . "\"/></td></tr>";
			$Pop .= "<td>&nbsp;Height:</td><td><input name=\"WS_IN_Param4_" . $SlotKey . "\" type=\"text\" size=\"5\"  value=\"" . $Height . "\"/></td></tr></table>";
			$Pop .= "<input class=\"ws_button\" name=\"WS_IN_BtnUpdate_" . $SlotKey . "\" type=\"submit\" value=\"Update\" />";
			$Pop .= "&nbsp;<input class=\"ws_button\" name=\"WS_IN_BtnClear_" . $SlotKey . "\" type=\"submit\" value=\"Clear\" />";
			$Pop .= "&nbsp;<input class=\"ws_button\" name=\"WS_IN_BtnCancel_" . $SlotKey . "\" type=\"submit\" value=\"Cancel\" />";
			
			$Pop .=  "<script type=\"text/javascript\" >";
			$Pop .=  "function GetMap() {\n";
			$Pop .=  "var Map_" . $SlotKey . " = new WS_Map('maped_".$SlotKey."','txtLat','txtLng','txtZoom','');\n";
			$Pop .=  "Map_" . $SlotKey . ".enable_edit();";
			$Pop .=  "}\n";
			$Pop .=  "GetMap();\n";
			$Pop .=  "</script>";
			$WS->SetPopup($Pop, "400px", "500px");
		}

		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver\">";
			echo $WS->DrawEditButton($SlotKey, "Map", "Edit Geo-Location Map", "ws_btnedit-mp ws_absolute",  $Latitude);
		}


		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$SWidth = "";
			$SHeight = "";
			if ($Width != ""){$SWidth = "width:" . $Width . ";";}
			if ($Height != ""){$SHeight = "height:" . $Height . ";";}

			echo "<input type=\"hidden\" id=\"MapLatitude\" name=\"MapLatitude\" value=\"" . $Lat . "\">";
			echo "<input type=\"hidden\" id=\"MapLongitude\" name=\"MapLongitude\" value=\"" . $Lon . "\">";
			echo "<input type=\"hidden\" id=\"MapZoom\" name=\"MapZoom\" value=\"" . $Zoom . "\">";
			echo "<div style=\"" . $SWidth . $SHeight . "\" id=\"map_" . $SlotKey . "\"></div>";
			echo "<script type=\"text/javascript\" >";
			echo "function GetMap() {\n";
			echo "var Map_" . $SlotKey . " = new WS_Map('map_".$SlotKey."','MapLatitude','MapLongitude','MapZoom','');\n";
			echo "}\n";
			echo "GetMap();\n";
			echo "</script>";
		}

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
		

	}
}
?>