<?php
trait WS_PayPal
{
	public function Slot_PayPal($SlotID, $Tag = "", $ItemNum = 1, $ItemName = "", $Currency = "EUR", $Import = "0.00", $Shipping = "0.00", $Testing = "0", $PayPalAccount = "")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$PageID = $WS->WS_Page->PageID;
		$SlotKey = $WS->GetSlotKey($SlotID);

		$WS->ReadInputSlots($PageID, $SlotID, 0, "INP");

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
//			$P = array();
//			$P[0] = "Pay Mode";
//			$P[1] = "Test Mode";
			$Params = array();
			$Params[0] = new WS_ParamDef("Text", "Description:", 30, 1, "TXT", null);
			$Params[1] = new WS_ParamDef("Param0", "Item num:", 20, 1, "TXT", null, "1");
			$Params[2] = new WS_ParamDef("Param1", "Item desc:", 20, 1, "TXT", null);
			$Params[3] = new WS_ParamDef("Param2", "Currency: ", 3, 1, "TXT", null, "EUR");
			$Params[4] = new WS_ParamDef("Param3", "Import:", 10, 1, "TXT", null, "1.00");
			$Params[5] = new WS_ParamDef("Param4", "Shipping:", 10, 1, "TXT", null, "0.00");
			$Params[6] = new WS_ParamDef("Param5", "Testing Mode:", 5, 1, "BOOL", null, "False");
			$Params[7] = new WS_ParamDef("Param6", "Account Email:", 40, 1, "TXT", null, WS_Property::GetText('PayPal', 'AccountEmail'));
			$Params[8] = new WS_ParamDef("Update", "Update", 0, 0, "BTN", null);
			$Params[9] = new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null);
			$Params[10] = new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null);
			$WS->DrawConfigSlots($PageID, $SlotID, 0, $Params);
		}

		$Text = "";  // LOAD FROM DB 
		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			if (!empty($WS->WS_Page->Slots[$SlotKey]->Text))
			{
				$Text = $WS->WS_Page->Slots[$SlotKey]->Text;
			}

			if (!empty($WS->WS_Page->Slots[$SlotKey]->Param[0]))
			{
				$ItemNum = $WS->WS_Page->Slots[$SlotKey]->Param[0];
			}

			if (!empty($WS->WS_Page->Slots[$SlotKey]->Param[1]))
			{
				$ItemName = $WS->WS_Page->Slots[$SlotKey]->Param[1];
			}

			if (!empty($WS->WS_Page->Slots[$SlotKey]->Param[2]))
			{
				$Currency = $WS->WS_Page->Slots[$SlotKey]->Param[2];
			}

			if (!empty($WS->WS_Page->Slots[$SlotKey]->Param[3]))
			{
				$Import = $WS->WS_Page->Slots[$SlotKey]->Param[3];
			}

			if (!empty($WS->WS_Page->Slots[$SlotKey]->Param[4]))
			{
				$Shipping = $WS->WS_Page->Slots[$SlotKey]->Param[4];
			}

			if (!empty($WS->WS_Page->Slots[$SlotKey]->Param[5]))
			{
				$Testing = $WS->WS_Page->Slots[$SlotKey]->Param[5];
			}

			if (!empty($WS->WS_Page->Slots[$SlotKey]->Param[6]))
			{
				$PayPalAccount = $WS->WS_Page->Slots[$SlotKey]->Param[6];
			}
		}

		$PageUrl = (isset($_SERVER['HTTPS']) ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
		$Pg = WS_Page::GetPageName();

		if (filter_input(INPUT_POST, "WS_BtnClose"))
		{
			$TransactionID = filter_input(INPUT_GET, "WS_TransactionID");
			$Pay = WS_Pay::GetByTansactionID($TransactionID);
			$Url = $PageUrl;
			$Url = str_replace("?WS_PayResult=0", "", $Url);
			$Url = str_replace("?WS_PayResult=" . $Pay->Success, "", $Url);
			$Url = str_replace("&WS_TransactionID=" . $TransactionID, "", $Url);
			echo "<input type=\"hidden\" name=\"TransactionID=\" value=\"" . $TransactionID . "\">";
			header("Location: " . $Url);
			exit();
		}

		if ((filter_input(INPUT_GET, "WS_TransactionID")) && (empty(filter_input(INPUT_POST, "WS_BtnClose"))))
		{
			$TransactionID = filter_input(INPUT_GET, "WS_TransactionID");

			$Pay = WS_Pay::GetByTansactionID($TransactionID);

			$Url = $PageUrl;
			if (filter_input(INPUT_GET, "WS_PayResult") == "1")
			{
				$Pop = "<br/><br/><div style=\"text-align:center\">Payment succesfull<br/><br/>";
				$Pop .= "<input class=\"ws_button\" name=\"WS_BtnClose\" type=\"submit\" value=\"Close\"/>";
				$WS->SetPopup($Pop, "250px", "150px");

				$Pay->Success = 1;
				$Pay->Ret_verify_sign = filter_input(INPUT_POST, "verify_sign");
				$Pay->Ret_txn_type = filter_input(INPUT_POST, "txn_type");
				$Pay->Ret_txn_id = filter_input(INPUT_POST, "txn_id");
				$Pay->Ret_shipping = filter_input(INPUT_POST, "shipping");
				$Pay->Ret_residence_country = filter_input(INPUT_POST, "residence_country");
				$Pay->Ret_quantity = filter_input(INPUT_POST, "quantity");
				$Pay->Ret_protection_eligibility = filter_input(INPUT_POST, "protection_eligibility");
				$Pay->Ret_pending_reason = filter_input(INPUT_POST, "pending_reason");
				$Pay->Ret_payment_type = filter_input(INPUT_POST, "payment_type");
				$Pay->Ret_payment_status = filter_input(INPUT_POST, "payment_status");
				$Pay->Ret_payment_gross = filter_input(INPUT_POST, "payment_gross");
				$Pay->Ret_payment_date = filter_input(INPUT_POST, "payment_date");
				$Pay->Ret_payer_status = filter_input(INPUT_POST, "payer_status");
				$Pay->Ret_payer_id = filter_input(INPUT_POST, "payer_id");
				$Pay->Ret_payer_email = filter_input(INPUT_POST, "payer_email");
				$Pay->Ret_notify_version = filter_input(INPUT_POST, "notify_version");
				$Pay->Ret_mc_gross = filter_input(INPUT_POST, "mc_gross");
				$Pay->Ret_mc_currency = filter_input(INPUT_POST, "mc_currency");
				$Pay->Ret_last_name = filter_input(INPUT_POST, "last_name");
				$Pay->Ret_first_name = filter_input(INPUT_POST, "first_name");
				$Pay->Ret_custom = filter_input(INPUT_POST, "custom");
				$Pay->Ret_business = filter_input(INPUT_POST, "business");
				$Pay->Ret_address_zip = filter_input(INPUT_POST, "address_zip");
				$Pay->Ret_address_street = filter_input(INPUT_POST, "address_street");
				$Pay->Ret_address_state = filter_input(INPUT_POST, "address_state");
				$Pay->Ret_address_name = filter_input(INPUT_POST, "address_name");
				$Pay->Ret_address_country_code = filter_input(INPUT_POST, "address_country_code");
				$Pay->Ret_address_city = filter_input(INPUT_POST, "address_city");

				$Pay->Update();
			}
			else
			{
				$Pop = "<br/><br/><div style=\"text-align:center\">Payment failed<br/><br/>";
				$Pop .= "<input class=\"ws_button\" name=\"WS_BtnClose\" type=\"submit\" value=\"Close\"/>";
				$Pop .= "</div>";
				$WS->SetPopup($Pop, "250px", "150px");
			}
		}

		if (filter_input(INPUT_POST, "BtnBuy" . $SlotKey))
		{
			if (PayPalAccount == "")
			{
				$PayPalAccount = WS_Property::GetText("PayPal", "AccountEmail");
			}

			$Pay = new WS_Pay();
			$Pay->TransactionID = WS_Pay::GenerateTansactionID();
			$Pay->PayAccount = $PayPalAccount;
			$DT = new DateTime();
			$Pay->DT = $DT;
			$Pay->UserID = $_SESSION["USER_ID"];
			$Pay->Tag = $Tag;
			$Pay->Quantity = $ItemNum;
			$Pay->Import = $Import;
			$Pay->Shipping = $Shipping;
			$Pay->Currency = $Currency;
			$Pay->ItemName = $ItemName;
			$Pay->Description = $Description;
			$Pay->Success = 0;
			$Pay->Update();

			$ConfirmUrl = $PageUrl . "?WS_PayResult=1&WS_TransactionID=" . $Pay->TransactionID;
			$CancelUrl = $PageUrl . "?WS_PayResult=0&WS_TransactionID=" . $Pay->TransactionID;

			ob_end_clean();

			if (($Testing === 1) || ($Testing === "true"))
			{
				$Pop = "<form id=\"frm_" . $SlotKey . "\" method=\"post\" name=\"paypal_form\" action=\"https://www.sandbox.paypal.com/cgi-bin/webscr\">";
			}
			else
			{
				$Pop = "<form id=\"frm_" . $SlotKey . "\" != method=\"post\" name=\"paypal_form\" action=\"https://www.paypal.com/cgi-bin/webscr\">";
			}

			$Pop .= "<br/><br/><div style=\"font-size:20px\">Connecting to PayPal ... <br/><br/>Please Wait ! ...</div>";
			$Pop .= "<input type=\"hidden\" name=\"business\" value=\"" . $PayPalAccount . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"cmd\" value=\"_xclick\" />";
			$Pop .= "<input type=\"hidden\" name=\"return\" value=\"" . $ConfirmUrl . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"cancel_return\" value=\"" . $CancelUrl . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"notify_url\" value=\"" . $CancelUrl . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"rm\" value=\"2\" />";
			$Pop .= "<input type=\"hidden\" name=\"currency_code\" value=\"" . $Currency . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"lc\" value=\"IT\" />";
			$Pop .= "<input type=\"hidden\" name=\"cbt\" value=\"Continua\" />";
			$Pop .= "<input type=\"hidden\" name=\"shipping\" value=\"" . $Shipping . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"cs\" value=\"1\" />";
			$Pop .= "<input type=\"hidden\" name=\"item_num\" value=\"" . $ItemNum . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"item_name\" value=\"" . $ItemName . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"amount\" value=\"" . $Import . "\" />";
			$Pop .= "<input type=\"hidden\" name=\"custom\" value=\"ABR24\" />";
			$Pop .= "</form>";
			$WS->PayScript = "<script type=\"text/javascript\" >document.getElementById(\"frm_" . $SlotKey . "\").submit();</script>";
			;
			$WS->SetPopup($Pop, "250px", "150px");
			echo "<br/><br/><br/><br/><br/><br/><br/><br/><br/><br/>";
		}

		echo "<div style=\"display:block\" title=\"" . $ItemName . "\">";
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo $WS->DrawEditButton($SlotKey, "Pay", "Edit Pay Pal Button", "ws_btnedit-pp",  $Text);
		}

		$User = WS::GetUser(1);
		if ($ItemName != "")
		{
			//echo "<input type=\"hidden\" name=\"cur\" value=\"" . $Currency . "\" />";
			//echo "<input type=\"hidden\" name=\"shp\" value=\"" . $Shipping . "\" />";
			//echo "<input type=\"hidden\" name=\"item\" value=\"" . $ItemName . "\" />";
			//echo "<input type=\"hidden\" name=\"imp\" value=\"" . $Import . "\" />";

			if (floatval($Import) > 0)
			{
				if (floatval($Shipping) > 0)
				{
					echo (string) (floatval($Import) - floatval($Shipping)) . " (" . $Currency . ") {Price:" . $Import . " - Shipping: " . $Shipping . "}<input name=\"BtnBuy" . $SlotKey . "\" type=\"submit\" value=\".\"  style=\"background-image:url(../Lib/Images/PayPal.png);background-size:cover;width:50px;height:25px />";
				}
				else
				{
					echo $Import . " (" . $Currency . ") <input name=\"BtnBuy" . $SlotKey . "\" type=\"submit\" style=\"background-image:url(../Lib/Images/PayPal.png);background-size:cover;width:100px;height:50px;color:white\" value=\".\" />";
				}
			}
		}
		echo "</div>";
	}
}
?>