<?php
trait WS_Plugin
{
	public function Slot_Plugin($SlotID, $Width = "800px", $Height = "", $Plugin = "")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$RowOffset = 0;
		$SlotKey = $WS->GetSlotKey($SlotID);

		$WS->ReadInputSlots($WS->WS_Page->PageID, $SlotID, 0, "PLG");

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Plugins = WS::GetPluginsNames();
			$PluginsArray = array();
			$SelPugin = "";
			foreach ($Plugins as $Plugin)
			{
				if (isset($WS->WS_Page->Slots[$SlotKey]))
				{
					$Slot = $WS->WS_Page->Slots[$SlotKey];
					if ((isset($Slot->Param[0])) && ($Slot->Param[0] == $Plugin . ".plugin.php"))
					{
						$SelPugin = $Plugin;
					}
				}
				array_push($PluginsArray,$Plugin . "=" . $Plugin . ".plugin.php");
			}

			$Width = "";
			$Height = "";
			$WS->PluginParam = "";
			if (isset($WS->WS_Page->Slots[$SlotKey]))
			{
				$Slot = $WS->WS_Page->Slots[$SlotKey];
				if (isset($Slot->Param[1]))
				{
					$Width = $Slot->Param[1];
				}
				if (isset($Slot->Param[2]))
				{
					$Height = $Slot->Param[2];
				}
				if (isset($Slot->Param[3]))
				{
					$WS->PluginParam = $Slot->Param[3];
				}
                                				if (isset($Slot->Param[3]))
				{
					$WS->PluginParam = $Slot->Param[4];
				}
			}
			
			$Params = array();
			array_push($Params, new WS_ParamDef("Param0", "Plugin:", 40, 1, "DDL", $PluginsArray, $SelPugin));
			array_push($Params, new WS_ParamDef("Param1", "Width:", 40, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Param2", "Height:", 40, 1, "TXT", null));
                        array_push($Params, new WS_ParamDef("Param3", "Css Class:", 120, 1, "CLS", null));
			array_push($Params, new WS_ParamDef("Param4", "Params:", 120, 1, "TXT", null));
			array_push($Params, new WS_ParamDef("Update", "Update", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null));
			array_push($Params, new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null));
			$this->DrawConfigSlots($this->WS_Page->PageID, $SlotID,  $Params);
		}

		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver\">";
			echo $WS->DrawEditButton($SlotKey, "Plug", "Insert a Plugin Block", "ws_btnedit-pl ws_absolute", 0, $Value = "");
		}

		$SWidth = "";
		$SHeight = "";
                $PluginClass="";
		if ($Width != "")
		{
			$SWidth = " width:" . $Width . ";";
		}
		if ($Height != "")
		{
			$SHeight = " height:" . $Height . ";";
		}

		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $WS->WS_Page->Slots[$SlotKey];
			if ($Slot->Param[1] != "")
			{
				$SWidth = "width:" . $Slot->Param[1] . ";";
			}
			if ($Slot->Param[2] != "")
			{
				$SHeight = "height:" . $Slot->Param[2] . ";";
			}
			if ($Slot->Param[3] != "")
			{
				$PluginClass = $Slot->Param[3];
			}
		}

		$Overflow = "";
		if ($SWidth != "")
		{
			$Overflow .= "overflow-x:auto;padding-bottom:4px;";
		}
		if ($SHeight != "")
		{
			$Overflow .= "overflow-y:auto;padding-right:4px;";
		}

		$WS = $WS;
		if (isset($WS->WS_Page->Slots[$SlotKey]))
		{
			echo "<div style=\"" . $SWidth . $SHeight . $Overflow . "\">";
                        if ($PluginClass != "") echo "<div class=\"".$PluginClass."\">";
			include (WS::$WSBase->Root . "/Plugin/" . $Slot->Param[0]);
                        if ($PluginClass != "") echo "</div>";
			echo "</div>";
		}
		else
		{
			if ($Plugin != "")
			{
				if (file_exists(WS::$WSBase->Root . "/Plugin/" . $Plugin))
				{
					echo "<div style=\"" . $SWidth . $SHeight . $Overflow . "\">";
                                        if ($PluginClass != "") echo "<div class=\"".$PluginClass."\">";
					include (WS::$WSBase->Root . "/Plugin/" . $Plugin);
                                        if ($PluginClass != "") echo "</div>";
					echo "</div>";
				}
				else
				{
					echo "<br/>Error:<br/><br/>WS->PluginSlot: File not found (" . $Plugin . ")\n";
				}
			}
		}
		$WS->PluginParam = "";

		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
}
?>