<?php
trait WS_TextExpandible
{
	public function Slot_TextExpandible($SlotID, $Width="100%", $Height = "50px")
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$SlotKey = $this->GetSlotKey($SlotID);

		$this->ReadInputSlots($this->WS_Page->PageID, $SlotID,  "TXT");

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Params = array();
			$Params[0] = new WS_ParamDef("Text", "Text:", 80, 10, "TXT", null);
			$Params[1] = new WS_ParamDef("Param0", "CSS class:", 80, 1, "CLS", null);
			$Params[2] = new WS_ParamDef("Update", "Update", 0, 0, "BTN", null);
			$Params[3] = new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null);
			$Params[4] = new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null);
			$this->DrawConfigSlots($this->WS_Page->PageID, $SlotID,  $Params);
		}


		$Text = "";
		$CSS = "";
		$CssClass="";
		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $this->WS_Page->Slots[$SlotKey];
			$CSS = "width:" . $Width . ";height:" . $Height;
			$Text = $Slot->Text;
			$CssClass = $Slot->Param[0];
		}

		$WS->IncludeCss("../Lib/Styles/TextExpandible.css");
		$WS->IncludeScript("../Lib/js/TextExpandible.js");
		
		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div>";
			echo $this->DrawEditButton($SlotKey, "Text", "Edit Text", "ws_btnedit-t ws_absolute",  $Text);
		}

		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			echo "<div id=\"".$SlotKey."\" class=\"ws_TextExpandible ".$CssClass."\" style=\"" .$CSS ."\" ";
			echo "\n onclick=\"ws_TextExpandible('".$SlotKey."','".$SlotKey."_Pts','".$SlotKey."_Arw','".$Height."')\">";

			$Text = str_replace("\n", "<br/>", $Text);
			$Text = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;", $Text);
			echo "<div class=\"ws_TextExpandible_Arrow\" style=\"transform:rotate(90deg)\" id=\"".$SlotKey."_Arw\">&gt;</div>";
			echo $Text;
			echo "</div>";
			echo "<div id=\"".$SlotKey."_Pts\">...</div>";
		}
	
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
}
?>
