<?php
trait WS_Tree_View
{
	public function Slot_TreeView($SlotID)
	{
		global $WS;
		if (!isset($_SESSION["SITE_ID"])){return;}
		if (!isset($WS->WS_Page->PageID)){return;}
		if ($WS->WSDB == null){return;}

		$RowOffset = 0;
		$SlotKey = $this->GetSlotKey($SlotID);

		$this->ReadInputSlots($this->WS_Page->PageID, $SlotID,  "TXT");

		// BUTTON PRESS
		// ENTER EDIT MODE POPUP
		if (filter_input(INPUT_POST, "Btn" . $SlotKey))
		{
			$Params = array();
			$Params[0] = new WS_ParamDef("Param0", "Width:", 80, 1, "TXT", null);
			$Params[1] = new WS_ParamDef("Param1", "Height:", 80, 1, "TXT", null);
			$Params[2] = new WS_ParamDef("Param2", "CSS styles:", 80, 1, "TXT", null);
			$Params[3] = new WS_ParamDef("Param3", "Tree Button CSS styles:", 80, 1, "TXT", null);
			$Params[4] = new WS_ParamDef("Param4", "Edit button CSS styles:", 80, 1, "TXT", null);

			$Params[5] = new WS_ParamDef("Update", "Update", 0, 0, "BTN", null);
			$Params[6] = new WS_ParamDef("Clear", "Clear", 0, 0, "BTN", null);
			$Params[7] = new WS_ParamDef("Cancel", "Cancel", 0, 0, "BTN", null);
			$this->DrawConfigSlots($this->WS_Page->PageID, $SlotID,  $Params);
		}

		$Width = "98%";
		$Height = "98%";
		$CSS = "";
		$TreeBtnCSS = "";
		$EditBtnCSS = "";
		if (isset($this->WS_Page->Slots[$SlotKey]))
		{
			$Slot = $this->WS_Page->Slots[$SlotKey];
			$Width = $Slot->Param[0];
			$Height = $Slot->Param[1];
			$CSS = $Slot->Param[2];
			$TreeBtnCSS = $Slot->Param[3];
			$EditBtnCSS = $Slot->Param[4];
		}

		// DRAW EDITING ICON
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "<div style=\"border:1px dashed silver\">";
			echo $this->DrawEditButton($SlotKey, "Tree", "Edit TreeView", "ws_btnedit-t ws_absolute",  "");
		}

		$TV = new WS_TreeView();
		$TV->PageID = $this->WS_Page->PageID;
		$TV->SlotID = $SlotID;
		$TV->PostValueID = "TreeView_" . $SlotID;
		$TV->CssFile = "../Lib/Styles/ws_treeview.css";
		$TV->TreeButtonCssStyle = $TreeBtnCSS;
		$TV->EditButtonCssStyle = $EditBtnCSS;
		$TV->User = $_SESSION["PERMISIONS"];
		$TV->CurrentLang = $_SESSION["LANG"];
		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			$TV->EditMode = true;
		}
		$TV->LoadFromDB();
		$TV->DrawTree($Width, $Height);


		if ($_SESSION["SLOTS_EDIT_MODE"])
		{
			echo "</div>";
		}
	}
}
?>