<?php
if (file_exists("Config.php")) {$Path = "Config.php";}
if (file_exists("../Config.php")) {$Path = "../Config.php";}

include $Path;

class ConnectDB extends mysqli
{
	public $DBServer="";
	public $User="";
	public $Password="";
	public $DbName="";
	public $NumOfRows = 0;
	private $Result=null;
	private $Rows=null;
		
	public function __construct($Server,$User,$Password,$DbName)
	{
		$this->DBServer=$Server;
		$this->User=$User;
		$this->Password=$Password;
		$this->DbName=$DbName;
		parent::__construct($Server,$User,$Password,$DbName);
	}
	
	public function query( $query,  $resultmode = null )
	{
		$this->Result = parent::query($query,$resultmode);
		if(isset($this->Result->num_rows)) {$this->NumOfRows=$this->Result->num_rows;}
		return $this->Result;
	}
	
	public function fetch_assoc()
	{
		$this->EOF=false;
		$this->Row = $this->Result->fetch_assoc();
		if(!isset($this->Row)) {$this->EOF=true;}
		return $this->EOF;
	}
	
	public function GetRows($sql)
	{
		$this->Rows = array();
		$Result = $this->query($sql);
		for ($M=0;$M<$this->Result->num_rows;$M++)
		{
			$Row = $Result->fetch_assoc();
			array_push($this->Rows,$Row);
		}
		return $this->Rows;
	}
	
	public function GetData($NumRow,$FieldName)
	{
		return $this->Rows[$NumRow][$FieldName];
	}
	
	public function Disconnect()
	{
		try {parent::close();}
		catch(Exception $Ex) {}
	}
	
	public static function FormatStr($Str)
	{
		return str_replace("'","''",$Str);
	}
}

?>