<?php
class HtmlEditor
{
	static $HE_Include = false;
	public $TextID;
	public $ID;

	public function __construct($ID)
	{
		$this->ID = $ID;
		WS::$WSBase->IncludeScript("../Lib/js/HtmlEditor.js");
		WS::$WSBase->IncludeCss("../Lib/Styles/HtmlEditor.css");
	}
	
	public function Build($Value="",$Width="99%",$Height="200px")
	{
		$this->TextID = $this->ID."_Txt";
		$TxtName = $this->ID."_Txt";
		$HtmlName = $this->ID."_Html";
		$Name = $this->ID;
		$BtnName = $this->ID."_Btn";
		$BgColName = $this->ID."_BgCol";
		$FgColName = $this->ID."_FgCol";
		
		$Ret  = "<button type=\"button\" title=\"Bold\" onmouseup=\"HE_Command('bold');HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/><b>B</b></button>";
		$Ret .= "<button type=\"button\" title=\"Italic\" onmouseup=\"HE_Command('italic');HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/><i>I</i></button>";
		$Ret .= "<button type=\"button\" title=\"Underline\" onmouseup=\"HE_Command('underline');HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/><u>U</u></button>";
		$Ret .= "<button type=\"button\" title=\"Tab\" onmouseup=\"HE_Command('indent');HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/>Tab</button>";
		$Ret .= "<button type=\"button\" title=\"justify Left\" onmouseup=\"HE_Command('justifyLeft');HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/>=&nbsp;&nbsp;</button>";
		$Ret .= "<button type=\"button\" title=\"justify center\" onmouseup=\"HE_Command('justifyCenter');HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/>&nbsp;=&nbsp;</button>";
		$Ret .= "<button type=\"button\" title=\"justify right\" onmouseup=\"HE_Command('justifyRight');HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/>&nbsp;&nbsp;=</button>";
		$Ret .= "<button type=\"button\" title=\"Sup text\" onmouseup=\"HE_Command('superscript',);HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/><small>Tx<sup>s</sup></small></button>";
		$Ret .= "<button type=\"button\" title=\"Sub text\" onmouseup=\"HE_Command('subscript',);HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/><small>Tx<sub>s</sub></small></button>";
		$Ret .= "<button type=\"button\" title=\"Dotted list\" onmouseup=\"HE_Command('insertUnorderedList',);HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/>:=</button>";
		$Ret .= "<button type=\"button\" title=\"Link\" onmouseup=\"var Link=prompt('link:', '');HE_Command('createLink',true,Link);HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/>&rarr;</button>";

		$Ret .= "<select id=\"".$BgColName."\" onchange=\"HE_Command('backColor',true,this.value);this.selectedIndex=0;HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\">";
		$Ret .= "	<option value=\"\">bg col</option>";
		$Ret .= "</select>";
		$Ret .= "<select id=\"".$FgColName."\" onChange=\"HE_Command('foreColor',true,this.value);this.selectedIndex=0;this.style.color=this.value;HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\">";
		$Ret .= "	<option value=\"\">fg col</option>";
		$Ret .= "</select>";
		$Ret .= "<select  onChange=\"HE_Command('fontsize',true,this.value);this.selectedIndex=0;HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\">";
		$Ret .= "	<option value=\"1\">50%</option>";
		$Ret .= "	<option value=\"2\">75%</option>";
		$Ret .= "	<option selected value=\"3\">Normal</option>";
		$Ret .= "	<option value=\"4\">125%</option>";
		$Ret .= "	<option value=\"5\">150%</option>";
		$Ret .= "	<option value=\"6\">200%</option>";
		$Ret .= "	<option value=\"7\">250%</option>";
		$Ret .= "</select>";
		$Ret .= "<button type=\"button\" title=\"remove format\" onmouseup=\"HE_Command('(removeFormat)',);HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"/>Clr</button>";
		$Ret .= "<button type=\"button\" id=\"".$BtnName."\" title=\"View code\" onmouseup=\"HE_ViewCode('".$TxtName."','".$HtmlName."','".$BtnName."');\" >Code</button>";

		$Ret .= "<br/>";
		$Ret .= "<div id=\"".$TxtName."\" name=\"".$TxtName."\" contenteditable=\"true\" style=\"width:".$Width.";height:".$Height."\" class=\"HE_box\" onkeyup=\"HE_Refresh('".$TxtName."','".$HtmlName."','".$Name."');\"></div>";
		$Ret .= "<xmp id=\"".$HtmlName."\" name=\"".$HtmlName."\" style=\"width:".$Width.";height:".$Height."\" class=\"HE_box HE_hidden\" contenteditable=\"true\" onkeyup=\"HE_RefreshView('".$TxtName."','".$HtmlName."','".$Name."');\">".$Value."</xmp>";
		$Ret .= "<input id=\"".$Name."\" name=\"".$Name."\" type=\"hidden\");\">";
		$Ret .= "<script type=\"text/javascript\">HE_SetColor('".$BgColName."','".$FgColName."');HE_RefreshView('".$TxtName."','".$HtmlName."','".$Name."');</script>";
		
		return $Ret;
	}
	public function Draw($Value="",$Width="99%",$Height="200px")
	{
		echo $this->Build($Value,$Width,$Height);
		
	}
}