<?php

// GEST GAGER POST BACK
if (!isset($_SESSION["PAGER_CURR_PAGE"])) $_SESSION["PAGER_CURR_PAGE"] = 0;
if (isset($_POST['Pager'])) $_SESSION["PAGER_CURR_PAGE"] = ((int) $_POST['Pager']) - 1;

class HtmlHelper
{
	static function GetPageRelativePath()
	{
		return $_SERVER['SCRIPT_NAME'];
	}
	
	public static function GetPageURL()
	{
		$pageURL = 'http';
		if ((isset($_SERVER["HTTPS"])) && ($_SERVER["HTTPS"] == "on"))
		{
			$pageURL .= "s";
		}
		$pageURL .= "://";
		if ($_SERVER["SERVER_PORT"] != "80")
		{
			$pageURL .= $_SERVER["SERVER_NAME"] . ":" . $_SERVER["SERVER_PORT"] . $_SERVER["REQUEST_URI"];
		} else
		{
			$pageURL .= $_SERVER["SERVER_NAME"] . $_SERVER["REQUEST_URI"];
		}
		return $pageURL;
	}

	public static function GetPageName()
	{
		return basename($_SERVER['SCRIPT_NAME']);
	}

	public static function BuildSelectList($sql, $Name, $value)
	{
		if (ConnectDB::$DBConn == null)
			return "";

		$Ret = "<select name=\"" . $Name . "\">";

		$result = ConnectDB::$DBConn->query($sql) or die(mysql_error());

		for ($N = 0; $N < $result->num_rows; $N++)
		{
			$row = $result->fetch_assoc();
			$row = array_values($row);

			$Ret .= "<option ";
			if ($row[0] == $value)
				$Ret .= " selected ";
			$Ret .= "value=\"" . $row[0] . "\">";

			if (count($row) > 1)
			{
				$Ret .= $row[1];
			} else
			{
				$Ret .= $row[0];
			}
			$Ret .= "</option>";
		}

		return $Ret . "</select>";
	}

	function GetCurrentPagerPage()
	{
		return $_SESSION["PAGER_CURR_PAGE"];
	}
	
	function BuildPager($Count, $Step)
	{
		// PAGER DRAWER
		$Ret = "<div>";
		$Start = 0;
		$End = 0;

		$CurrPage = $_SESSION["PAGER_CURR_PAGE"];

		if (($CurrPage - 10) > 0)
			$Start = $CurrPage - 10;
		if ($Start > 0)
			$Ret .= "...&nbsp;&nbsp;";

		for ($N = $Start; $N <= ((int) ($Count / $Step)); $N++)
		{
			if ($N == $_SESSION["PAGER_CURR_PAGE"])
			{
				$Ret .= "<b>" . ($N + 1) . "</b>&nbsp;&nbsp";
			} else
			{
				$Ret .= "<input name=\"Pager\" type=\"submit\" value=\"" . ($N + 1) . "\" style=\"border:none\">&nbsp;&nbsp";
			}
			$End ++;
			if ($End > 15)
				break;
		}

		if ($N < ((int) ($Count / $Step)))
		{
			$Ret .= "...";
		}

		$Ret .= "</div>";
		return $Ret;
	}

	public static function BuildLink($Text, $HRef)
	{
		$Ret = "<a href=" . $HRef . ">" . $Text . "</a>";
		return $Ret;
	}

	public static function BuildButton($Text, $PostName)
	{
		$Ret = "<input type=\"submit\" name=\"" . $PostName . "\" value=\"" . $Text . "\">" . $Text . " />";
		return $Ret;
	}
}
?>