<?php

$Message = "";

function Save($Txt,$Mobile,$Css)
{
	try
	{
		$Path = WS::$WSBase->Root."/Templates/Master/";
		if (!file_exists($Path)) {$Path = WS::$WSBase->Root."/Templates/";}
		$FileTemplate = $Path . $_SESSION["CURRENT_TEMPLATE"];
		WS::FilePutContents($FileTemplate,$Txt);
		
		$FileMobile = str_replace(".Master", ".Master.Mobile", $FileTemplate);
		if ($Mobile!="")
		{
			WS::FilePutContents($FileMobile,$Mobile);
		}
		else
		{
			if (file_exists($FileMobile)) 
				{unlink($FileMobile);}
			
		}
		$FileCss = str_replace(".Master", ".Master.css", $FileTemplate);
		WS::FilePutContents($FileCss,$Css);
	}
	catch (Exception $e) 
	{
		$Message = 'Error: '.$e->getMessage();
	}
}

$Path = WS::$WSBase->Root."/Templates/Master/";
if (!file_exists($Path)) {$Path = WS::$WSBase->Root."/Templates/";}

// Cancel button
if(isset($_POST['Cancel']))
{
	$_SESSION["CURRENT_TEMPLATE"] = null;
}

if(isset($_POST['Delete']))
{
	if (filter_input(INPUT_POST, 'TemplateList') != "")
	{
		$FileTemplate = $Path . filter_input(INPUT_POST, 'TemplateList');
		$FileCss = str_replace(".Master", ".Master.css", $FileTemplate);
		$FileMobile = str_replace(".Master", "Master.Mobile", $FileTemplate);
		unlink($FileTemplate);
		if (file_exists($FileCss)){unlink($FileCss);}
		if (file_exists($FileMobile)){unlink($FileMobile);}
	}
}

if(isset($_POST['Back']))
{
	$_SESSION["CURRENT_TEMPLATE"] = null;
	header("Location: ../Pages/" . $_SESSION["WS_RET_PAG"] . " ");
	exit();
}

if(isset($_POST['BackToPage']))
{
	$Txt = $_POST["Txt"];
	$Mobile = $_POST["TxtMobile"];
	if ($WS->CheckForCodePHP($Txt) || $WS->CheckForCodePHP($Mobile))
	{
		$Txt = preg_replace("/[<][?][p][h][p].*[?][>]/","<?@NotAllowPHP()@?>", $Txt);
		$Mobile = preg_replace("/[<][?][p][h][p].*[?][>]/","<?@NotAllowPHP()@?>", $Mobile);
		$Message = "Php tag is not allowed in the template!";
	}
	else
	{
		$Txt = $WS->UnprotectPHP($Txt);
		$Mobile = $WS->UnprotectPHP($Mobile);
		Save($Txt,$Mobile,$_POST["Css"]);
		$_SESSION["CURRENT_TEMPLATE"] = null;
		$Message = "Updated!";

		$_SESSION["CURRENT_TEMPLATE"] = null;
		header("Location: ../Pages/" . $_SESSION["WS_RET_PAG"] . " ");
		exit();
	}
}

if(isset($_POST['New']))
{
	if (filter_input(INPUT_POST, 'NewName') == "") 
		{$Message = "Missing template name!";}
	else
	{
		$Mobile = "";
		$Css = "/* ".filter_input(INPUT_POST, 'NewName')." */";
		$Txt = "<!-- ".filter_input(INPUT_POST, 'NewName')." -->";
		
		if (filter_input(INPUT_POST, 'TemplateList') != null)
		{
			if (file_exists($Path.filter_input(INPUT_POST, 'TemplateList')))
			{
				$Txt = file_get_contents($Path.filter_input(INPUT_POST, 'TemplateList'));
				$Txt = $WS->ProtectPHP($Txt);
			}
			
			if (file_exists($Path.filter_input(INPUT_POST, 'TemplateList').".Mobile"))
			{
				$Mobile = file_get_contents($Path.filter_input(INPUT_POST, 'TemplateList').'.Mobile');
				$Mobile = $WS->ProtectPHP($Mobile);
			}
			
			if (file_exists($Path.filter_input(INPUT_POST, 'TemplateList')))
			{
				$Css = file_get_contents($Path.filter_input(INPUT_POST, 'TemplateList').".css");
			}
		}
	
		$_SESSION["CURRENT_TEMPLATE"] = filter_input(INPUT_POST, 'NewName').".Master";
		Save($Txt,$Mobile,$Css);
		$Message = "Created!";
	}
}

if(isset($_POST['DblClick']) && ($_POST['DblClick']=='1'))
{
	$_SESSION["CURRENT_TEMPLATE"] = filter_input(INPUT_POST, 'TemplateList');
}

if(isset($_POST['Select']))
{
	$_SESSION["CURRENT_TEMPLATE"] = filter_input(INPUT_POST, 'TemplateList');
}

if(isset($_POST['Update']))
{
	$Txt = $_POST["Txt"];
	$Mobile = $_POST["TxtMobile"];
	if ($WS->CheckForCodePHP($Txt) || $WS->CheckForCodePHP($Mobile))
	{
		$Txt = preg_replace("/[<][?][p][h][p].*[?][>]/","<?@NotAllowPHP()@?>", $Txt);
		$Mobile = preg_replace("/[<][?][p][h][p].*[?][>]/","<?@NotAllowPHP()@?>", $Mobile);
		$Message = "Php tag is not allowed in the footer template!";
	}
	else
	{
		$Txt = $WS->UnprotectPHP($Txt);
		$Mobile = $WS->UnprotectPHP($Mobile);
		Save($Txt,$Mobile,$_POST["Css"]);
		$_SESSION["CURRENT_TEMPLATE"] = null;
		$Message = "Updated!";
	}
}

if (!isset($_SESSION["CURRENT_TEMPLATE"]) )
{
	// LIST OF TEMPLATES
	?>
	<form action="<?php echo WS_Page::GetPageName(); ?>" method="POST" enctype="multipart/form-data">
	<div class="page_block">
		<br/>
		<div style="margin:auto;width:400px;height:400px">
			Master Templates:

			<select class="ws_text" id="TemplateList" name="TemplateList" size="20" style="width:400px;height:400px;margin: auto">
				<?php
					$Templates = glob($Path."*.Master");
					foreach($Templates as $Template)	
					{
						$Tx = str_replace(".Master", "", basename($Template));
						echo "<option value=\"" . basename($Template) . "\" ondblclick=\"$('#DblClick').val('1');document.forms[0].submit();\">" . $Tx . "</option>";
					}
				?>
			</select>
			<input id="DblClick" name="DblClick" type="hidden" value="0">
		</div>
		<table style="margin: auto">
			<tr>
				<td>  
					<br/><input class="ws_text" name="NewName" type="text" value="">
				</td>
				<td>
					<br/><input class="ws_button" name="New" type="submit" value="New">
				</td>
				<td>
					<br/><input class="ws_button" name="Select" type="submit" value="Edit">
				</td>
				<td>
					<br/><input class="ws_button" name="Delete" type="submit" value="Delete" onclick="return confirm('Confirn delete ?');">
				</td>
			</tr>
			<tr>
				<td class="ws_txt_center" colspan="5">
					<br/><input class="ws_button" name="Back" type="submit" value="Back">
				</td>
			</tr>
			<tr>
				<td class="ws_text_red ws_txt_center" colspan="5">
					<br/>
					<?php echo $Message ?>
				</td>
			</tr>
		</table>
		<br/>
	</div>
<?php
}
else
{
	$Txt="";
	$Css="";
	$Mobile="";
	try
	{

		$FileTemplate = $Path . $_SESSION["CURRENT_TEMPLATE"];
		$Txt = file_get_contents($FileTemplate);
		$Txt = $WS->ProtectPHP($Txt);
		
		$FileMobile = str_replace(".Master", ".Master.Mobile", $FileTemplate);
		if (file_exists($FileMobile)) {$Mobile = file_get_contents($FileMobile);}
		$Mobile = $WS->ProtectPHP($Mobile);
		
		$FileCss = str_replace(".Master", ".Master.css", $FileTemplate);
		if (file_exists($FileCss)) {$Css = file_get_contents($FileCss);}
		
	}
	catch (Exception $e) {$Message = 'Error: '.$e->getMessage();}
	?>
	
	<style>
		.ws_TabLab
		{
			text-align:center;
			border-top:solid 1px silver;
			border-left:solid 1px silver;
			border-right:solid 1px silver;
			cursor:pointer;
			height:30px;
			padding-top: 15px;
		}
		.ws_TabBox
		{
			margin: auto;
			width: 1000px;
			height:400px;
		}
	</style>
	<div class="page_block">
		<br/>
		<table style="width:1000px;margin:auto" cellpadding="0px" cellspacing="0px">
			<tr>
				<td style="width:180px"><div id="TabLab0" class="ws_TabLab" onclick="ChangeTab(0);">Template</div></td>
				<td style="width:180px"><div id="TabLab1" class="ws_TabLab" onclick="ChangeTab(1);">Mobile Template</div></td>
				<td style="width:180px"><div id="TabLab2" class="ws_TabLab" onclick="ChangeTab(2);">CSS</div></td>
				<td>&nbsp;</td>
			</tr>
		</table>
		<div id="Tab0" class="ws_TabBox">
			<textarea id="Txt" name="Txt" style="width: 900px; height:400px" wrap="off"><?php echo $Txt; ?></textarea>
			<script type="text/javascript">AllowTab("Txt");</script>
		</div>

		<div id="Tab1" class="ws_TabBox">
			<textarea id="TxtMobile" name="TxtMobile" style="width: 900px; height:400px" wrap="off"><?php echo $Mobile; ?></textarea>
			<script type="text/javascript">AllowTab("TxtMobile");</script>
		</div>
		
		<div id="Tab2" class="ws_TabBox">
			<textarea id="Css" name="Css" style="width: 900px; height:400px" wrap="off"><?php echo $Css; ?></textarea>
			<script type="text/javascript">AllowTab("Css");</script>
		</div>
		<script type="text/javascript">
			var textarea = document.getElementById('Txt');
			textarea.onkeydown = function(p)
			{
				if( (p.keyCode===9) || (p.which===9) )
				{
					p.preventDefault();
					var s = this.selectionStart;
					var e = this.selectionEnd;
					if ((s!==null)&&(e!==null))
					{
						this.value = this.value.substring(0,s) + "\t" + this.value.substring(e);
						this.selectionEnd = s+1; 
					}
				}
			}
			
			var textarea = document.getElementById('Mobile');
			textarea.onkeydown = function(e)
			{
				if(e.keyCode==9 || e.which==9)
				{
				e.preventDefault();
				var s = this.selectionStart;
				this.value = this.value.substring(0,this.selectionStart) + "\t" + this.value.substring(this.selectionEnd);
				this.selectionEnd = s+1; 
				}
			}
		
			var textarea = document.getElementById('Css');
			textarea.onkeydown = function(e)
			{
				if(e.keyCode==9 || e.which==9)
				{
				e.preventDefault();
				var s = this.selectionStart;
				this.value = this.value.substring(0,this.selectionStart) + "\t" + this.value.substring(this.selectionEnd);
				this.selectionEnd = s+1; 
				}
			}
		</script>
		
		<script LANGUAGE="JavaScript">
			ChangeTab(0);
			function ChangeTab(Tab)
			{
				for(T=0;T<3;T++)
				{
					document.getElementById("Tab"+T).style.display = "none";
					document.getElementById("TabLab"+T).style.backgroundColor = "white";
				}
				document.getElementById("Tab"+Tab).style.display = "block";
				document.getElementById("TabLab"+Tab).style.backgroundColor = "#eeeeee";
			}
		</script>
		
		<table style="margin: auto">
			<tr>
				<td>
					<br/><input class="ws_button" name="Update" type="submit" value="Update">
				</td>
				<td>	
					<br/><input class="ws_button" name="BackToPage" type="submit" value="Update & Back To Page">
				</td>
				<td>	
					<br/><input class="ws_button" name="API" type="button" value="API Help" onclick="window.open('../Lib/Docs/API.html')">
				</td>
				<td>	
					<br/><input class="ws_button" name="Cancel" type="submit" value="Cancel">
				</td>
			</tr>
			<tr>
				<td colspan="2">
					<br/>
					<?php echo $Message ?>
				</td>
			</tr>
		</table>
		<br/>
	</div>
<?php
	}
$WSDB->Disconnect();
?>
