<?php
$WS->IncludeScript("../Lib/js/md5.js");
$WS->IncludeScript("../Lib/js/ws_login.js");

$Message = "";
// Cancel button
if(isset($_POST['Cancel']))
{
	header("Location: ../Pages/".$_SESSION["WS_RET_PAG"]);
	exit();
}

// Update Button
if (isset($_POST['Update']))
{
	$User = WS_User::GetUserByID($_SESSION["MOD_USER_ID"]);
	$User->FirstName = $_POST["FirstName"];
	$User->LastName = $_POST["LastName"];
	$User->Organization = $_POST["Organization"];
	$User->EMail = $_POST["EMail"];
	$User->Address = $_POST["Address"];
	$User->City = $_POST["City"];
	$User->State = $_POST["State"];
	$User->Zip = $_POST["Zip"];
	$User->Phone = $_POST["Phone"];
	$User->FiscalCode = $_POST["FiscalCode"];
	$User->Notes = $_POST["Notes"];
	$User->Gender = $_POST["Gender"];
	$User->LookFor = $_POST["LookFor"];
	

	// SAVE THE PHOTO
	if ($_FILES["Photo"]["tmp_name"] != "")
	{
		$Ext = strtolower(pathinfo($_FILES["Photo"]["name"], PATHINFO_EXTENSION));
		if(($Ext=="jpg")||($Ext=="gif")||($Ext=="png"))
		{
			$Path = "../MediaUser/Img_".$User->UserID.".".$Ext;
			rename ($_FILES["Photo"]["tmp_name"],$Path);
			WS::FileSetPermisions($Path);
			$User->Photo = $Path;
		}
	}
	$User->Update();
	
	// NOTIFICATION EMAIL
	$Params =array
	(
		"UserID"			=> htmlentities($_SESSION["MOD_USER_ID"]),
		"UserName"			=> htmlentities($User->UserName),
		"Password"			=> htmlentities($User->Password),
		"FirstName"			=> htmlentities($User->FirstName),
		"LastName"			=> htmlentities($User->LastName),
		"Organization"		=> htmlentities($User->Organization),
		"Address"			=> htmlentities($User->Address),
		"City"				=> htmlentities($User->City),
		"State"				=> htmlentities($User->State),
		"Zip"				=> htmlentities($User->Zip),
		"FiscalCode"		=> htmlentities($User->FiscalCode),
		"Email"				=> htmlentities($User->Email),
		"Phone"				=> htmlentities($User->Phone),
		"Notes"				=> htmlentities($User->Notes)
	);

	$Subject = "User update";
	$MailNotifier = new WS_MailNotifier();

	if ($MailNotifier->GetMailAdmin() != "")
	{
		//$TemplateFile = "../SysPages/EmailTemplates/UserUpdateNotifyToAdmin.html";
		//$MailNotifier->SendFromTemplateFile($MailNotifier->GetMailAdmin(), $Subject, $TemplateFile, $Params);
		$MailNotifier->SendFromPropertyTemplate($MailNotifier->GetMailAdmin(), $Subject, "EmailTamplate", "UserUpdNotifyToAdmin", $Params);
	}
	
	if ($User->Email != "")
	{
		//$TemplateFile = "../SysPages/EmailTemplates/UserUpdateNotifyToUser.html";
		//$MailNotifier->SendFromTemplateFile($User->Email, $Subject, $TemplateFile, $Params);
		$MailNotifier->SendFromPropertyTemplate($User->Email, $Subject, "EmailTamplate", "UserUpdNotifyToUser", $Params);
	}
	
	$_SESSION["MOD_USER_ID"] = null;
	$Message = 'Update succesfull';
	ws_Log::Log("UsrUpd",$_SESSION["USER_ID"],$_SERVER["REMOTE_ADDR"]);
}

//
// LOADING
//
if ($_SESSION["MOD_USER_ID"]!="")
{
	$User=WS_User::GetUserByID($_SESSION["MOD_USER_ID"]);
}
?>

<div class="page_block">
	<br/><br/>
	<input type="hidden" name="SiteID">
	<input type="hidden" name="UserID">

	<table style="margin: auto">

		<tr>
			<td>
				<table style="margin:auto">
					<tr>
						<td style="text-align:right">
							<!-- USER IMAGE -->
							<?php
								if ($User->Photo =="")
								{
									echo "<img style=\"width:100px;height:100px;border-radius:50px\" src=\"../Lib/Images/User.png\">";
								}
								else
								{
									echo "<img style=\"width:100px;height:100px;border-radius:50px\" src=\"".$User->Photo."\">";
								}
							?>
							<br/><br/>
						</td>
						<td>
							<input type="file" name="Photo" size="50"/>
						</td>
					</tr>
					
					<tr><td style="text-align:right"><?php $WS->Translate("User");?> *:</td><td><input class="ws_text_big" type="text" name="UserName" maxlength="25" size="25" value="<?php echo $User->UserName; ?>"/></td></tr>

					<tr><td style="text-align:right"><?php $WS->Translate("EMail");?> *:</td><td><input class="ws_text_big" type="text" name="EMail" maxlength="80" size="30" value="<?php echo $User->Email; ?>"/></td></tr>
					
					<?php
					$Reg = WS_Property::GetText('Registration', 'Anonimous');
					if ( ($Reg=="1") || ($Reg==strtolower("true")))
					{
					?>
						<input type="hidden" name="FirstName" size="50" value="<?php echo $User->FirstName; ?>"/>
						<input type="hidden" name="LastName" size="50" value="<?php echo $User->LastName; ?>"/>
						<input type="hidden" name="Organization" size="50" value="<?php echo $User->Organization; ?>"/>
						<input type="hidden" name="Address" size="80" value="<?php echo $User->Address; ?>"/>
						<input type="hidden" name="City" size="30" value="<?php echo $User->City; ?>"/>
						<input type="hidden" name="State"  size="50" value="<?php echo $User->State; ?>"/>
						<input type="hidden" name="Zip"  size="15" value="<?php echo $User->Zip; ?>"/>
						<input type="hidden" name="Phone"  size="50" value="<?php echo $User->Phone; ?>"/>
						<input type="hidden" name="FiscalCode"  size="25" value="<?php echo $User->FiscalCode; ?>"/>
					<?php
					}
						else
					{
					?>
						<tr><td style="text-align:right"><?php $WS->Translate("First Name");?>:</td><td><input class="ws_text_big" type="text" name="FirstName" maxlength="50" size="50" value="<?php echo $User->FirstName; ?>"/></td></tr>
						<tr><td style="text-align:right"><?php $WS->Translate("Last Name");?>:</td><td><input class="ws_text_big" type="text" name="LastName" maxlength="50" size="50" value="<?php echo $User->LastName; ?>"/></td></tr>
						<tr><td style="text-align:right"><?php $WS->Translate("Organization");?>:</td><td><input class="ws_text_big" type="text" name="Organization" maxlength="50" size="50" value="<?php echo $User->Organization; ?>"/></td></tr>
						<tr><td style="text-align:right"><?php $WS->Translate("Address");?>:</td><td><input class="ws_text_big" type="text" name="Address" maxlength="80" size="80" value="<?php echo $User->Address; ?>"/></td></tr>
						<tr><td style="text-align:right"><?php $WS->Translate("City");?>:</td><td><input class="ws_text_big" type="text" name="City" maxlength="50" size="50" value="<?php echo $User->City; ?>"/></td></tr>
						<tr><td style="text-align:right"><?php $WS->Translate("State");?>:</td><td><input class="ws_text_big" type="text" name="State"  maxlength="50" size="50" value="<?php echo $User->State; ?>"/></td></tr>
						<tr><td style="text-align:right"><?php $WS->Translate("Zip Code");?>:</td><td><input class="ws_text_big" type="text" name="Zip"  maxlength="15" size="15" value="<?php echo $User->Zip; ?>"/></td></tr>
						<tr><td style="text-align:right"><?php $WS->Translate("Phone");?>:</td><td><input class="ws_text_big" type="text" name="Phone"  maxlength="50" size="50" value="<?php echo $User->Phone; ?>"/></td></tr>
						<tr><td style="text-align:right"><?php $WS->Translate("Fiscal Code");?>:</td><td><input class="ws_text_big" type="text" name="FiscalCode"  maxlength="50" size="25" value="<?php echo $User->FiscalCode; ?>"/></td></tr>
					<?php
					}

				
					$Reg = WS_Property::GetText('Registration', 'Gender');
					if ( ($Reg=="1") || ($Reg==strtolower("true")))
					{
						$SelM = "";
						$SelF = "";
						if ($User->Gender == "M") {$SelM="selected";}
						if ($User->Gender == "F") {$SelF="selected";}
						
						?>
						<tr><td style="text-align:right"><?php $WS->Translate("Gender");?>:</td><td>
							<select class="ws_text_big" type="text" name="Gender"  size="25"/>
								<option <?php echo $SelM;?>><?php $WS->Translate("Male");?></option>
								<option <?php echo $SelF;?>><?php $WS->Translate("Female");?></option>
							</select>
						</td></tr>
						<?php
					}	
					else
					{
						?> 
						<input type="hidden" name="Gender" value="<?php echo $User->Gender; ?>"/>
						<?php
					}
					
					$Reg = WS_Property::GetText('Registration', 'LookFor');
					if ( ($Reg=="1") || ($Reg==strtolower("true")))
					{
						$SelM = "";
						$SelF = "";
						if ($User->LookFor == "M") {$SelM="selected";}
						if ($User->LookFor == "F") {$SelF="selected";}
						
						?>
						<tr><td style="text-align:right"><?php $WS->Translate("Look For");?>:</td><td>
							<select type="text" name="LookFor" size="25" value="<?php echo $User->LookFor; ?>"/></td></tr>
								<option><?php $WS->Translate("Male");?></option>
								<option><?php $WS->Translate("Female");?></option>
							</select>
						</td></tr>
						<?php
					}
					else
					{
						?> 
						<input type="hidden" name="LookFor" value="<?php echo $User->Gender; ?>"/>
						<?php
					}
					
					?>
						
					<tr><td style="text-align:right"><?php $WS->Translate("Notes");?>:</td><td><textarea name="Notes" cols="50" rows="5"/><?php echo $User->Notes; ?></textarea></td></tr>
					
					<tr><td><br/></td><td><br/>
						<input class="ws_button" type="submit" name="Update" value="<?php $WS->Translate("Update");?>"/>
						<input class="ws_button" type="submit" name="Cancel" value="<?php $WS->Translate("Back");?>"/>
					</td></tr>

				</table>
			</td>
		</tr>
	</table>
	<br/>
	<div style="width:400px;margin:auto;color:red"><?php echo $Message?></div><br/><br/>
</div>
