<?php
$Message = "";
$PageName = $_SESSION["WS_RET_PAG"];
$P = strpos($PageName,".php");
$PageName = substr($PageName,0,$P);

$WS_Page = WS_Page::GetPageByName($PageName);

// Cancel button
if(isset($_POST['Cancel']))
{
	header("Location: ../Pages/" . $_SESSION["WS_RET_PAG"] . " ");
	exit();
}

if(isset($_POST['LoadFile']))
{
	$Message = "";
	try
	{
		$target_file = WS::$WSBase->Root."/Media/" . $_FILES["Media"]["name"];
		$Ext = pathinfo($target_file,PATHINFO_EXTENSION);
		$target_file = str_replace($Ext, strtolower($Ext), $target_file);
		if (file_exists($target_file))
		{
			$Message = "Sorry, file already exists.";
		}
		
		if ($Message == "")
		{
			rename ($_FILES["Media"]["tmp_name"],$target_file );
			WS::FileSetPermisions($target_file);
		}
	}
	catch (Exception $e)
	{
		$Message = 'Error: '.$e->getMessage();
	}
}

if(isset($_POST['LoadFileToPage']))
{
	$Message = "";

	try
	{
		if (!file_exists(WS::$WSBase->Root."/Media/".$WS_Page->Name))
		{
			mkdir(WS::$WSBase->Root."/Media/".$WS_Page->Name);
			WS::FileSetPermisions(WS::$WSBase->Root."/Media/".$WS_Page->Name);
		}
		
		$target_file = WS::$WSBase->Root."/Media/".$WS_Page->Name."/" . $_FILES["MediaP"]["name"];
		$Ext = pathinfo($target_file,PATHINFO_EXTENSION);
		$target_file = str_replace($Ext, strtolower($Ext), $target_file);
		
		if (file_exists($target_file))
		{
			$Message = "Sorry, file already exists.";
		}
		
		if ($Message == "")
		{
			rename ($_FILES["MediaP"]["tmp_name"],$target_file );
			WS::FileSetPermisions($target_file);
		}
	}
	catch (Exception $e)
	{
		$Message = 'Error: '.$e->getMessage();
	}
}


$MediaDir2 = WS::GetMediaNames();
foreach($MediaDir2 as $Entry)
{
	if(isset($_POST['btn' . str_replace(".","_",$Entry)] ))
	{
		unlink(WS::$WSBase->Root."/Media/" . $Entry);
		$Message = $Entry . " Deleted ...";
		break;
	}
}

$MediaDir2 = WS::GetMediaNames($WS_Page);
foreach($MediaDir2 as $Entry)
{
	if(isset($_POST['btn_'.$PageName ."_". str_replace(".","_",$Entry)] ))
	{
		unlink(WS::$WSBase->Root."/Media/".$PageName."/".$Entry);
		$Message = $Entry . " Deleted ...";
		break;
	}
}

?>
	<form action="<?php echo $PageName; ?>" method="POST" enctype="multipart/form-data">
	<div class="page_block">
		<br/>
		<div  class="ws-text ws_text_big" style=" margin: auto;width:95%">
		Global Media:
		</div>
		<div style=" margin: auto;width:95%; height:200px;overflow:auto;border:1px solid silver">
			<table><tr>
			<?php
				$MediaDir = WS::GetMediaNames();
				foreach($MediaDir as $Entry)
				{
					echo "<td style=\"border: 1px solid silver\">";
					
					$imageFileType = strtolower(pathinfo($Entry,PATHINFO_EXTENSION));

					if (($imageFileType == "jpg") || ($imageFileType == "gif") || ($imageFileType == "png") || ($imageFileType == "bmp"))
					{
						echo "<div style=\"background-image:url(../Media/". $Entry . ");background-repeat:no-repeat; background-size:contain;width:100px;height:80px\"></div>";
					}
					
					if (($imageFileType == "pdf"))
					{
						echo "<div style=\"background-image:url(../Lib/images/pdf.jpg);background-repeat:no-repeat; background-size:contain;width:100px;height:80px\"></div>";
					}
					
					
					if (($imageFileType == "zip")|| ($imageFileType == "rar")|| ($imageFileType == "7z"))
					{
						echo "<div style=\"background-image:url(../Lib/images/zip.jpg);background-repeat:no-repeat; background-size:contain;width:100px;;height:80px\"></div>";
					}
					
					echo "<div>" . $Entry . "</div><br/>";
					echo "<div style=\"text-align:center;vertical-align:top\"><input class=\"ws_button\" type=\"submit\" name=\"btn" . str_replace(".","_",$Entry) . "\" value=\"X\" title=\"Delete\"></div>";
					echo "</td>";
					
				}
				
			?>
			</tr></table>
		</div>
		<br/>
		<table style="margin: auto">
			<tr>
				<td colspan="2">
					<input  class="ws_text ws_text_big " name="Media" type="file"><input class="ws_button" name="LoadFile" type="submit" value="Load">
				</td>
			</tr>
			<tr>
				<td colspan="2">
					<br/>
					<?php echo $Message ?>
				</td>
			</tr>
		</table>
		<br/><br/>
		<div  class="ws_text ws_text_big" style=" margin: auto;width:95%">
		Page Media (<?php echo $PageName ?>):
		</div>
		<div style=" margin: auto;width:95%; height:200px;overflow:auto;border:1px solid silver">
			<table><tr>
			<?php
				$MediaPageDir = WS::GetMediaNames($WS_Page);
				foreach($MediaPageDir as $Entry)
				{
					echo "<td style=\"border: 1px solid silver\">";
					
					$imageFileType = strtolower(pathinfo($Entry,PATHINFO_EXTENSION));
					if (($imageFileType == "jpg") || ($imageFileType == "gif") || ($imageFileType == "png") || ($imageFileType == "bmp"))
					{
						echo "<div style=\"background-image:url(../Media/".$PageName."/".$Entry . ");background-repeat:no-repeat; background-size:contain;width:100px;height:80px\"></div>";
					}
					
					if (($imageFileType == "pdf"))
					{
						echo "<div style=\"background-image:url(../Lib/images/pdf.jpg);background-repeat:no-repeat; background-size:contain;width:100px;height:80px\"></div>";
					}
					
					
					if (($imageFileType == "zip")|| ($imageFileType == "rar")|| ($imageFileType == "7z"))
					{
						echo "<div style=\"background-image:url(../Lib/images/zip.jpg);background-repeat:no-repeat; background-size:contain;width:100px;height:80px\"></div>";
					}
					
					
					echo "<div>" . $Entry . "</div><br/>";
					echo "<div style=\"text-align:center;vertical-align:top\"><input class=\"ws_button\" type=\"submit\" name=\"btn_".$PageName."_" . str_replace(".","_",$Entry) . "\" value=\"X\" title=\"Delete\"></div>";
					echo "</td><td>&nbsp;&nbsp;&nbsp;</td>";
				}
			?>
			</tr></table>
		</div>
		<br />
		<table style="margin: auto">
			<tr>
				<td colspan="2">
					<input class="ws_text ws_text_big" name="MediaP" type="file"><input class="ws_button" name="LoadFileToPage" type="submit" value="Load">
				</td>
			</tr>
			<tr>
				<td>
					<br/><input class="ws_button" name="Cancel" type="submit" value="<?php $WS->Translate("Back"); ?>">
				</td>	  
			</tr>
			<tr>
				<td colspan="2">
					<br/>
					<?php echo $Message ?>
				</td>
			</tr>
		</table>
		<br/>
	</div>
<br/><br/><br/><br/><br/><br/><br/><br/><br/><br/>
<?php
$WSDB->Disconnect();
?>