<style>
.HEDV_box
{
	display:inline-block;
	border: solid 1px silver;
	overflow:scroll;
	border-radius: 3px;
	padding:3px;
}

.HEDV_box:focus
{
	border: solid 2px black;
}

.HEDV_hidden 
{
	display:none;
}
</style>
<?php

class TableDetailViwer
{
	public $UpdateButtonText="Update";
	public $InsertButtonText="Insert";
	public $CancelButtonText="Cancel";
	public $FieldPKeys=array();
	public $ColsVisibility=array();
	public $FieldsInfos = array();
	public $FieldsUpdatedValues = array();
	public $FieldsValues = array();
	public $FieldsType = array();			// String,Number,Date,DateTime,Image,Video, Audio, File, Note, LookUp, Html
	public $FileUploadForder = ".";
	public $FieldsDefault = array();
	public $FieldsLookUp = array();
	public $FieldsReadOnly = array();
	public $Message="";
	public $CssClassTable="";
	public $CssClassFieldName="";
	public $CssClassButton="";
	public $Updated=false;
	public $Inserted=false;
	public $Canceled=false;
	
	private static $TableListViewerCount=0;
	private $TLVCount;
	private $DB;
	private $Sql="";
	private $IsEmpty;
	private $Type_Str = array(252,253,254);
	private $Type_Num = array(1,2,3,4,5,8,9,16,246);
	private $Type_DateTime = array(12);
	private $Type_Date = array(10);

	
	public function __construct($DB,$Sql)
	{
		// GET COULUMS
		$this->TLVCount = self::$TableListViewerCount++;
		$this->DB = $DB;
		$this->Sql = $Sql;
		
		$result = $DB->Query($Sql);
		if (!$result)
		{
			echo("SQL ERROR: ".$DB->error."<br/>");
		}
		else
		{
			// GET INFO
			$K=0;
			for ($N=0;$N<$result->field_count;$N++) 
			{
				$Info = $result->fetch_field_direct($N);
				if (($Info->charsetnr == 33)&&(in_array($Info->type,$this->Type_Str))) 
					{$Info->length /= 3;}
				if (($Info->flags & 2) == 2) 
				{
					$this->FieldPKeys[$K]=$Info->orgname;
					$K++;
				}
				if ($Info->orgname!="")
					{$this->FieldsInfos[$Info->orgname]=$Info;}
				else
					{$this->FieldsInfos[$Info->name]=$Info;}
			}
			
			// GET VALUES
			if ($result->num_rows == 1)
			{
				$IsEmpty=false;
				$Row = $result->fetch_assoc();
				foreach ($this->FieldsInfos as $Info)
					{
						$this->FieldsValues[$Info->orgname] = trim($Row[$Info->name]);
					}
			}
			else
			{
				$IsEmpty=true;
				foreach ($this->FieldsInfos as $Info)
				{
					$this->FieldsValues[$Info->orgname] = "";
				}
			}
		}
		
		// MANAGE POSTBACK
		if (isset($_POST["TVD".$this->TLVCount."_Update"]))
		{
			if (isset($_POST["FieldsType".$this->TLVCount])) {$this->FieldsType = explode(',',$_POST["FieldsType".$this->TLVCount]);}
			if (isset($_POST["FieldsDefault".$this->TLVCount])) {$this->FieldsDefault = explode(',',$_POST["FieldsDefault".$this->TLVCount]);}
			if (isset($_POST["FileUploadForder".$this->TLVCount])) {$this->FileUploadForder = $_POST["FileUploadForder".$this->TLVCount];}
			
			$S = "select * from ".$this->FieldsInfos[$this->FieldPKeys[0]]->table." where ";
			$W = "";
			foreach ($this->FieldPKeys as $PKey)
			{
				$ID = "TD".$this->TLVCount."_".$Info->orgname;
				if ($W!=""){$W.=" and ";}
				
				$Val = $this->FieldsValues[$PKey];
				
				if (in_array($this->FieldsInfos[$PKey]->type,$this->Type_Str))
				{
					{$W .= $PKey."='".str_replace("'", "''", $Val)."'";}
				}
				
				if (in_array($this->FieldsInfos[$PKey]->type,$this->Type_Num))
				{
					if (is_numeric($Val)) {$W .= $PKey."=".$Val;}
				}
				if (in_array($this->FieldsInfos[$PKey]->type,$this->Type_DateTime))
				{
					$W .= $PKey."='".$Val."'";
				}
				
				if (in_array($this->FieldsInfos[$PKey]->type,$this->Type_Date))
				{
					$W .= $PKey."='".$Val."'";
				}
			}
			$S.=$W;
			$result = $DB->Query($S);
			if(($result===false)||($result->num_rows == 0))
			{
				// INSERT
				$this->Inserted=true;
				$F="";
				$S = "insert into ".$this->FieldsInfos[$this->FieldPKeys[0]]->orgtable." (";
				foreach ($this->FieldsInfos as $Info)
	 			{
					if (($Info->flags & 512) != 512)
					{
						if($F!=""){$F.=",";}
						$F.=$Info->orgname;
					}
				}
				$S .= $F.") values (";
				
				$F="";
				$Pos = 0;
				foreach ($this->FieldsInfos as $Info)
				{
					$ID = "TD".$this->TLVCount."_".$Info->orgname;
					
					if (($Info->flags & 512) != 512)
					{
						if ($F!=""){$F.=",";}

						if (isset($this->FieldsDefault[$Pos])) {$Val=$this->FieldsDefault[$Pos];}
						if (isset($_POST[$ID])){$Val=$_POST[$ID];}
						
						if (!isset($this->FieldsType[$Pos]))
						{
							$this->FieldsType[$Pos] = "String";
							if (in_array($Info->type,$this->Type_Str)) {$this->FieldsType[$Pos] = "String";}
 							if (in_array($Info->type,$this->Type_Str) && $Info->length>100) {$this->FieldsType[$Pos] = "Note";}
							if (in_array($Info->type,$this->Type_Num)) {$this->FieldsType[$Pos] = "Number";}
							if (in_array($Info->type,$this->Type_Date)) {$this->FieldsType[$Pos] = "Date";}
							if (in_array($Info->type,$this->Type_DateTime)) {$this->FieldsType[$Pos] = "DateTime";}
						}
						
						if ($this->FieldsType[$Pos] == "String")
							{$F .= "'".str_replace("'", "''", $Val)."'";}

						if ($this->FieldsType[$Pos] == "Note")
							{$F .= "'".str_replace("'", "''", $Val)."'";}
							
						if ($this->FieldsType[$Pos] == "Html")
							{$F .= "'".str_replace("'", "''", $Val)."'";}
							
						if ($this->FieldsType[$Pos] == "LookUp")
						{
							if (in_array($Info->type,$this->Type_Num))
								{$F .= 0+floatval($Val);}
							else
								{$F .= "'".str_replace("'", "''", $Val)."'";}
						}
						if (($this->FieldsType[$Pos] == "Image") || 
							($this->FieldsType[$Pos] == "Video") || 
							($this->FieldsType[$Pos] == "Audio") || 
							($this->FieldsType[$Pos] == "File"))
						{
							$Val = date("YmdHis")."_".$Val;
							$F .= "'".str_replace("'", "''", $Val)."'";
							$fileTmpName = $_FILES[$ID]['tmp_name'];
							$fileName = $_FILES[$ID]['name'];
							$DestDir = $this->FileUploadForder ."/".$Val;
							if (!is_dir($DestDir)){mkdir($DestDir);}
							$DestFile = $this->FieldsValues[$ID]."_".basename($fileName);
							$ValOld= $_POST[$ID."_OLD"];
							if ($ValOld!="") {unlink($this->FileUploadForder ."/". $ValOld);}
							move_uploaded_file($fileTmpName, $DestDir."/".$DestFile);
						}
							
						if ($this->FieldsType[$Pos] == "Number")
						{
							if (is_numeric($Val)) 
								{$F .= $Val;}
							else
								{$F .= "null";}
						}

						if ($this->FieldsType[$Pos] == "DateTime")
						{
							if ($Val != "")
							{
								$DT = DateTime::createFromFormat('d/m/Y',$Val);
								if (!$DT) {$DT = DateTime::createFromFormat('d/m/Y H:i:s',$Val);}
								if (!$DT) {$DT = DateTime::createFromFormat('Y-m-d',$Val);}
								if (!$DT) {$DT = DateTime::createFromFormat('Y-m-d H:i:s',$Val);}
								if ($DT !== False)
									{$F .= "'".$DT->format("Y-m-d H:i:s")."'";}
							}
							else
								{$F .= "null";}
						}

						if ($this->FieldsType[$Pos] == "Date")
						{
							if ($Val != "")
							{
								$DT = DateTime::createFromFormat('d/m/Y',$Val);
								$DT = DateTime::createFromFormat('Y-m-d',$Val);
								if ($DT !== False)
									{$F .= "'".$DT->format("Y-m-d")."'";}
							}
							else
								{$F .= "null";}
						}
						
						$this->FieldsUpdatedValues[$Info->orgname] = $Val;
					}
					$Pos++;
				}
				$S .= $F.")";
			}
			else
			{
				// UPDATE
				$Updated=true;
				$this->Updated = true;
				$S = "update ".$this->FieldsInfos[$this->FieldPKeys[0]]->orgtable." set ";
				$F="";
				$Pos=0;
				foreach ($this->FieldsInfos as $Info)
				{
					$ID = "TD".$this->TLVCount."_".$Info->orgname;
					if (($Info->flags & 512) != 512)
					{
						if (isset($_POST[$ID]) || isset($_FILES[$ID]))
						{
							if ($F!=""){$F.=",";}
							$F .= $Info->orgname."=";
							if (isset($_POST[$ID])) {$Val= $_POST[$ID];}
								
							if (!isset($this->FieldsType[$Pos]))
							{
								$this->FieldsType[$Pos] = "String";
								if (in_array($Info->type,$this->Type_Str)) {$this->FieldsType[$Pos] = "String";}
								if (in_array($Info->type,$this->Type_Str) && $Len>100) {$this->FieldsType[$Pos] = "Note";}
								if (in_array($Info->type,$this->Type_Num)) {$this->FieldsType[$Pos] = "Number";}
								if (in_array($Info->type,$this->Type_Date)) {$this->FieldsType[$Pos] = "Date";}
								if (in_array($Info->type,$this->Type_DateTime)) {$this->FieldsType[$Pos] = "DateTime";}
							}
							
							
							if ($this->FieldsType[$Pos] == "String")
							{
								$F .= "'".str_replace("'", "''", $Val)."'";
							}
							
							if ($this->FieldsType[$Pos] == "Note")
							{
								$F .= "'".str_replace("'", "''", $Val)."'";
							}
							
							if ($this->FieldsType[$Pos] == "Html")
							{
								$F .= "'".str_replace("'", "''", $Val)."'";
							}
							
							if ($this->FieldsType[$Pos] == "LookUp")
							{
								if (in_array($Info->type,$this->Type_Num))
									{$F .= 0+floatval(str_replace("'", "''", $Val));}
								else
									{$F .= "'".str_replace("'", "''", $Val)."'";}
							}
							
							if (($this->FieldsType[$Pos] == "Image") || 
								($this->FieldsType[$Pos] == "Video") || 
								($this->FieldsType[$Pos] == "Audio") || 
								($this->FieldsType[$Pos] == "File"))
							{
								$ValOld= $_POST[$ID."_OLD"];
								
								if ((isset($_POST[$ID."_CLR"])) && ($_POST[$ID."_CLR"]=="Clear"))
								{
									if (file_exists($this->FileUploadForder ."/". $ValOld)) {unlink($this->FileUploadForder ."/". $ValOld);}
									$F .= "''";
								}
								else
								{
									if ($_FILES[$ID]['name'] != "")
									{
										$fileTmpName = $_FILES[$ID]['tmp_name'];
										$fileName = $_FILES[$ID]['name'];
										$DestDir = $this->FileUploadForder;
										if (!is_dir($DestDir)){mkdir($DestDir);}
										$DestFile = date("YmdHis")."_".basename($fileName);

										if ($ValOld!="") 
										{
											if (file_exists($this->FileUploadForder ."/". $ValOld))
											{
												unlink($this->FileUploadForder ."/". $ValOld);
											}
										}
										move_uploaded_file($fileTmpName, $DestDir."/".$DestFile);
										$F .= "'".str_replace("'", "''", $DestFile)."'";
									}
									else
									{
										$F .= "'".str_replace("'", "''", $ValOld)."'";
									}
								}
							}
							
							if ($this->FieldsType[$Pos] == "Number")
							{
								if (is_numeric($Val)) 
									{$F .= $Val;}
								else
									{$F .= "null";}	
							}

							if ($this->FieldsType[$Pos] == "DateTime")
							{
								if ($Val != "")
								{
									$DT = DateTime::createFromFormat('Y-m-d H:i:s',$Val);
									$F .= "'".$DT->format("Y-m-d H:i:s")."'";
								}
								else
									{$F .= "null";}
							}

							if ($this->FieldsType[$Pos] == "Date")
							{
								if ($Val != "")
								{
									$DT = DateTime::createFromFormat('Y-m-d',$Val);
									$F .= "'".$DT->format("Y-m-d")."'";
								}
								else
									{$F .= "null";}
							}

							$this->FieldsUpdatedValues[$Info->orgname] = $Val;
						}
					}
					$Pos++;
				}
				$S.=$F." where ".$W;
			}
			
			if(!$DB->query($S))
			{
				$this->Message="UPDATE ERROR: ".$DB->error;
				$this->Inserted = false;
				$Updated=false;
			}
			else
			{
				if ($this->Inserted)
				{
					foreach ($this->FieldsInfos as $Info)
					{
						if (($Info->flags & 512) == 512)
						{
							$this->FieldsUpdatedValues[$Info->orgname]= $DB->insert_id;
						}
					}
				}
				$this->Message = "Updteted";
			}
		}
		
		// POSTBACK
		if (isset($_POST["TVD".$this->TLVCount."_Cancel"]))
		{
			$this->Canceled=true;
			$this->Message = "Canceled";
		}
	}
	
	public function Draw()
	{
		
		if (count($this->FieldsInfos)==0)
		{
			echo "Void Select Can't Draw the TableView.<br/>";
			return;
		}
		
		echo "<table class=\"".$this->CssClassTable."\">";
		$N=0;
		$HiddenField = "";
		foreach ($this->FieldsInfos as $Info)
		{
			$Val=$this->FieldsValues[$Info->orgname];
 			$Len = $Info->length;

			if (!isset($this->FieldsType[$N]))
			{
				$this->FieldsType[$N] = "String";
				if (in_array($Info->type,$this->Type_Str)) {$this->FieldsType[$N] = "String";}
				if (in_array($Info->type,$this->Type_Str) && $Len>100) {$this->FieldsType[$N] = "Note";}
				if (in_array($Info->type,$this->Type_Num)) {$this->FieldsType[$N] = "Number";}
				if (in_array($Info->type,$this->Type_Date)) {$this->FieldsType[$N] = "Date";}
				if (in_array($Info->type,$this->Type_DateTime)) {$this->FieldsType[$N] = "DateTime";}
			}

			if ($this->FieldsType[$N] == "Date"){$Len=10;}
				
			if ($this->FieldsType[$N] == "DateTime"){$Len=19;}
			
			if ((!isset($this->ColsVisibility[$N])) || ($this->ColsVisibility[$N]))
			{
				$RO = "";
				if ((isset($this->FieldsReadOnly[$N])) && ($this->FieldsReadOnly[$N])) {$RO = "readonly";}
				
				echo "<tr><td class=\"".$this->CssClassFieldName."\" style=\"text-align:right\">".$Info->name."</td>";
				echo "<td>";
				
				$ID= "TD".$this->TLVCount."_".$Info->orgname;
				if (isset($this->FieldsLookUp))
				{
					if  (isset($this->FieldsLookUp[$N])) 
					{
						if ($this->FieldsLookUp[$N] != "")
						{
							$this->FieldsType[$N] = "LookUp";
						}
					}
				}

				if ($this->FieldsType[$N] == "Date")
				{
					//InputDate::Draw("TD".$this->TLVCount."_".$Info->orgname,$Val);
					echo "<input ".$RO." name=\"".$ID."\" style=\"margin-top:2px;width:190px;\" TYPE=\"date\" value=\"".$Val ."\" maxlength=\"10\">";
				}

				if ($this->FieldsType[$N] == "DateTime")
				{
					$Val = Explode(' ',$Val);
					$NameD = $ID."_D";
					$NameT = $ID."_T";
					$OnChange = "document.getElementById('".$ID."').value=document.getElementById('".$NameD."').value + ' ' + document.getElementById('".$NameT."').value;";
					echo "<input ".$RO." id=\"".$NameD."\" style=\"margin-top:2px;width:190px;\" TYPE=\"date\" value=\"".$Val[0]."\" maxlength=\"10\" onchange=\"".$OnChange."\" >";
					echo "<input ".$RO." id=\"".$NameT."\" style=\"margin-top:2px;width:190px;\" TYPE=\"time\" value=\"".$Val[1] ."\" maxlength=\"8\" onchange=\"".$OnChange."\">";
					echo "<input ".$RO." id=\"".$ID."\" name=\"".$ID."\" style=\"margin-top:2px;width:190px;\" TYPE=\"hidden\" value=\"".$Val[0]." ".$Val[1] ."\" maxlength=\"8\">";
				}


				if ($this->FieldsType[$N] == "Number")
				{
					echo "<input ".$RO." name=\"".$ID."\" style=\"margin-top:2px;width:190px;\" TYPE=\"text\" value=\"".$Val ."\" size=\"10\" maxlength=\"10\" onkeyup=\"if(event.key!=','){ this.value=parseFloat(this.value);}\">";
				}

				if ($this->FieldsType[$N] == "Note")
				{
					echo "<textarea ".$RO." cols=\"50\" rows=\"4\" type=\"text\" name=\"".$ID."\">".$Val."</textarea>";
				}

				if ($this->FieldsType[$N] == "String")
				{
					echo "<input type=\"text\" name=\"".$ID."\" maxlength=\"".$Len."\" size=\"".$Len."\"  value=\"".$Val."\">";
				}
					
				if ($this->FieldsType[$N] == "Image")
				{
					echo "<table border=1>";
					echo "<tr><td>";
						echo "<input type=\"file\" name=\"".$ID."\" maxlength=\"".$Len."\" size=\"".$Len."\"  value=\"".$Val."\">";
						echo "<input type=\"hidden\" name=\"".$ID."_OLD\" value=\"".$Val."\">";
					echo "</td><td style=\"white-space: nowrap;\">";
						echo "Clear <input type=\"checkbox\" name=\"".$ID."_CLR\" value=\"Clear\">";
					echo "</td><td>";
						echo "<image height=\"280px\" src=\"".$this->FileUploadForder."/".$this->FieldsValues["Immagine"]."\" />";
					echo "</td>";
					echo "</tr>";
					echo "</table>";
				}
				
				if ($this->FieldsType[$N] == "Video")
				{
					echo "<table border=1>";
					echo "<tr><td>";
						echo "<input type=\"file\" name=\"".$ID."\" maxlength=\"".$Len."\" size=\"".$Len."\"  value=\"".$Val."\">";
						echo "<input type=\"hidden\" name=\"".$ID."_OLD\" value=\"".$Val."\">";
					echo "</td><td style=\"white-space: nowrap;\">";
						echo "Clear <input type=\"checkbox\" name=\"".$ID."_CLR\" value=\"Clear\">";
					echo "</td><td>";
						echo "<video id=\"Video\" height=\"300px\" controls preload autoplay >";
							echo "<source src=\"".$this->FileUploadForder."/".$this->FieldsValues["Video"]."\" type=\"video/mp4\">";
						echo "</video>";
					echo "</td>";
					echo "</tr>";
					echo "</table>";
				}
			
				if ($this->FieldsType[$N] == "Audio")
				{
					echo "<table border=1>";
					echo "<tr><td>";
						echo "<input type=\"file\" name=\"".$ID."\" maxlength=\"".$Len."\" size=\"".$Len."\"  value=\"".$Val."\">";
						echo "<input type=\"hidden\" name=\"".$ID."_OLD\" value=\"".$Val."\">";
					echo "</td><td style=\"white-space: nowrap;\">";
						echo "Clear <input type=\"checkbox\" name=\"".$ID."_CLR\" value=\"Clear\">";
					echo "</td><td>";
						echo "<Audio id=\"Audio\" controls preload autoplay controlsList=\"nodownload\">";
							echo "<source src=\"".$this->FileUploadForder."/".$this->FieldsValues["Audio"]."\">";
						echo "</Audio>";
					echo "</td>";
					echo "</tr>";
					echo "</table>";
				}

				if ($this->FieldsType[$N] == "File")
				{
					echo "<table border=1>";
					echo "<tr><td>";
						echo "<input type=\"file\" name=\"".$ID."\" maxlength=\"".$Len."\" size=\"".$Len."\"  value=\"".$Val."\">";
						echo "<input type=\"hidden\" name=\"".$ID."_OLD\" value=\"".$Val."\">";
					echo "</td><td style=\"white-space: nowrap;\">";
						echo "Clear <input type=\"checkbox\" name=\"".$ID."_CLR\" value=\"Clear\">";
					echo "</td><td>";
					echo "<a href=\"".$this->FileUploadForder."/".$this->FieldsValues["File"]."\">".$this->FieldsValues["File"]."</a>";
					echo "</td>";
					echo "</tr>";
					echo "</table>";
				}
				
				if ($this->FieldsType[$N] == "Html")
				{
					$TxtName = $ID."_Txt";
					$HtmlName = $ID."_Html";
					$InpName = $ID;
					$BtnName = $ID."_Btn";
					$BgColName = $ID."_BgCol";
					$FgColName = $ID."_FgCol";
					
					$Ret  = "<button type=\"button\" title=\"Bold\" onmouseup=\"HEDV_Command('bold');HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/><b>B</b></button>";
					$Ret .= "<button type=\"button\" title=\"Italic\" onmouseup=\"HEDV_Command('italic');HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/><i>I</i></button>";
					$Ret .= "<button type=\"button\" title=\"Underline\" onmouseup=\"HEDV_Command('underline');HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/><u>U</u></button>";
					$Ret .= "<button type=\"button\" title=\"Tab\" onmouseup=\"HEDV_Command('indent');HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/>Tab</button>";
					$Ret .= "<button type=\"button\" title=\"justify Left\" onmouseup=\"HEDV_Command('justifyLeft');HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/>=&nbsp;&nbsp;</button>";
					$Ret .= "<button type=\"button\" title=\"justify center\" onmouseup=\"HEDV_Command('justifyCenter');HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/>&nbsp;=&nbsp;</button>";
					$Ret .= "<button type=\"button\" title=\"justify right\" onmouseup=\"HEDV_Command('justifyRight');HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/>&nbsp;&nbsp;=</button>";
					$Ret .= "<button type=\"button\" title=\"Sup text\" onmouseup=\"HEDV_Command('superscript',);HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/><small>Tx<sup>s</sup></small></button>";
					$Ret .= "<button type=\"button\" title=\"Sub text\" onmouseup=\"HEDV_Command('subscript',);HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/><small>Tx<sub>s</sub></small></button>";
					$Ret .= "<button type=\"button\" title=\"Dotted list\" onmouseup=\"HEDV_Command('insertUnorderedList',);HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/>:=</button>";
					$Ret .= "<button type=\"button\" title=\"Link\" onmouseup=\"var Link=prompt('link:', '');HEDV_Command('createLink',true,Link);HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/>&rarr;</button>";

					$Ret .= "<select id=\"".$BgColName."\" onchange=\"HEDV_Command('backColor',true,this.value);this.selectedIndex=0;HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\">";
					$Ret .= "	<option value=\"\">bg col</option>";
					$Ret .= "</select>";
					$Ret .= "<select id=\"".$FgColName."\" onChange=\"HEDV_Command('foreColor',true,this.value);this.selectedIndex=0;this.style.color=this.value;HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\">";
					$Ret .= "	<option value=\"\">fg col</option>";
					$Ret .= "</select>";
					$Ret .= "<select  onChange=\"HEDV_Command('fontsize',true,this.value);this.selectedIndex=0;HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\">";
					$Ret .= "	<option value=\"1\">50%</option>";
					$Ret .= "	<option value=\"2\">75%</option>";
					$Ret .= "	<option selected value=\"3\">Normal</option>";
					$Ret .= "	<option value=\"4\">125%</option>";
					$Ret .= "	<option value=\"5\">150%</option>";
					$Ret .= "	<option value=\"6\">200%</option>";
					$Ret .= "	<option value=\"7\">250%</option>";
					$Ret .= "</select>";
					$Ret .= "<button type=\"button\" title=\"remove format\" onmouseup=\"HEDV_Command('(removeFormat)',);HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"/>Clr</button>";
					$Ret .= "<button type=\"button\" id=\"".$BtnName."\" title=\"View code\" onmouseup=\"HEDV_ViewCode('".$TxtName."','".$HtmlName."','".$BtnName."');\" >Code</button>";
					$Ret .= "<br/>";
					$Width = "99%";
					$Height= "200px";
					$Ret .= "<div id=\"".$TxtName."\" name=\"".$TxtName."\" contenteditable=\"true\" style=\"width:".$Width.";height:".$Height."\" class=\"HEDV_box\" onkeyup=\"HEDV_Refresh('".$TxtName."','".$HtmlName."','".$InpName."');\"></div>";
					$Ret .= "<xmp id=\"".$HtmlName."\" name=\"".$HtmlName."\" style=\"width:".$Width.";height:".$Height."\" class=\"HEDV_box HEDV_hidden\" contenteditable=\"true\" onkeyup=\"HEDV_RefreshView('".$TxtName."','".$HtmlName."','".$InpName."');\">".$Val."</xmp>";
					$Ret .= "<input id=\"".$InpName."\" name=\"".$InpName."\" type=\"hidden\");\">";

					$Ret .= "<script type=\"text/javascript\">HEDV_SetColor('".$BgColName."','".$FgColName."');HEDV_RefreshView('".$TxtName."','".$HtmlName."','".$InpName."');</script>";
					
					echo $Ret;
				}
				
				if ($this->FieldsType[$N] == "LookUp")
				{
					// LOOKUP
					if (isset($this->FieldsDefault[$N]))
						{$Val= $this->FieldsDefault[$N];}

					$result = $this->DB->Query($this->FieldsLookUp[$N]);
					if ($result !== false)
					{
						$Info0 = $result->fetch_field_direct(0);
						$Info1 = $result->fetch_field_direct(1);
						echo "<select class=\"ws_text\" " .$RO." name=\"".$ID."\">";
						echo "<option value=\"\"></option>";
						for ($R=0;$R<$result->num_rows;$R++)
						{
							$Row = $result->fetch_assoc();
							echo "<option value=\"" . $Row[$Info0->orgname] . "\">" . $Row[$Info1->orgname] . "</option>";
						}
						echo "</select>";
					}
					else
					{
						echo "FieldsLookUp Error !!";
					}
				}
				echo "</td></tr>";
			}
			$N++;
		}
		
		if ($this->IsEmpty)
			{echo "<tr><td></td><td><br/><input class=\"".$this->CssClassButton."\" type=\"submit\" name=\"TVD".$this->TLVCount."_Update\" value=\"".$this->InsertButtonText."\">";}
		else
			{echo "<tr><td></td><td><br/><input class=\"".$this->CssClassButton."\" type=\"submit\" name=\"TVD".$this->TLVCount."_Update\" value=\"".$this->UpdateButtonText."\">";}
			
		echo "&nbsp;<input class=\"".$this->CssClassButton."\" type=\"submit\" name=\"TVD".$this->TLVCount."_Cancel\" value=\"".$this->CancelButtonText."\"></td></tr>";
		
		if ($this->Message!="")
		{
			echo "<tr><td colspan=\"2\">".$this->Message."</td></tr>";
		}
		echo "</table>";
		$HiddenField .= "<input type=\"hidden\" name=\"FieldsDefault".$this->TLVCount."\" value=\"".implode(',',$this->FieldsDefault)."\" >";
		$HiddenField .= "<input type=\"hidden\" name=\"FieldsType".$this->TLVCount."\" value=\"".implode(',',$this->FieldsType)."\" >";
		$HiddenField .= "<input type=\"hidden\" name=\"FileUploadForder".$this->TLVCount."\" value=\"".$this->FileUploadForder."\" >";
		echo $HiddenField;
	}
}
?>

<script type="application/javascript">	

function HEDV_Command(Cmd,P1=null,P2=null,P3=null)
{
	document.execCommand(Cmd,P1,P2,P3);
}

function HEDV_Refresh(TxtName,HtmlName,Name)
{
	var Txt = document.getElementById(TxtName);
	var Html = document.getElementById(HtmlName);
	var TxtInp = document.getElementById(Name);
	Html.innerHTML = Txt.innerHTML.replaceAll("><",">\n<").replaceAll("<br>","<br>\n");
	TxtInp.value = Html.innerHTML;
	
}

function HEDV_RefreshView(TxtName,HtmlName,Name)
{
	var Txt = document.getElementById(TxtName);
	var Html = document.getElementById(HtmlName);
	var TxtInp = document.getElementById(Name);
	Txt.innerHTML = Html.innerHTML;
	TxtInp.value = Html.innerHTML;
}

function HEDV_ViewCode(TxtName,HtmlName,BtnName)
{
	var Btn = document.getElementById(BtnName);
	var Txt = document.getElementById(TxtName);
	var Html = document.getElementById(HtmlName);
	if (Btn.innerText == 'Code')
	{
		Btn.innerText = 'Text'; 
		Html.style.display='block';
		Txt.style.display='none';
	}
	else
	{
		Btn.innerText = 'Code';
		Html.style.display='none';
		Txt.style.display='block';
	}
}

function HEDV_SetColor(BgColName,FgColName)
{
	var r;
	var g;
	var b;
	var bg_col = document.getElementById(BgColName);
	var fg_col = document.getElementById(FgColName);
	for(b=0;b<=256;b+=64)
		for(g=0;g<=256;g+=64)
			for(r=0;r<=256;r+=64)
			{
				var RevCol = (r + g + b)/3;
				if (RevCol>150) 
					RevCol = "eeeeee";
				else
					RevCol = "ffffff";
				
				if (r > 255) r = 255;
				if (g > 255) g = 255;
				if (b > 255) b = 255;
				var rh = r.toString(16).toUpperCase(); 
				var gh = g.toString(16).toUpperCase(); 
				var bh = b.toString(16).toUpperCase(); 
				if (rh.length < 2) rh = rh + "0";
				if (gh.length < 2) gh = gh + "0";
				if (bh.length < 2) bh = bh + "0";

				var Col = rh + gh + bh ;
				
				var St;
				St = "<option style=\"color:#" + RevCol + ";background-color:#" + Col + "\">" + Col + "</option>";
				bg_col.innerHTML += St;
				St = "<option style=\"font-weight:bold;color:#" + Col + ";background-color:#" + RevCol + "\">" + Col + "</option>";
				fg_col.innerHTML += St;
			}
}
</script>
