
function TranslateImage(Type, NumObjID, ImgArr, ObjID, ObjBackID, Mode)
{
    var Obj = document.getElementById(ObjID);
    var ObjBack = document.getElementById(ObjBackID);
    var NumObj = document.getElementById(NumObjID);
    var Num = Number(NumObj.value);
	
	if (Type=="IMG") 
		Obj.src = ImgArr[Num];
		
	if (Type=="TXT") 
		Obj.innerHTML = ImgArr[Num];
	
	Obj.style.position = "relative";
	ObjBack.style.position = "relative";
	Obj.style.top = (Obj.offsetHeight * (-1)) + "px";
	
    if (Mode == "SHADE")
        ShadeStart(Type,NumObjID, ImgArr, Obj, ObjBack);
	
    if (Mode == "SCROLL_LEFT")
		setTimeout(function () { ScrollLeftStart(Type,NumObjID, ImgArr, Obj, ObjBack); }, 5000);
	
	if (Mode == "SCROLL_RIGHT")
		setTimeout(function () { ScrollRightStart(Type,NumObjID, ImgArr, Obj, ObjBack); }, 5000);
	
	if (Mode == "SCROLL_DOWN")
		setTimeout(function () { ScrollDownStart(Type,NumObjID, ImgArr, Obj, ObjBack); }, 5000);
	
	if (Mode == "SCROLL_UP")
		setTimeout(function () { ScrollUpStart(Type,NumObjID, ImgArr, Obj, ObjBack); }, 5000);
	
    if (Mode == "EXCHANGE")
		setTimeout(function () { ChangeStart(Type,NumObjID, ImgArr, Obj); }, 5000);
		
	if (Mode == "RING")
		RingStart(Type,NumObjID, ImgArr, Obj, ObjBack);
}

function ChangeStart(Type,NumObjID,ImgArr,Obj)
{
	var NumObj = document.getElementById(NumObjID);
	var Num = Number(NumObj.value);
	if (Type=="IMG") Obj.style.backgroundImage = ImgArr[Num];
	if (Type=="TXT") Obj.innerHTML = ImgArr[Num];
	setTimeout(function () { ChangeStart(Type,NumObjID, ImgArr, ObjID); }, 5000);
	Num++;
	if (Num == ImgArr.length) Num = 0;
	NumObj.value = Num;
}

function ShadeStart(Type,NumObjID,ImgArr,Obj,ObjBack)
{
	var NumObj = document.getElementById(NumObjID);
	var Num = Number(NumObj.value);
	ObjBack.style.zIndex = 0;
	Obj.style.zIndex = 1;
	
	if (Type=="IMG") ObjBack.style.backgroundImage = "url("+ImgArr[Num]+")";
	if (Type=="TXT") ObjBack.innerHTML = ImgArr[Num];
	Obj.className = "ws_imgSlideOut ws_imgToDiv";
	ObjBack.className = "ws_imgSlideIn ws_imgToDiv";
	setTimeout(function () { ShadeStart(Type,NumObjID, ImgArr, ObjBack, Obj); }, 5000);
	setTimeout(function () { ShadeEnd(Type,Num, Obj,ImgArr); }, 2000);
    Num++;
    if (Num == ImgArr.length) Num = 0;
	NumObj.value = Num;
}

function RingStart(Type,NumObjID,ImgArr,Obj,ObjBack)
{
    var NumObj = document.getElementById(NumObjID);
    var Num = Number(NumObj.value);
	var NumOld = Num;
	ObjBack.style.zIndex = 0;
	Obj.style.zIndex = 1;
	
	var L = 0;
	var T = Obj.clientHeight*(-1);
	var W = Obj.clientWidth;
	var H = Obj.clientHeight;
    var LL = Obj.clientHeight/2;
	Obj.style.borderRadius = "0px";
    Inc = (LL/30);
	
	Num++;
    if (Num == ImgArr.length) Num = 0;
	NumObj.value = Num;

	if (Type=="IMG") ObjBack.style.backgroundImage = "url("+ImgArr[Num]+")";
	if (Type=="TXT") ObjBack.innerHTML = ImgArr[Num];	
	
    setTimeout(function () { CloseRadius(Obj,Inc,L,T,W,H,0); }, 30);
    setTimeout(function () { RingStart(Type,NumObjID, ImgArr, Obj, ObjBack); }, 5000);
	setTimeout(function () { RingEnd(Type,Num,Obj,ObjBack,ImgArr,W,H); },1000);
}

function ShadeEnd(Type,Num, Obj,ImgArr)
{
	if (Type=="IMG") Obj.style.backgroundImage = "url("+ImgArr[Num]+")";
	if (Type=="TXT") Obj.innerHTML = ImgArr[Num];
}

function RingEnd (Type,Num,Obj,ObjBack,ImgArr,W,H)
{
	if (Type=="IMG") Obj.style.backgroundImage = ObjBack.style.backgroundImage;
	if (Type=="TXT") Obj.innerHTML = ImgArr[Num];
    Obj.style.left = "0px";
	Obj.style.top = H*(-1) + "px";
	Obj.style.width = "100%";
	Obj.style.height =  "100%";

}

function ScrollLeftStart(Type,NumObjID,ImgArr,Obj,ObjBack)
{
    var NumObj = document.getElementById(NumObjID);
    var Num = Number(NumObj.value);
    Num++;
    if (Num == ImgArr.length) Num = 0;
    NumObj.value = Num;
    var L = Obj.clientWidth;
    Obj.style.left = "0px";
    ObjBack.style.left = L+"px";
	if (Type=="IMG") ObjBack.src = ImgArr[Num];
	if (Type=="TXT") ObjBack.innerHTML = ImgArr[Num];
    IncX = (L/30*(-1));
    X = 0;
    XB = L;
    setTimeout(function () { ScrollToX(Obj,ObjBack,X,XB,IncX,0); }, 30);
    setTimeout(function () { ScrollLeftStart(Type,NumObjID, ImgArr, ObjBack, Obj); }, 5000);
    setTimeout(function () { MoveObjEnd(Type,Num, Obj,ImgArr); },2000);
}

function ScrollRightStart(Type,NumObjID,ImgArr,Obj,ObjBack)
{
    var NumObj = document.getElementById(NumObjID);
    var Num = Number(NumObj.value);
    Num++;
    if (Num == ImgArr.length) Num = 0;
    NumObj.value = Num;
    var L = Obj.clientWidth;
    Obj.style.left = "0px";
    ObjBack.style.left = (L*(-1)) + "px";
	if (Type=="IMG") ObjBack.src = ImgArr[Num];
	if (Type=="TXT") ObjBack.innerHTML = ImgArr[Num];
    IncX = L/30;
    X = 0;
    XB = (L*(-1));
    setTimeout(function () { ScrollToX(Obj,ObjBack,X,XB,IncX,0); }, 30);
    setTimeout(function () { ScrollRightStart(Type,NumObjID, ImgArr, ObjBack, Obj); }, 5000);
    setTimeout(function () { MoveObjEnd(Type,Num, Obj,ImgArr); },2000);
}

function ScrollDownStart(Type,NumObjID,ImgArr,Obj,ObjBack)
{
    var NumObj = document.getElementById(NumObjID);
    var Num = Number(NumObj.value);
    Num++;
    if (Num == ImgArr.length) Num = 0;
    NumObj.value = Num;
    var L = Obj.clientHeight;
	Obj.style.top = 0;
    ObjBack.style.top = (L*(-1));
	if (Type=="IMG") ObjBack.style.backgroundImage = ImgArr[Num];
	if (Type=="TXT") ObjBack.innerHTML = ImgArr[Num];
    IncY = L/30;
    Y = 0;
    YB = (L*(-1));
	if (Obj.id.indexOf("Back") == -1)
	{
		Obj.style.top = L*(-1) + "px";
		Y = L*(-1);
	}
	else
	{
		ObjBack.style.top = L*2*(-1) + "px";
		YB = L*2*(-1);
	}
    setTimeout(function () { ScrollToY(Obj,ObjBack,Y,YB,IncY,0); }, 30);
    setTimeout(function () { ScrollDownStart(Type,NumObjID, ImgArr, ObjBack, Obj); }, 5000);
    setTimeout(function () { MoveObjEnd(Type,Num, Obj,ImgArr); },2000);
}

function ScrollUpStart(Type,NumObjID,ImgArr,Obj,ObjBack)
{
    var NumObj = document.getElementById(NumObjID);
    var Num = Number(NumObj.value);
    Num++;
    if (Num == ImgArr.length) Num = 0;
    NumObj.value = Num;
    var L = Obj.clientHeight;
	Obj.style.top = "0px";
    ObjBack.style.top = L+"px";
	if (Type=="IMG") ObjBack.style.backgroundImage = ImgArr[Num];
	if (Type=="TXT") ObjBack.innerHTML = ImgArr[Num];
    IncY = (L/30*(-1));
    Y = 0;
    YB = L;
	if (Obj.id.indexOf("Back") == -1)
	{
		Obj.style.top = L*(-1) + "px";
		Y = L*(-1);
	}
	else
	{
		ObjBack.style.top = "0px";
		YB = 0;
	}
    setTimeout(function () { ScrollToY(Obj,ObjBack,Y,YB,IncY,0); }, 30);
    setTimeout(function () { ScrollUpStart(Type,NumObjID, ImgArr, ObjBack, Obj); }, 5000);
    setTimeout(function () { MoveObjEnd(Type,Num, Obj,ImgArr); },2000);
}

function ScrollToX (Obj,ObjBack,X,XB,IncX,C)
{
    X+=IncX;
    Obj.style.left = X+"px";
    XB+=IncX;
    ObjBack.style.left = XB+"px";
    C++;
    if (C<30) setTimeout(function () { ScrollToX(Obj,ObjBack,X,XB,IncX,C); }, 30);
}

function ScrollToY (Obj,ObjBack,Y,YB,IncY,C)
{
    Y+=IncY;
    Obj.style.top = Y+"px";
    YB+=IncY;
    ObjBack.style.top = YB+"px";
    C++;
    if (C<30) setTimeout(function () { ScrollToY(Obj,ObjBack,Y,YB,IncY,C); }, 30);
}

function MoveObjEnd (Type,Num,Obj,ImgArr)
{
	if (Type=="IMG") Obj.src = ImgArr[Num];
	if (Type=="TXT") Obj.innerHTML = ImgArr[Num];
	Obj.style.left="0px";
    Obj.style.top="0px";
	if (Obj.id.indexOf("Back") == -1)
	{
		var L = Obj.offsetHeight;
		Obj.style.top = (L*(-1)) + "px";
	}
    
}

function CloseRadius (Obj,Inc,L,T,W,H,C)
{
	L+=Inc;
	T+=Inc;
	W-=Inc;
	H-=Inc;
	W-=Inc;
	H-=Inc;
	Obj.style.left = L + "px";
	Obj.style.top = T + "px";
	Obj.style.width = W + "px";
	Obj.style.height = H + "px";
    C++;
    if (C<31) 
		setTimeout(function () { CloseRadius(Obj,Inc,L,T,W,H,C); }, 30);
	else
		Obj.style.zIndex = 0;
}

