

function ws_slider_getIndex(IndexID)
{
	return parseInt(document.getElementById('ws_sldInd_'+IndexID).value,10);
}

function ws_slider_setIndex(IndexID,Val)
{
	document.getElementById('ws_sldInd_'+IndexID).value = Val.toString();
}

function ws_slider_setDelay(IndexID,Delay)
{
	ws_slider_plusSlides(IndexID,1);
	setTimeout(function() {ws_slider_setDelay(IndexID,Delay)}, Delay);
}

// Next/previous controls
function ws_slider_plusSlides(IndexID,n)
{
	var slideIndex = ws_slider_getIndex(IndexID);
	slideIndex += n;
	ws_slider_setIndex(IndexID,slideIndex);
	ws_slider_showSlides(IndexID);
}

// Thumbnail image controls
function ws_slider_currentSlide(IndexID,n)
{
	ws_slider_setIndex(IndexID,n);
	ws_slider_showSlides(IndexID);
}

function ws_slider_showSlides(IndexID)
{
	var slideIndex = ws_slider_getIndex(IndexID);
	let i;
	let slides = document.getElementsByClassName("ws_slider_"+IndexID);
	let dots = document.getElementsByClassName("ws_slider_dot_"+IndexID);
	if (slideIndex > slides.length)
	{
		slideIndex = 1;
	}
	if (slideIndex < 1)
	{
		slideIndex = slides.length;
	}
	for (i = 0; i < slides.length; i++)
	{
		slides[i].style.display = "none";
	}
	for (i = 0; i < dots.length; i++)
	{
		dots[i].className = dots[i].className.replace(" ws_slider_active", "");
	}
	slides[slideIndex - 1].style.display = "block";
	dots[slideIndex - 1].className += " ws_slider_active";
	ws_slider_setIndex(IndexID,slideIndex);
} 